/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 30 "parser.yy"


#define yyerror Lily_parser::parser_error

/* We use custom location type: Input objects */
#define YYLTYPE Input
#define YYSTYPE SCM
#define YYLLOC_DEFAULT(Current,Rhs,N) \
	((Current).set_location ((Rhs)[1], (Rhs)[N]))

#define YYPRINT(file, type, value)                                      \
        do {                                                            \
                if (scm_is_eq (value, SCM_UNSPECIFIED))                 \
                        break;                                          \
                char *p = scm_to_locale_string                          \
                        (scm_simple_format (SCM_BOOL_F,                 \
                                            scm_from_locale_string ("~S"), \
                                            scm_list_1 (value)));       \
                fputs (p, file);                                        \
                free (p);                                               \
        } while (0)

/* Line 371 of yacc.c  */
#line 121 "parser.yy"
 // -*-Fundamental-*-

/*
FIXME:

   * The rules for who is protecting what are very shady.  Uniformise
     this.

   * There are too many lexical modes?
*/

#include "config.hh"

#include <cctype>
#include <cstdlib>
#include <cstdio>
using namespace std;

#include "book.hh"
#include "context-def.hh"
#include "context-mod.hh"
#include "dimensions.hh"
#include "file-path.hh"
#include "input.hh"
#include "international.hh"
#include "lily-guile.hh"
#include "lily-lexer.hh"
#include "lily-parser.hh"
#include "main.hh"
#include "misc.hh"
#include "music.hh"
#include "output-def.hh"
#include "paper-book.hh"
#include "scm-hash.hh"
#include "score.hh"
#include "text-interface.hh"
#include "warn.hh"

void
Lily_parser::parser_error (Input const *i, Lily_parser *parser, SCM *, string s)
{
	parser->parser_error (*i, s);
}

#define MYBACKUP(Token, Value, Location)				\
do									\
	if (yychar == YYEMPTY)						\
	{								\
		if (Token)						\
			parser->lexer_->push_extra_token (Token, Value); \
		parser->lexer_->push_extra_token (BACKUP);		\
	} else {							\
		parser->parser_error					\
			(Location, _("Too much lookahead"));		\
	}								\
while (0)


#define MYREPARSE(Location, Pred, Token, Value)				\
do									\
	if (yychar == YYEMPTY)						\
	{								\
		parser->lexer_->push_extra_token (Token, Value);	\
		parser->lexer_->push_extra_token (REPARSE,		\
						  Pred);		\
	} else {							\
		parser->parser_error					\
			(Location, _("Too much lookahead"));		\
	}								\
while (0)

/* Line 371 of yacc.c  */
#line 195 "parser.yy"


#define MY_MAKE_MUSIC(x, spot) \
	make_music_with_input (ly_symbol2scm (x), \
			       parser->lexer_->override_input (spot))

/* ES TODO:
- Don't use lily module, create a new module instead.
- delay application of the function
*/
#define LOWLEVEL_MAKE_SYNTAX(proc, args)	\
  scm_apply_0 (proc, args)
/* Syntactic Sugar. */
#define MAKE_SYNTAX(name, location, ...)				\
	LOWLEVEL_MAKE_SYNTAX (ly_lily_module_constant (name), scm_list_n (parser->self_scm (), make_input (parser->lexer_->override_input (location)), ##__VA_ARGS__, SCM_UNDEFINED))
#define START_MAKE_SYNTAX(name, ...)					\
	scm_list_n (ly_lily_module_constant (name) , ##__VA_ARGS__, SCM_UNDEFINED)
#define FINISH_MAKE_SYNTAX(start, location, ...)			\
	LOWLEVEL_MAKE_SYNTAX (scm_car (start), scm_cons2 (parser->self_scm (), make_input (parser->lexer_->override_input (location)), scm_append_x (scm_list_2 (scm_cdr (start), scm_list_n (__VA_ARGS__, SCM_UNDEFINED)))))

SCM get_next_unique_context_id ();
SCM get_next_unique_lyrics_context_id ();

#undef _
#if !HAVE_GETTEXT
#define _(x) x
#else
#include <libintl.h>
#define _(x) gettext (x)
#endif


static Music *make_music_with_input (SCM name, Input where);
SCM check_scheme_arg (Lily_parser *parser, Input loc,
		      SCM arg, SCM args, SCM pred, SCM disp = SCM_UNDEFINED);
SCM make_music_from_simple (Lily_parser *parser, Input loc, SCM pitch);
SCM loc_on_music (Input loc, SCM arg);
SCM make_chord_elements (Input loc, SCM pitch, SCM dur, SCM modification_list);
SCM make_chord_step (SCM step, Rational alter);
SCM make_simple_markup (SCM a);
bool is_duration (int t);
bool is_regular_identifier (SCM id, bool multiple=false);
SCM try_string_variants (SCM pred, SCM str);
int yylex (YYSTYPE *s, YYLTYPE *loc, Lily_parser *parser);


/* Line 371 of yacc.c  */
#line 212 "out/parser.cc"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END_OF_FILE = 0,
     PREC_BOT = 258,
     REPEAT = 259,
     ALTERNATIVE = 260,
     COMPOSITE = 261,
     ADDLYRICS = 262,
     DEFAULT = 263,
     FUNCTION_ARGLIST = 264,
     DURATION_IDENTIFIER = 265,
     REAL = 266,
     UNSIGNED = 267,
     TONICNAME_PITCH = 268,
     NOTENAME_PITCH = 269,
     PITCH_IDENTIFIER = 270,
     NUMBER_IDENTIFIER = 271,
     PREC_TOP = 272,
     ACCEPTS = 273,
     ALIAS = 274,
     BOOK = 275,
     BOOKPART = 276,
     CHANGE = 277,
     CHORDMODE = 278,
     CHORDS = 279,
     CONSISTS = 280,
     CONTEXT = 281,
     DEFAULTCHILD = 282,
     DENIES = 283,
     DESCRIPTION = 284,
     DRUMMODE = 285,
     DRUMS = 286,
     FIGUREMODE = 287,
     FIGURES = 288,
     HEADER = 289,
     INVALID = 290,
     LAYOUT = 291,
     LYRICMODE = 292,
     LYRICS = 293,
     LYRICSTO = 294,
     MARKUP = 295,
     MARKUPLIST = 296,
     MIDI = 297,
     NAME = 298,
     NOTEMODE = 299,
     OVERRIDE = 300,
     PAPER = 301,
     REMOVE = 302,
     REST = 303,
     REVERT = 304,
     SCORE = 305,
     SEQUENTIAL = 306,
     SET = 307,
     SIMULTANEOUS = 308,
     TEMPO = 309,
     TYPE = 310,
     UNSET = 311,
     WITH = 312,
     NEWCONTEXT = 313,
     CHORD_BASS = 314,
     CHORD_CARET = 315,
     CHORD_COLON = 316,
     CHORD_MINUS = 317,
     CHORD_SLASH = 318,
     ANGLE_OPEN = 319,
     ANGLE_CLOSE = 320,
     DOUBLE_ANGLE_OPEN = 321,
     DOUBLE_ANGLE_CLOSE = 322,
     E_BACKSLASH = 323,
     E_EXCLAMATION = 324,
     E_PLUS = 325,
     EXTENDER = 326,
     FIGURE_CLOSE = 327,
     FIGURE_OPEN = 328,
     FIGURE_SPACE = 329,
     HYPHEN = 330,
     CHORDMODIFIERS = 331,
     MULTI_MEASURE_REST = 332,
     E_UNSIGNED = 333,
     EXPECT_MARKUP = 334,
     EXPECT_PITCH = 335,
     EXPECT_DURATION = 336,
     EXPECT_SCM = 337,
     BACKUP = 338,
     REPARSE = 339,
     EXPECT_MARKUP_LIST = 340,
     EXPECT_OPTIONAL = 341,
     EXPECT_NO_MORE_ARGS = 342,
     EMBEDDED_LILY = 343,
     BOOK_IDENTIFIER = 344,
     CHORDMODIFIER_PITCH = 345,
     CHORD_MODIFIER = 346,
     CHORD_REPETITION = 347,
     CONTEXT_DEF_IDENTIFIER = 348,
     CONTEXT_MOD_IDENTIFIER = 349,
     DRUM_PITCH = 350,
     EVENT_IDENTIFIER = 351,
     EVENT_FUNCTION = 352,
     FRACTION = 353,
     LYRIC_ELEMENT = 354,
     MARKUP_FUNCTION = 355,
     MARKUP_LIST_FUNCTION = 356,
     MARKUP_IDENTIFIER = 357,
     MARKUPLIST_IDENTIFIER = 358,
     MUSIC_FUNCTION = 359,
     MUSIC_IDENTIFIER = 360,
     OUTPUT_DEF_IDENTIFIER = 361,
     RESTNAME = 362,
     SCM_ARG = 363,
     SCM_FUNCTION = 364,
     SCM_IDENTIFIER = 365,
     SCM_TOKEN = 366,
     STRING = 367,
     SYMBOL_LIST = 368,
     UNARY_MINUS = 369
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (Lily_parser *parser, SCM *retval);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 402 "out/parser.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3664

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  132
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  198
/* YYNRULES -- Number of rules.  */
#define YYNRULES  542
/* YYNRULES -- Number of states.  */
#define YYNSTATES  811

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   369

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   127,     2,     2,     2,     2,     2,   125,
       2,     2,   128,   117,   126,   116,   122,    17,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    10,     2,
       2,   121,     2,   131,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   130,     2,   129,   123,   124,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   119,     2,   120,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    11,    12,    13,    14,    15,
      16,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   118
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     6,    10,    11,    14,    17,    20,
      23,    24,    27,    29,    31,    33,    35,    37,    39,    41,
      43,    45,    47,    49,    51,    53,    55,    57,    59,    61,
      63,    65,    67,    69,    71,    73,    75,    77,    79,    81,
      84,    85,    87,    91,    93,    96,    97,   100,   103,   108,
     110,   114,   119,   121,   123,   125,   127,   129,   131,   134,
     136,   138,   140,   142,   144,   146,   151,   153,   154,   157,
     159,   160,   162,   165,   168,   171,   176,   177,   179,   182,
     185,   188,   191,   194,   197,   200,   203,   204,   208,   211,
     216,   217,   219,   222,   225,   228,   231,   234,   237,   240,
     241,   245,   248,   253,   255,   257,   258,   262,   265,   268,
     270,   273,   275,   277,   279,   281,   283,   284,   290,   293,
     297,   300,   303,   304,   308,   311,   316,   322,   325,   326,
     329,   332,   336,   338,   340,   342,   344,   348,   350,   352,
     354,   356,   358,   363,   370,   373,   375,   378,   382,   384,
     386,   388,   389,   395,   398,   400,   403,   404,   406,   407,
     410,   413,   416,   418,   420,   422,   425,   427,   429,   431,
     433,   435,   437,   439,   443,   447,   451,   456,   461,   466,
     471,   477,   483,   489,   491,   496,   501,   506,   511,   516,
     518,   522,   524,   528,   530,   532,   534,   536,   541,   546,
     550,   554,   558,   563,   568,   573,   575,   577,   579,   581,
     586,   591,   596,   601,   606,   611,   616,   622,   628,   634,
     639,   644,   649,   654,   659,   663,   667,   669,   671,   673,
     677,   681,   685,   689,   694,   698,   702,   706,   710,   714,
     718,   722,   727,   732,   734,   736,   738,   742,   746,   751,
     755,   759,   763,   767,   771,   773,   776,   780,   784,   786,
     789,   793,   797,   799,   801,   803,   805,   807,   810,   812,
     816,   820,   825,   830,   835,   838,   839,   842,   844,   846,
     848,   851,   856,   861,   864,   868,   870,   872,   874,   876,
     878,   880,   882,   884,   886,   887,   891,   892,   897,   900,
     901,   906,   911,   913,   916,   920,   923,   928,   931,   935,
     937,   939,   945,   950,   952,   954,   956,   958,   960,   962,
     964,   966,   968,   970,   973,   976,   978,   980,   983,   985,
     990,   994,   999,  1002,  1004,  1006,  1008,  1010,  1012,  1014,
    1016,  1018,  1020,  1022,  1024,  1027,  1029,  1031,  1033,  1035,
    1037,  1039,  1042,  1044,  1046,  1048,  1051,  1054,  1058,  1062,
    1064,  1066,  1070,  1074,  1075,  1078,  1084,  1087,  1089,  1091,
    1093,  1096,  1099,  1101,  1103,  1104,  1107,  1109,  1112,  1114,
    1116,  1119,  1122,  1125,  1128,  1130,  1133,  1135,  1137,  1139,
    1141,  1143,  1145,  1147,  1148,  1151,  1152,  1154,  1156,  1158,
    1161,  1163,  1166,  1169,  1172,  1174,  1176,  1178,  1180,  1182,
    1184,  1186,  1188,  1190,  1192,  1194,  1196,  1198,  1200,  1202,
    1204,  1206,  1208,  1210,  1211,  1213,  1215,  1218,  1221,  1223,
    1227,  1231,  1232,  1235,  1237,  1240,  1242,  1244,  1246,  1248,
    1250,  1252,  1254,  1256,  1258,  1261,  1264,  1267,  1269,  1271,
    1273,  1275,  1277,  1280,  1281,  1284,  1288,  1289,  1291,  1298,
    1301,  1304,  1306,  1309,  1311,  1313,  1315,  1319,  1322,  1327,
    1328,  1331,  1333,  1335,  1338,  1341,  1343,  1345,  1347,  1349,
    1353,  1355,  1358,  1361,  1363,  1367,  1371,  1375,  1377,  1379,
    1383,  1387,  1390,  1392,  1394,  1397,  1400,  1402,  1404,  1406,
    1408,  1410,  1411,  1414,  1415,  1418,  1419,  1423,  1424,  1428,
    1430,  1433,  1435,  1436,  1440,  1442,  1444,  1446,  1448,  1451,
    1453,  1455,  1456,  1462,  1465,  1469,  1470,  1473,  1476,  1479,
    1483,  1487,  1489,  1491,  1495,  1499,  1501,  1504,  1506,  1509,
    1512,  1514,  1517
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     133,     0,    -1,   135,    -1,    -1,    90,   134,   144,    -1,
      -1,   135,   136,    -1,   135,   148,    -1,   135,     1,    -1,
     135,    37,    -1,    -1,   137,   146,    -1,   155,    -1,   158,
      -1,   161,    -1,   188,    -1,   310,    -1,   308,    -1,   113,
      -1,   139,    -1,   165,    -1,   113,    -1,   112,    -1,   112,
      -1,   143,    -1,   110,    -1,   113,    -1,   308,    -1,   184,
      -1,   161,    -1,   150,    -1,   155,    -1,   158,    -1,   165,
      -1,   138,    -1,   143,    -1,   140,    -1,   143,    -1,   178,
      -1,   111,   204,    -1,    -1,   149,    -1,   176,   176,   173,
      -1,     1,    -1,    37,   144,    -1,    -1,   145,   148,    -1,
     145,   141,    -1,    36,   119,   145,   120,    -1,   114,    -1,
     147,   121,   149,    -1,   147,   228,   121,   149,    -1,   161,
      -1,   155,    -1,   158,    -1,   165,    -1,   150,    -1,   179,
      -1,   257,   256,    -1,   300,    -1,   100,    -1,   241,    -1,
     141,    -1,   308,    -1,   184,    -1,    28,   119,   154,   120,
      -1,   141,    -1,    -1,   152,   188,    -1,   151,    -1,    -1,
      95,    -1,   154,   234,    -1,   154,   184,    -1,   154,   153,
      -1,    22,   119,   156,   120,    -1,    -1,    91,    -1,   156,
     164,    -1,   156,   158,    -1,   156,   161,    -1,   156,   188,
      -1,   156,   310,    -1,   156,   308,    -1,   156,   113,    -1,
     156,   139,    -1,    -1,   156,   157,   146,    -1,   156,     1,
      -1,    23,   119,   159,   120,    -1,    -1,    91,    -1,   159,
     164,    -1,   159,   161,    -1,   159,   188,    -1,   159,   310,
      -1,   159,   308,    -1,   159,   113,    -1,   159,   139,    -1,
      -1,   159,   160,   146,    -1,   159,     1,    -1,    52,   119,
     162,   120,    -1,   175,    -1,   139,    -1,    -1,   162,   163,
     146,    -1,   162,   165,    -1,   162,     1,    -1,   165,    -1,
     170,   120,    -1,    48,    -1,    44,    -1,    38,    -1,   166,
      -1,   178,    -1,    -1,    28,   169,   119,   154,   120,    -1,
     167,   119,    -1,   167,   119,   108,    -1,   170,   148,    -1,
     170,   141,    -1,    -1,   170,   171,   168,    -1,   170,     1,
      -1,    56,   277,   121,   299,    -1,    56,   245,   277,   121,
     299,    -1,    56,   244,    -1,    -1,   173,   176,    -1,   173,
       1,    -1,   119,   173,   120,    -1,   178,    -1,   292,    -1,
     175,    -1,   177,    -1,   177,    85,   292,    -1,   141,    -1,
     183,    -1,   188,    -1,   183,    -1,   188,    -1,     4,   242,
     305,   175,    -1,     4,   242,   305,   175,     5,   174,    -1,
      53,   174,    -1,   174,    -1,    55,   174,    -1,    68,   173,
      69,    -1,   246,    -1,   240,    -1,   227,    -1,    -1,    59,
     185,   119,   187,   120,    -1,    59,    96,    -1,    96,    -1,
      59,   211,    -1,    -1,   184,    -1,    -1,   187,   234,    -1,
     187,    96,    -1,   187,   153,    -1,   217,    -1,   190,    -1,
     190,    -1,   218,   189,    -1,   252,    -1,   219,    -1,   107,
      -1,   191,    -1,   182,    -1,   181,    -1,   205,    -1,    88,
      82,   192,    -1,    88,    83,   192,    -1,    88,    84,   192,
      -1,    88,    82,   204,   269,    -1,    88,    83,   207,   274,
      -1,    88,    84,   204,   100,    -1,    88,    84,   207,   257,
      -1,    88,    84,   207,   116,    13,    -1,    88,    84,   207,
     116,    12,    -1,    88,    84,   207,   116,    18,    -1,   193,
      -1,    88,    84,   204,   212,    -1,    88,    84,   207,   304,
      -1,    88,    84,   204,   112,    -1,    88,    84,   204,   114,
      -1,    88,    84,   204,   310,    -1,   115,    -1,   115,   122,
     196,    -1,   197,    -1,   196,   122,   197,    -1,   198,    -1,
     114,    -1,   138,    -1,   193,    -1,    88,    84,   204,   142,
      -1,    88,    84,   207,   303,    -1,   200,    86,   110,    -1,
     200,    86,   292,    -1,   200,    86,   195,    -1,    88,    84,
     204,   112,    -1,    88,    84,   204,   114,    -1,    88,    84,
     204,   310,    -1,   205,    -1,   203,    -1,   208,    -1,   203,
      -1,    88,    84,   201,   212,    -1,    88,    84,   202,   257,
      -1,    88,    84,   201,   310,    -1,    88,    84,   202,    13,
      -1,    88,    84,   202,    12,    -1,    88,    84,   202,    18,
      -1,    88,    84,   201,   100,    -1,    88,    84,   202,   116,
      13,    -1,    88,    84,   202,   116,    12,    -1,    88,    84,
     202,   116,    18,    -1,    88,    82,   201,   269,    -1,    88,
      83,   202,   274,    -1,    88,    84,   201,   112,    -1,    88,
      84,   201,   114,    -1,    88,    84,   203,    85,    -1,   203,
      86,   303,    -1,   203,    86,   195,    -1,   205,    -1,   199,
      -1,   214,    -1,    84,   209,   142,    -1,    84,   210,   303,
      -1,    84,   209,   100,    -1,    84,   210,   257,    -1,    84,
     210,   116,    18,    -1,   206,    86,   110,    -1,   206,    86,
     292,    -1,   206,    86,   303,    -1,   206,    86,   195,    -1,
      84,   209,   112,    -1,    84,   209,   114,    -1,    84,   209,
     310,    -1,    84,   210,   116,    13,    -1,    84,   210,   116,
      12,    -1,   208,    -1,   194,    -1,   214,    -1,    84,   209,
     212,    -1,    84,   210,   303,    -1,    84,   210,   116,    18,
      -1,    84,   210,   257,    -1,    84,   209,   100,    -1,   206,
      86,   110,    -1,   206,    86,   303,    -1,   206,    86,   195,
      -1,   201,    -1,   203,    85,    -1,    88,    82,   209,    -1,
      88,    83,   209,    -1,   202,    -1,   203,    85,    -1,    88,
      82,   210,    -1,    88,    83,   210,    -1,   138,    -1,   213,
      -1,   140,    -1,   213,    -1,   189,    -1,   111,   207,    -1,
      89,    -1,    82,   209,   269,    -1,    83,   210,   274,    -1,
      88,    82,   192,     8,    -1,    88,    83,   192,     8,    -1,
      88,    84,   192,     8,    -1,   106,   204,    -1,    -1,   121,
     242,    -1,   215,    -1,   180,    -1,   225,    -1,   218,   175,
      -1,    28,   243,   216,   186,    -1,    60,   243,   216,   186,
      -1,   220,   191,    -1,   221,   186,   191,    -1,    46,    -1,
      32,    -1,    34,    -1,    25,    -1,    39,    -1,    33,    -1,
      35,    -1,    26,    -1,    40,    -1,    -1,     7,   223,   188,
      -1,    -1,   222,     7,   224,   188,    -1,   188,   222,    -1,
      -1,    41,   242,   226,   175,    -1,    24,   114,   121,   114,
      -1,   196,    -1,   196,   228,    -1,   243,   121,   244,    -1,
      58,   243,    -1,    47,   228,   121,   244,    -1,    51,   230,
      -1,   231,    85,   195,    -1,   232,    -1,   197,    -1,   231,
      85,   110,   122,   197,    -1,   231,    85,   110,   197,    -1,
      27,    -1,    49,    -1,    20,    -1,    29,    -1,    30,    -1,
      21,    -1,    57,    -1,    31,    -1,    45,    -1,   229,    -1,
     233,   114,    -1,   233,   141,    -1,   196,    -1,   235,    -1,
     235,   228,    -1,   196,    -1,    47,   236,   121,   244,    -1,
      51,   239,   230,    -1,    54,   237,   121,   244,    -1,    58,
     237,    -1,   197,    -1,   238,    -1,   114,    -1,   310,    -1,
     114,    -1,   138,    -1,   114,    -1,   138,    -1,   142,    -1,
     112,    -1,   303,    -1,   116,   303,    -1,   100,    -1,   114,
      -1,   310,    -1,   212,    -1,   112,    -1,   303,    -1,   116,
     303,    -1,   100,    -1,   114,    -1,   310,    -1,   289,   256,
      -1,   290,   256,    -1,    94,   276,   256,    -1,    79,   276,
     256,    -1,   254,    -1,   247,    -1,   248,   276,   256,    -1,
      66,   249,    67,    -1,    -1,   249,   250,    -1,   268,   306,
     307,   262,   256,    -1,    97,   256,    -1,   251,    -1,   215,
      -1,   107,    -1,   106,   207,    -1,    99,   207,    -1,   255,
      -1,   172,    -1,    -1,   256,   258,    -1,   260,    -1,   273,
     252,    -1,    77,    -1,    73,    -1,   273,   261,    -1,   273,
     260,    -1,   123,   271,    -1,   124,   271,    -1,   257,    -1,
     116,   271,    -1,    80,    -1,   259,    -1,    98,    -1,   280,
      -1,   253,    -1,   270,    -1,   272,    -1,    -1,   121,   263,
      -1,    -1,   265,    -1,   264,    -1,   125,    -1,   264,   125,
      -1,   126,    -1,   265,   126,    -1,    15,   263,    -1,    14,
     263,    -1,   266,    -1,    16,    -1,   268,    -1,   267,    -1,
     310,    -1,   114,    -1,   211,    -1,    13,    -1,   123,    -1,
     117,    -1,   116,    -1,   127,    -1,    67,    -1,   122,    -1,
     124,    -1,   124,    -1,   123,    -1,   116,    -1,   278,    -1,
      -1,   278,    -1,   275,    -1,    13,   279,    -1,    11,   279,
      -1,   277,    -1,   278,   128,    13,    -1,   278,   128,   100,
      -1,    -1,   279,   122,    -1,    10,    -1,    10,    13,    -1,
      13,    -1,   114,    -1,   310,    -1,   138,    -1,   116,    -1,
     117,    -1,   127,    -1,    76,    -1,   281,    -1,   283,   129,
      -1,   283,   282,    -1,   283,   284,    -1,    72,    -1,    71,
      -1,    17,    -1,    70,    -1,   283,    -1,   130,   283,    -1,
      -1,   286,   285,    -1,    75,   286,    74,    -1,    -1,    50,
      -1,   268,   306,   307,   262,   275,   288,    -1,    97,   276,
      -1,   109,   276,    -1,   293,    -1,   287,   276,    -1,   310,
      -1,   114,    -1,   101,    -1,   291,   276,   256,    -1,   267,
     276,    -1,   267,   276,   295,   294,    -1,    -1,   294,   296,
      -1,    63,    -1,    62,    -1,    65,   267,    -1,    61,   267,
      -1,   295,    -1,   297,    -1,    93,    -1,   298,    -1,   297,
     122,   298,    -1,    13,    -1,    13,   117,    -1,    13,    64,
      -1,    13,    -1,    13,   116,    13,    -1,   300,   117,   301,
      -1,   300,   116,   301,    -1,   301,    -1,   302,    -1,   302,
     128,   302,    -1,   302,    17,   302,    -1,   116,   302,    -1,
     303,    -1,   304,    -1,    13,    18,    -1,    12,    18,    -1,
      13,    -1,    12,    -1,    18,    -1,    13,    -1,    18,    -1,
      -1,   306,   127,    -1,    -1,   307,   131,    -1,    -1,    43,
     309,   317,    -1,    -1,    42,   311,   312,    -1,   315,    -1,
     327,   328,    -1,   328,    -1,    -1,   138,   314,    85,    -1,
     320,    -1,   316,    -1,   321,    -1,   323,    -1,   313,   105,
      -1,   315,    -1,   318,    -1,    -1,    52,   319,   119,   162,
     120,    -1,   327,   316,    -1,   119,   322,   120,    -1,    -1,
     322,   329,    -1,   322,   315,    -1,   103,   325,    -1,    87,
     325,   317,    -1,    84,   325,   211,    -1,    89,    -1,   324,
      -1,    81,   325,   329,    -1,   102,    81,   325,    -1,   326,
      -1,   327,   326,    -1,   114,    -1,   102,   324,    -1,   313,
     104,    -1,   318,    -1,   327,   328,    -1,   328,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   388,   388,   389,   389,   398,   399,   401,   403,   406,
     413,   413,   418,   422,   426,   430,   434,   438,   442,   446,
     460,   476,   480,   484,   485,   489,   490,   494,   495,   496,
     497,   498,   499,   500,   506,   507,   511,   512,   513,   517,
     525,   528,   529,   537,   541,   549,   550,   553,   559,   568,
     572,   576,   585,   586,   587,   588,   589,   590,   591,   613,
     614,   615,   616,   617,   618,   622,   629,   631,   631,   643,
     659,   663,   667,   671,   678,   690,   701,   712,   716,   720,
     724,   728,   732,   736,   740,   744,   759,   758,   762,   771,
     778,   784,   788,   791,   795,   799,   803,   807,   811,   826,
     825,   832,   840,   846,   852,   864,   863,   870,   882,   893,
     906,   915,   921,   926,   935,   947,   952,   951,   961,   965,
     972,   975,   979,   978,   994,  1000,  1003,  1006,  1015,  1018,
    1022,  1032,  1038,  1039,  1043,  1050,  1054,  1061,  1083,  1089,
    1093,  1094,  1098,  1102,  1109,  1112,  1118,  1121,  1127,  1128,
    1129,  1133,  1133,  1138,  1142,  1146,  1158,  1161,  1168,  1171,
    1175,  1180,  1187,  1188,  1193,  1194,  1198,  1202,  1203,  1204,
    1208,  1209,  1245,  1246,  1250,  1254,  1262,  1265,  1268,  1272,
    1276,  1289,  1295,  1304,  1305,  1309,  1313,  1319,  1325,  1332,
    1333,  1340,  1341,  1350,  1364,  1365,  1370,  1371,  1375,  1379,
    1383,  1387,  1394,  1411,  1428,  1444,  1445,  1449,  1450,  1454,
    1464,  1474,  1483,  1494,  1505,  1515,  1525,  1545,  1556,  1566,
    1570,  1574,  1589,  1604,  1609,  1614,  1621,  1622,  1626,  1627,
    1632,  1637,  1642,  1647,  1652,  1657,  1662,  1667,  1674,  1692,
    1710,  1724,  1741,  1750,  1751,  1755,  1756,  1761,  1766,  1772,
    1777,  1782,  1787,  1792,  1799,  1800,  1801,  1805,  1812,  1813,
    1814,  1818,  1825,  1826,  1830,  1831,  1832,  1836,  1843,  1846,
    1849,  1852,  1855,  1858,  1864,  1872,  1873,  1879,  1880,  1881,
    1882,  1889,  1896,  1906,  1917,  1932,  1938,  1945,  1950,  1958,
    1965,  1971,  1976,  1983,  1990,  1990,  1999,  1999,  2008,  2011,
    2011,  2020,  2027,  2030,  2036,  2039,  2042,  2053,  2082,  2089,
    2101,  2102,  2106,  2113,  2114,  2116,  2117,  2118,  2120,  2121,
    2122,  2123,  2127,  2128,  2131,  2149,  2167,  2175,  2190,  2207,
    2218,  2224,  2233,  2259,  2277,  2286,  2289,  2292,  2295,  2307,
    2310,  2327,  2328,  2329,  2337,  2341,  2342,  2343,  2347,  2348,
    2353,  2354,  2358,  2359,  2360,  2365,  2376,  2385,  2391,  2397,
    2398,  2403,  2421,  2428,  2429,  2436,  2462,  2472,  2489,  2490,
    2499,  2506,  2513,  2519,  2526,  2529,  2550,  2553,  2563,  2568,
    2573,  2581,  2589,  2594,  2602,  2603,  2609,  2617,  2618,  2621,
    2626,  2630,  2633,  2644,  2645,  2650,  2653,  2654,  2658,  2661,
    2667,  2670,  2676,  2691,  2702,  2703,  2707,  2708,  2712,  2717,
    2723,  2738,  2746,  2749,  2752,  2755,  2758,  2761,  2764,  2770,
    2771,  2772,  2776,  2782,  2785,  2793,  2801,  2811,  2822,  2825,
    2828,  2836,  2839,  2845,  2848,  2857,  2858,  2859,  2860,  2875,
    2876,  2877,  2881,  2885,  2896,  2900,  2911,  2919,  2922,  2925,
    2928,  2934,  2937,  2944,  2947,  2953,  2960,  2961,  2965,  3001,
    3008,  3024,  3029,  3039,  3044,  3049,  3053,  3062,  3065,  3072,
    3075,  3081,  3084,  3087,  3090,  3096,  3099,  3102,  3108,  3109,
    3115,  3118,  3121,  3127,  3130,  3142,  3145,  3148,  3152,  3155,
    3158,  3164,  3167,  3172,  3173,  3176,  3182,  3183,  3184,  3188,
    3189,  3193,  3194,  3204,  3205,  3216,  3215,  3225,  3224,  3233,
    3236,  3241,  3248,  3247,  3262,  3265,  3269,  3272,  3275,  3282,
    3283,  3290,  3290,  3300,  3307,  3313,  3314,  3317,  3323,  3329,
    3332,  3335,  3341,  3342,  3348,  3354,  3357,  3363,  3366,  3369,
    3373,  3380,  3385
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of input\"", "error", "$undefined", "PREC_BOT", "\"\\\\repeat\"",
  "\"\\\\alternative\"", "COMPOSITE", "\"\\\\addlyrics\"",
  "\"\\\\default\"", "FUNCTION_ARGLIST", "':'", "DURATION_IDENTIFIER",
  "REAL", "UNSIGNED", "TONICNAME_PITCH", "NOTENAME_PITCH",
  "PITCH_IDENTIFIER", "'/'", "NUMBER_IDENTIFIER", "PREC_TOP",
  "\"\\\\accepts\"", "\"\\\\alias\"", "\"\\\\book\"", "\"\\\\bookpart\"",
  "\"\\\\change\"", "\"\\\\chordmode\"", "\"\\\\chords\"",
  "\"\\\\consists\"", "\"\\\\context\"", "\"\\\\defaultchild\"",
  "\"\\\\denies\"", "\"\\\\description\"", "\"\\\\drummode\"",
  "\"\\\\drums\"", "\"\\\\figuremode\"", "\"\\\\figures\"",
  "\"\\\\header\"", "\"\\\\version-error\"", "\"\\\\layout\"",
  "\"\\\\lyricmode\"", "\"\\\\lyrics\"", "\"\\\\lyricsto\"",
  "\"\\\\markup\"", "\"\\\\markuplist\"", "\"\\\\midi\"", "\"\\\\name\"",
  "\"\\\\notemode\"", "\"\\\\override\"", "\"\\\\paper\"",
  "\"\\\\remove\"", "\"\\\\rest\"", "\"\\\\revert\"", "\"\\\\score\"",
  "\"\\\\sequential\"", "\"\\\\set\"", "\"\\\\simultaneous\"",
  "\"\\\\tempo\"", "\"\\\\type\"", "\"\\\\unset\"", "\"\\\\with\"",
  "\"\\\\new\"", "\"/+\"", "\"^\"", "\":\"", "\"-\"", "\"/\"", "\"<\"",
  "\">\"", "\"<<\"", "\">>\"", "\"\\\\\"", "\"\\\\!\"", "\"\\\\+\"",
  "\"__\"", "FIGURE_CLOSE", "FIGURE_OPEN", "\"_\"", "\"--\"",
  "CHORDMODIFIERS", "MULTI_MEASURE_REST", "E_UNSIGNED", "\"markup?\"",
  "\"ly:pitch?\"", "\"ly:duration?\"", "\"scheme?\"", "\"(backed-up?)\"",
  "\"(reparsed?)\"", "\"markup-list?\"", "\"optional?\"",
  "EXPECT_NO_MORE_ARGS", "\"#{\"", "BOOK_IDENTIFIER",
  "CHORDMODIFIER_PITCH", "CHORD_MODIFIER", "CHORD_REPETITION",
  "CONTEXT_DEF_IDENTIFIER", "CONTEXT_MOD_IDENTIFIER", "DRUM_PITCH",
  "EVENT_IDENTIFIER", "EVENT_FUNCTION", "FRACTION", "LYRIC_ELEMENT",
  "MARKUP_FUNCTION", "MARKUP_LIST_FUNCTION", "MARKUP_IDENTIFIER",
  "MARKUPLIST_IDENTIFIER", "MUSIC_FUNCTION", "MUSIC_IDENTIFIER",
  "OUTPUT_DEF_IDENTIFIER", "RESTNAME", "SCM_ARG", "SCM_FUNCTION",
  "SCM_IDENTIFIER", "SCM_TOKEN", "STRING", "SYMBOL_LIST", "'-'", "'+'",
  "UNARY_MINUS", "'{'", "'}'", "'='", "'.'", "'^'", "'_'", "'\\''", "','",
  "'!'", "'*'", "']'", "'['", "'?'", "$accept", "start_symbol", "$@1",
  "lilypond", "toplevel_expression", "$@2", "embedded_scm_bare",
  "embedded_scm_active", "embedded_scm_bare_arg", "embedded_scm",
  "embedded_scm_arg", "scm_function_call", "embedded_lilypond",
  "lilypond_header_body", "lilypond_header", "assignment_id", "assignment",
  "identifier_init", "context_def_spec_block", "context_mod_arg", "$@3",
  "context_mod_embedded", "context_def_spec_body", "book_block",
  "book_body", "$@4", "bookpart_block", "bookpart_body", "$@5",
  "score_block", "score_body", "$@6", "paper_block", "output_def",
  "output_def_head", "output_def_head_with_mode_switch",
  "music_or_context_def", "$@7", "output_def_body", "$@8", "tempo_event",
  "music_list", "braced_music_list", "music", "music_embedded",
  "music_embedded_backup", "music_arg", "music_assign", "repeated_music",
  "sequential_music", "simultaneous_music", "simple_music",
  "context_modification", "$@9", "optional_context_mod",
  "context_mod_list", "composite_music", "closed_music", "music_bare",
  "grouped_music_list", "function_arglist_skip",
  "function_arglist_nonbackup_common", "function_arglist_closed_nonbackup",
  "symbol_list_arg", "symbol_list_rev", "symbol_list_part",
  "symbol_list_element", "function_arglist_nonbackup",
  "function_arglist_nonbackup_reparse", "function_arglist_keep",
  "function_arglist_closed_keep", "function_arglist_backup",
  "function_arglist", "function_arglist_common",
  "function_arglist_common_reparse", "function_arglist_closed",
  "function_arglist_closed_common", "function_arglist_optional",
  "function_arglist_closed_optional", "embedded_scm_closed",
  "embedded_scm_arg_closed", "scm_function_call_closed",
  "function_arglist_bare", "music_function_call", "optional_id",
  "complex_music", "complex_music_prefix", "mode_changed_music",
  "mode_changing_head", "mode_changing_head_with_context", "new_lyrics",
  "$@10", "$@11", "re_rhythmed_music", "$@12", "context_change",
  "property_path", "property_operation", "revert_arg", "revert_arg_backup",
  "revert_arg_part", "context_def_mod", "context_mod", "grob_prop_spec",
  "grob_prop_path", "context_prop_spec", "simple_music_property_def",
  "simple_revert_context", "music_property_def", "string", "simple_string",
  "symbol", "scalar", "scalar_closed", "event_chord", "note_chord_element",
  "chord_body", "chord_body_elements", "chord_body_element",
  "music_function_chord_body", "music_function_call_closed",
  "event_function_event", "command_element", "command_event",
  "post_events", "post_event_nofinger", "post_event",
  "string_number_event", "direction_less_event", "direction_reqd_event",
  "octave_check", "quotes", "sup_quotes", "sub_quotes", "steno_pitch",
  "steno_tonic_pitch", "pitch", "pitch_also_in_chords", "gen_text_def",
  "fingering", "script_abbreviation", "script_dir", "duration_length",
  "maybe_notemode_duration", "optional_notemode_duration",
  "steno_duration", "multiplied_duration", "dots", "tremolo_type",
  "bass_number", "figured_bass_alteration", "bass_figure",
  "figured_bass_modification", "br_bass_figure", "figure_list",
  "figure_spec", "optional_rest", "simple_element",
  "simple_chord_elements", "lyric_element", "lyric_element_music",
  "new_chord", "chord_items", "chord_separator", "chord_item",
  "step_numbers", "step_number", "tempo_range", "number_expression",
  "number_term", "number_factor", "bare_number", "bare_number_closed",
  "unsigned_number", "exclamations", "questions", "full_markup_list",
  "$@13", "full_markup", "$@14", "markup_top", "markup_scm", "$@15",
  "simple_markup_list", "markup_uncomposed_list", "markup_list",
  "markup_score", "$@16", "markup_composed_list", "markup_braced_list",
  "markup_braced_list_body", "markup_command_list",
  "markup_command_basic_arguments", "markup_command_list_arguments",
  "markup_head_1_item", "markup_head_1_list", "simple_markup", "markup", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      58,   265,   266,   267,   268,   269,   270,    47,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    45,    43,   369,   123,
     125,    61,    46,    94,    95,    39,    44,    33,    42,    93,
      91,    63
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   132,   133,   134,   133,   135,   135,   135,   135,   135,
     137,   136,   136,   136,   136,   136,   136,   136,   136,   136,
     136,   138,   138,   139,   139,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   141,   141,   142,   142,   142,   143,
     144,   144,   144,   144,   144,   145,   145,   145,   146,   147,
     148,   148,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   150,   151,   152,   151,   153,
     154,   154,   154,   154,   154,   155,   156,   156,   156,   156,
     156,   156,   156,   156,   156,   156,   157,   156,   156,   158,
     159,   159,   159,   159,   159,   159,   159,   159,   159,   160,
     159,   159,   161,   162,   162,   163,   162,   162,   162,   164,
     165,   166,   166,   166,   167,   168,   169,   168,   170,   170,
     170,   170,   171,   170,   170,   172,   172,   172,   173,   173,
     173,   174,   175,   175,   176,   176,   176,   177,   178,   178,
     179,   179,   180,   180,   181,   181,   182,   182,   183,   183,
     183,   185,   184,   184,   184,   184,   186,   186,   187,   187,
     187,   187,   188,   188,   189,   189,   189,   190,   190,   190,
     191,   191,   192,   192,   192,   192,   193,   193,   193,   193,
     193,   193,   193,   194,   194,   194,   194,   194,   194,   195,
     195,   196,   196,   197,   198,   198,   199,   199,   199,   199,
     199,   199,   200,   200,   200,   201,   201,   202,   202,   203,
     203,   203,   203,   203,   203,   203,   203,   203,   203,   203,
     203,   203,   203,   203,   203,   203,   204,   204,   205,   205,
     205,   205,   205,   205,   205,   205,   205,   205,   206,   206,
     206,   206,   206,   207,   207,   208,   208,   208,   208,   208,
     208,   208,   208,   208,   209,   209,   209,   209,   210,   210,
     210,   210,   211,   211,   212,   212,   212,   213,   214,   214,
     214,   214,   214,   214,   215,   216,   216,   217,   217,   217,
     217,   218,   218,   219,   219,   220,   220,   220,   220,   220,
     221,   221,   221,   221,   223,   222,   224,   222,   225,   226,
     225,   227,   228,   228,   229,   229,   229,   229,   230,   231,
     232,   232,   232,   233,   233,   233,   233,   233,   233,   233,
     233,   233,   234,   234,   234,   235,   236,   236,   237,   238,
     238,   238,   238,   239,   240,   241,   241,   242,   242,   243,
     243,   244,   244,   244,   244,   244,   244,   244,   245,   245,
     245,   245,   245,   245,   245,   246,   246,   246,   246,   246,
     246,   247,   248,   249,   249,   250,   250,   250,   251,   251,
     252,   253,   254,   255,   256,   256,   257,   257,   257,   257,
     257,   257,   257,   257,   258,   258,   259,   260,   260,   260,
     260,   261,   261,   262,   262,   263,   263,   263,   264,   264,
     265,   265,   266,   267,   268,   268,   269,   269,   270,   270,
     270,   271,   272,   272,   272,   272,   272,   272,   272,   273,
     273,   273,   274,   275,   275,   276,   277,   277,   278,   278,
     278,   279,   279,   280,   280,   281,   281,   281,   281,   282,
     282,   282,   283,   283,   283,   283,   283,   284,   284,   284,
     284,   285,   285,   286,   286,   287,   288,   288,   289,   289,
     289,   290,   290,   291,   291,   291,   292,   293,   293,   294,
     294,   295,   295,   295,   295,   296,   296,   296,   297,   297,
     298,   298,   298,   299,   299,   300,   300,   300,   301,   301,
     301,   302,   302,   303,   303,   303,   304,   304,   304,   305,
     305,   306,   306,   307,   307,   309,   308,   311,   310,   312,
     312,   312,   314,   313,   315,   315,   316,   316,   316,   317,
     317,   319,   318,   320,   321,   322,   322,   322,   323,   324,
     324,   324,   325,   325,   326,   327,   327,   328,   328,   328,
     328,   329,   329
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     3,     0,     2,     2,     2,     2,
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       0,     1,     3,     1,     2,     0,     2,     2,     4,     1,
       3,     4,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     4,     1,     0,     2,     1,
       0,     1,     2,     2,     2,     4,     0,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     0,     3,     2,     4,
       0,     1,     2,     2,     2,     2,     2,     2,     2,     0,
       3,     2,     4,     1,     1,     0,     3,     2,     2,     1,
       2,     1,     1,     1,     1,     1,     0,     5,     2,     3,
       2,     2,     0,     3,     2,     4,     5,     2,     0,     2,
       2,     3,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     4,     6,     2,     1,     2,     3,     1,     1,
       1,     0,     5,     2,     1,     2,     0,     1,     0,     2,
       2,     2,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     4,     4,     4,     4,
       5,     5,     5,     1,     4,     4,     4,     4,     4,     1,
       3,     1,     3,     1,     1,     1,     1,     4,     4,     3,
       3,     3,     4,     4,     4,     1,     1,     1,     1,     4,
       4,     4,     4,     4,     4,     4,     5,     5,     5,     4,
       4,     4,     4,     4,     3,     3,     1,     1,     1,     3,
       3,     3,     3,     4,     3,     3,     3,     3,     3,     3,
       3,     4,     4,     1,     1,     1,     3,     3,     4,     3,
       3,     3,     3,     3,     1,     2,     3,     3,     1,     2,
       3,     3,     1,     1,     1,     1,     1,     2,     1,     3,
       3,     4,     4,     4,     2,     0,     2,     1,     1,     1,
       2,     4,     4,     2,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     3,     0,     4,     2,     0,
       4,     4,     1,     2,     3,     2,     4,     2,     3,     1,
       1,     5,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     1,     1,     2,     1,     4,
       3,     4,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     2,     2,     3,     3,     1,
       1,     3,     3,     0,     2,     5,     2,     1,     1,     1,
       2,     2,     1,     1,     0,     2,     1,     2,     1,     1,
       2,     2,     2,     2,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     0,     2,     0,     1,     1,     1,     2,
       1,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     1,     2,     2,     1,     3,
       3,     0,     2,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     1,     1,     1,
       1,     1,     2,     0,     2,     3,     0,     1,     6,     2,
       2,     1,     2,     1,     1,     1,     3,     2,     4,     0,
       2,     1,     1,     2,     2,     1,     1,     1,     1,     3,
       1,     2,     2,     1,     3,     3,     3,     1,     1,     3,
       3,     2,     1,     1,     2,     2,     1,     1,     1,     1,
       1,     0,     2,     0,     2,     0,     3,     0,     3,     1,
       2,     1,     0,     3,     1,     1,     1,     1,     2,     1,
       1,     0,     5,     2,     3,     0,     2,     2,     2,     3,
       3,     1,     1,     3,     3,     1,     2,     1,     2,     2,
       1,     2,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       5,     3,     0,     0,     0,     1,     8,     0,     0,     0,
     288,   292,     0,   286,   290,   287,   291,     9,   113,   289,
     293,     0,   507,   505,   112,   285,   111,     0,     0,     0,
       0,   128,     0,   168,     0,    23,    18,    49,   128,     6,
       0,    19,    24,     0,     7,    12,    13,    14,    20,   114,
       0,     0,   145,   278,   171,   170,    15,   163,   169,   277,
     162,     0,   167,     0,   156,   279,    17,    16,    43,   433,
     497,   496,   395,   395,   405,   498,     0,     0,     0,     0,
       0,     0,     0,     0,   151,   363,   379,   453,   378,   423,
     386,   423,   154,   423,   388,     0,    60,   465,   423,    22,
      21,   464,   421,   420,   419,    34,   137,    35,     4,    41,
      56,    53,    54,    52,    55,   373,   134,     0,   135,   132,
      57,   138,    64,   139,   150,   334,   149,    61,   148,   360,
     423,   390,   359,   372,   374,   387,   376,   404,   423,   501,
       0,   389,   423,   374,   374,   423,   133,   461,    59,   487,
     488,   492,   493,    63,   463,   337,   338,     0,    76,    90,
     339,   340,   275,   299,     0,     0,     0,   144,   146,   275,
       0,     0,     0,     0,     0,   268,   196,   227,     0,   274,
     226,     0,   228,    39,     0,     0,    11,   194,     0,   195,
     302,   191,   193,     0,   118,   124,   110,   121,   120,     0,
     294,   298,   464,   280,   138,   139,   463,   283,   157,     0,
     434,   495,   494,   398,   400,   403,   397,   396,   402,     0,
      70,    44,   325,   326,     0,   333,     0,   328,     0,   431,
     496,   345,     0,    25,     0,   342,    26,   346,     0,    36,
     341,    37,    30,    31,    32,    29,    33,    38,    28,   266,
     163,   348,   265,     0,   127,     0,   166,     0,   343,    27,
     347,   332,   153,     0,   262,     0,   155,   263,     0,     0,
     431,   425,   374,   428,   424,   374,   459,     0,     0,   183,
     244,     0,   371,   243,   245,   460,     0,   491,   411,   382,
     383,   137,   128,     0,   374,    58,   467,   503,   416,     0,
     409,   414,   413,   417,   412,   418,   415,   410,   377,   381,
     380,   391,   392,   408,   462,   355,   356,   374,     0,     0,
       0,     0,   499,   500,     0,    77,     0,    91,     0,     0,
     156,     0,   521,     0,     0,   537,   525,   512,   508,     0,
     509,   515,   540,   514,   516,   517,   535,     0,   511,     0,
       0,   519,   506,   520,     0,   104,     0,   103,   156,   130,
     147,   129,     0,   254,   206,   205,     0,     0,   258,   208,
     207,     0,     0,     0,   206,     0,     0,     0,   228,     0,
       0,     0,     0,     0,   131,    45,   335,    62,    50,   140,
     141,   336,     0,   303,     0,   119,   116,   123,   115,     0,
     296,   284,   399,   401,     0,    71,    67,   327,     0,   310,
     330,     0,   309,     0,   427,   426,     0,   196,   370,   267,
     344,   165,     0,     0,   158,   362,   374,   369,   368,   364,
     367,   501,   435,   455,   442,   436,     0,   438,   443,   451,
     454,   437,   358,     0,   357,     0,     0,     0,     0,     0,
     136,   361,   421,   384,   375,     0,   472,   471,     0,   469,
     502,   393,   466,   486,   485,   490,   489,   142,    88,    84,
      75,    85,     0,    79,    80,    78,   109,    81,    83,    82,
     101,    97,    89,    98,     0,    93,    92,    94,    96,    95,
     276,   281,   300,     0,     0,     0,     0,   531,   538,     0,
     532,   528,     0,     0,   539,   518,   523,   536,   510,   108,
     102,     0,   107,   282,     0,     0,     0,   255,     0,   407,
     406,   269,     0,     0,   259,   270,   422,     0,     0,     0,
       0,   255,     0,   231,   238,   239,    36,   229,   240,   421,
     232,   230,     0,     0,     0,   226,     0,     0,   172,     0,
       0,     0,     0,     0,   199,   189,   201,   200,   234,   237,
     235,   236,     0,   192,    51,     0,   295,     0,   301,   315,
     318,   313,   316,   317,   320,   321,     0,   314,     0,   319,
       0,    65,    34,    66,    69,     0,    74,    73,   322,     0,
      72,     0,   345,   342,   346,     0,   329,   343,   347,     0,
     331,   432,     0,     0,   483,   125,    67,   366,   503,   452,
     449,   450,   448,   447,   439,   440,   441,   444,   445,   446,
     429,   430,   250,   264,   164,   246,     0,   421,   249,   247,
       0,     0,   251,   253,   252,   385,   474,   473,   468,   395,
     504,   423,     0,    87,   100,     0,   534,     0,     0,     0,
     524,   527,     0,   542,   526,   513,   106,     0,   254,   205,
     256,     0,   206,   257,     0,     0,     0,   206,   225,   224,
       0,     0,   206,   260,   258,   261,   231,   421,   232,   230,
       0,   234,   237,   236,   242,   241,   233,     0,     0,     0,
     271,   176,     0,   272,   177,     0,   273,   178,   202,   203,
     197,   204,   421,   179,   198,     0,    48,    47,    46,    70,
     297,     0,   307,   305,    68,   323,   324,     0,   344,     0,
     308,     0,     0,   126,     0,   160,   152,   161,   159,   393,
     248,   186,   187,   184,   188,   497,   496,   185,   480,   477,
     475,   470,   476,   478,   394,   456,   143,     0,   530,   529,
       0,     0,   533,   541,     0,     0,     0,   219,   220,     0,
       0,   215,   221,   222,   209,   211,   213,   212,   214,   421,
     210,   223,     0,     0,   233,     0,     0,   173,   174,   175,
     181,   180,   182,   190,    67,     0,   304,     0,   312,   186,
     187,   188,   493,   484,   374,   482,   481,     0,   457,   458,
     522,   206,   208,   217,   216,   218,   117,   306,   311,   365,
     479
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     4,     3,    39,    40,   189,   355,   536,   291,
     240,   107,   108,   562,   186,    43,    44,   109,   242,   584,
     585,   586,   406,   243,   326,   472,   244,   328,   484,   245,
     356,   511,   475,   246,    49,    50,   397,   565,    51,   199,
     115,   170,    52,   116,   361,   118,   119,   120,    53,    54,
      55,   204,   248,   265,   209,   606,   205,   249,    57,    58,
     777,   417,   280,   556,   190,   191,   192,   177,   178,   363,
     368,   374,   179,   659,   375,   418,   370,   660,   673,   266,
     625,   252,   378,    59,   330,    60,    61,    62,    63,    64,
     201,   399,   567,    65,   331,   124,   193,   588,   410,   411,
     412,   589,   590,   223,   224,   228,   125,   226,   126,   127,
     157,   162,   254,   255,   128,   129,   130,   268,   429,   430,
     256,   131,   132,   133,   295,   453,   454,   135,   136,   310,
     641,   215,   216,   217,   137,   138,   139,   757,   311,   289,
     312,   140,   758,   271,   272,   273,   274,   415,   141,   438,
     618,   439,   619,   440,   269,   142,   799,   143,   144,   145,
     146,   147,   638,   459,   741,   742,   743,   605,   148,   149,
     150,   151,   152,   324,   297,   461,   259,   165,   206,   164,
     338,   339,   503,   351,   341,   352,   342,   493,   343,   344,
     502,   345,   500,   501,   346,   354,   653,   654
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -513
static const yytype_int16 yypact[] =
{
     -18,  -513,    96,  1431,   838,  -513,  -513,   622,    -7,    12,
    -513,  -513,   706,  -513,  -513,  -513,  -513,  -513,  -513,  -513,
    -513,   622,  -513,  -513,  -513,  -513,  -513,    21,    38,    38,
     706,  -513,   529,  -513,   529,  -513,  -513,  -513,  -513,  -513,
     144,  -513,  -513,   810,  -513,  -513,  -513,  -513,  -513,  -513,
      65,  1332,  -513,  -513,  -513,  -513,   127,  -513,  -513,  -513,
    -513,  2570,  -513,    74,    40,  -513,  -513,  -513,  -513,   133,
     187,   194,   145,   145,  -513,  -513,   101,   643,   838,   721,
     721,   721,  1742,   721,   224,  -513,  -513,  -513,  -513,   231,
    -513,   231,  -513,   231,  -513,   885,  -513,  -513,   231,  -513,
    -513,   227,   136,   221,   221,  -513,   260,  -513,  -513,  -513,
    -513,  -513,  -513,  -513,  -513,  -513,  -513,  2368,   193,  -513,
    -513,   285,  -513,   132,  -513,  -513,  -513,  -513,  -513,  -513,
     231,  -513,  -513,  -513,  -513,  -513,  -513,  -513,   231,  -513,
     700,  -513,   231,  -513,  -513,   231,  -513,  -513,   308,  -513,
      72,  -513,  -513,  -513,   293,  -513,  -513,   110,   212,   236,
    -513,  -513,   195,  -513,   465,   755,  2469,  -513,  -513,   195,
    1631,   893,   901,  1038,   207,  -513,  -513,  -513,   248,  -513,
    -513,   252,  -513,  -513,  1114,   179,  -513,  -513,  1000,  -513,
     183,  -513,  -513,   223,   259,  -513,  -513,  -513,  -513,  2762,
    -513,   367,  -513,  -513,  -513,   127,  -513,  -513,  -513,    74,
    -513,  -513,  -513,  -513,  -513,  -513,   268,   251,  -513,   282,
     333,  -513,   310,   721,   356,  -513,   721,   310,   365,  -513,
      85,   295,  1075,  -513,  1075,   352,  -513,   407,   136,  1304,
    -513,  -513,  -513,  -513,  -513,  -513,  -513,  -513,  -513,  -513,
    1603,  -513,  -513,  2666,  -513,   231,  -513,   369,   418,  -513,
     435,  -513,  -513,   885,  -513,   335,  -513,  -513,   531,   408,
    -513,  -513,  -513,  -513,   395,  -513,  -513,  1038,   846,  -513,
    -513,   445,  -513,  -513,  -513,  -513,    98,  -513,  -513,  -513,
    -513,  -513,  -513,   174,  -513,   624,   109,   366,  -513,   885,
    -513,  -513,  -513,  -513,  -513,  -513,  -513,  -513,  -513,  -513,
    -513,  -513,  -513,  -513,  -513,   624,   624,  -513,    98,    98,
      98,    98,  -513,  -513,  2570,  -513,  1481,  -513,  1531,   622,
      40,  2570,  -513,   417,   461,  -513,  -513,  -513,  -513,   331,
    -513,  -513,  -513,  -513,  -513,  -513,  -513,   465,  -513,   453,
     432,  -513,  -513,  -513,   853,  -513,   202,  -513,    40,  -513,
    -513,  -513,   876,  -513,   378,  -513,   982,   917,  -513,   382,
    -513,   231,  1038,   937,  2821,   455,  1964,  2638,  2340,  1095,
    1103,  1112,   166,   695,  -513,  -513,  -513,  -513,  -513,  -513,
     127,  -513,   721,  -513,  1000,  -513,   706,  -513,  -513,  2850,
    -513,  -513,  -513,  -513,   439,  -513,  3260,  -513,  1853,  -513,
    -513,   470,  -513,  1853,   441,   441,   947,  2441,  -513,  -513,
     463,  -513,   448,   558,  -513,  -513,  -513,  -513,  -513,  -513,
    -513,  -513,  -513,  -513,  -513,  -513,   519,  -513,  -513,   458,
    -513,  -513,   624,    64,   624,  3399,  3077,  1112,   143,  1231,
    -513,   624,   221,  -513,  -513,   559,  -513,  -513,   559,  -513,
    -513,   -16,   624,  -513,  -513,  -513,  -513,   585,  -513,  -513,
    -513,  -513,   144,  -513,  -513,  -513,  -513,   127,  -513,  -513,
    -513,  -513,  -513,  -513,   144,  -513,  -513,   127,  -513,  -513,
    -513,  -513,  -513,   480,   461,   461,   461,  -513,  -513,   461,
    -513,  -513,   807,   522,  -513,  -513,  -513,  -513,  -513,  -513,
    -513,   144,  -513,  -513,  1115,  1130,  1154,  -513,   177,  -513,
    -513,  -513,  1192,  1192,  -513,  -513,   395,  2065,  3117,  1212,
    1212,  3146,   731,  -513,  -513,  -513,  -513,  -513,  -513,   330,
    -513,  -513,   979,   602,   982,   614,   999,   628,  -513,   231,
    1002,   631,  2166,  3159,  -513,   508,  -513,  -513,  -513,  -513,
    -513,  -513,   788,  -513,  -513,   521,  -513,  2850,  -513,  -513,
    -513,  -513,  -513,  -513,  -513,  -513,   721,  -513,   721,  -513,
     706,  -513,   525,  -513,  -513,  2850,  -513,  -513,  -513,   689,
    -513,   532,  -513,  -513,  -513,   136,  -513,  -513,  -513,   149,
    -513,  -513,  1112,   558,   543,  -513,  3306,   624,   366,   458,
    -513,  -513,  -513,  -513,  -513,  -513,  -513,  -513,  -513,  -513,
    -513,  -513,  -513,  -513,  -513,  -513,  3545,   546,  -513,  -513,
    3448,  3169,  -513,  -513,  -513,  -513,  -513,  -513,   728,   145,
    -513,   231,    38,  -513,  -513,  2469,  -513,   980,   755,   664,
    -513,  -513,   465,  -513,  -513,  -513,  -513,  1019,   982,   614,
    -513,   231,   147,  -513,  1049,  3497,  3199,  2848,  -513,  -513,
    1052,   982,   244,  -513,   231,  -513,  2542,   576,  2904,  2941,
    1061,  2975,  2986,  2995,  -513,  -513,  -513,  1095,  1103,  1112,
    -513,  -513,  1112,  -513,  -513,  1112,  -513,  -513,  -513,  -513,
    -513,  -513,   590,  -513,  -513,   721,  -513,  -513,  -513,   333,
    -513,   540,  -513,  -513,   127,  -513,  -513,  1853,  -513,   358,
    -513,  2267,  3159,  -513,   652,  -513,  -513,  -513,  -513,   -16,
    -513,  -513,  -513,  -513,  -513,  -513,  -513,  -513,    58,  -513,
    -513,  -513,   547,  -513,  -513,   623,  -513,   225,  -513,  -513,
     568,   664,  -513,  -513,  1115,  1130,  1154,  -513,  -513,  1220,
    1154,  -513,  -513,  -513,  -513,  -513,  -513,  -513,  -513,   636,
    -513,  -513,  1192,  1192,  3023,  1212,  1212,  -513,  -513,  -513,
    -513,  -513,  -513,   310,  3283,  1853,  -513,   721,  -513,   589,
     593,   596,  3068,  -513,  -513,  -513,  -513,   672,  -513,  -513,
    -513,   610,   610,  -513,  -513,  -513,  -513,  -513,  -513,   624,
    -513
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -513,  -513,  -513,  -513,  -513,  -513,     3,    70,   -74,     8,
    -298,     0,   621,  -513,  -190,  -513,   -19,  -132,    36,  -513,
    -513,    82,    -4,    63,  -513,  -513,   114,  -513,  -513,    91,
      55,  -513,   383,    13,  -513,  -513,  -513,  -513,  -513,  -513,
    -513,    27,    -1,    31,   100,  -513,   -61,  -513,  -513,  -513,
    -513,    43,    10,  -513,  -245,  -513,    57,  -204,   -44,    30,
     314,     2,  -513,    44,   -35,   -75,  -513,  -513,  -513,  -294,
    -216,   -27,    -9,   -21,     5,    14,   -69,  -151,   -89,  -131,
     -64,   -42,    11,   447,   550,  -513,   -30,  -513,  -513,  -513,
    -513,  -513,  -513,  -513,  -513,  -513,  -133,  -513,   152,  -513,
    -513,  -513,   119,  -513,  -513,   648,  -513,  -513,  -513,  -513,
      32,   -26,  -306,  -513,  -513,  -513,  -513,  -513,  -513,  -513,
     598,  -513,  -513,  -513,  -113,    -2,  -513,  -513,   611,  -513,
      24,   -67,  -513,  -513,  -513,  -325,  -213,  -297,  -513,   -40,
    -513,  -513,  -300,   122,   850,   -12,  -308,   539,  -513,  -513,
    -513,   336,  -513,  -513,  -513,  -513,  -513,  -513,  -513,  -513,
    -146,  -513,  -513,   112,  -513,  -513,   -28,   168,  -513,   181,
     -34,   -59,  -512,  -513,   343,   167,   121,  -513,    -3,  -513,
    -513,  -136,  -513,  -102,  -246,   131,  -130,  -513,  -513,  -513,
    -513,  -513,   450,    15,  -296,  -114,  -145,   135
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -432
static const yytype_int16 yytable[] =
{
      67,   154,   134,    42,   169,   225,   218,   105,   239,   307,
     156,   180,   106,   180,   122,   161,    48,   114,   251,   348,
     366,   247,   376,   258,   156,   183,   283,   167,   168,   350,
     315,   316,   198,   161,   176,   353,   176,   181,   250,   181,
     110,   519,   267,   182,   222,   182,   227,   121,   227,   421,
     347,   507,   253,   163,   105,   431,   388,   393,   507,   197,
      56,   123,   340,   526,   290,   184,    45,   111,   287,   521,
     257,   525,     1,    41,   208,   154,   134,   620,   537,   260,
     161,   105,   241,   371,   377,   491,   106,   264,   122,   320,
     407,   114,   203,   207,    47,   113,     5,   279,   267,    84,
     281,   506,   596,   212,   117,   639,   284,   600,   506,   282,
      70,    71,   158,   513,   110,   640,    75,    46,   112,   737,
     105,   121,   795,   322,    66,   153,   445,    28,   323,    29,
     636,   159,  -141,   637,   200,   123,    92,   313,   398,   200,
     166,   111,    31,   264,   364,   369,   210,   450,    70,    71,
     365,   409,   365,   520,    75,    70,    71,    38,  -208,   442,
    -208,    75,   444,   283,   621,   283,    42,   337,   337,   113,
     455,   456,   457,   105,   458,   796,   181,   281,   117,   420,
     185,   451,   182,   284,   194,   391,   134,   105,   446,    70,
      71,   105,   112,    38,   283,    75,   387,   357,   122,   153,
     321,   114,   508,   509,   462,   211,  -431,  -431,    22,   250,
     792,   180,   212,   180,   286,   219,    22,   292,   350,   519,
     658,   527,   665,   253,   110,   183,   509,  -335,   671,   537,
     283,   389,   517,   518,   288,   658,   557,   560,  -105,   401,
      18,   526,   229,   422,   270,   390,    24,   691,   419,   694,
      26,   111,   287,   632,   700,  -208,   365,  -208,   555,   719,
     -62,  -105,   564,    18,   555,   279,   441,    97,   281,    24,
     213,   214,   437,    26,   284,    97,   554,   419,   293,   113,
     202,   555,   643,   528,   203,  -140,   465,   466,   202,   379,
     380,   381,   555,  -336,   644,    99,   100,   187,   385,   661,
     666,   279,   112,   325,   281,   392,  -352,   674,  -352,   153,
     284,   283,   283,   607,   674,   247,   329,   563,   541,   449,
     262,   656,   510,   479,   561,   489,    42,   327,    42,   524,
     518,   520,   156,   519,   382,   263,    99,   100,   383,   476,
     208,   476,   684,   685,   394,   800,   519,   247,   686,   597,
     337,   365,   247,   526,   597,   467,   507,   337,   545,   548,
     545,   490,   492,  -349,   663,  -349,   526,   395,   208,   512,
     544,   623,   552,   538,   400,   540,   241,   403,   283,   663,
     591,   176,   279,   477,   181,   487,   560,   629,   652,   634,
     182,   391,   134,   402,   549,   553,   471,   105,   483,   161,
     651,   624,   387,   404,   122,   598,   506,   114,   241,   582,
     598,   786,   635,   241,   583,   626,   587,   474,  -353,   485,
    -353,   432,   421,   700,   318,   319,   545,   559,   405,  -350,
     110,  -350,   392,   441,   675,   504,   505,   389,   630,   437,
     473,   675,   538,   711,   628,   520,  -354,   478,  -354,   488,
      22,   390,   105,   239,   424,   507,   566,   111,   520,   669,
     658,   631,   665,   517,   518,   671,   247,   524,   518,   679,
      99,   100,   187,   683,  -351,   610,  -351,   408,   671,   807,
     787,   658,   433,   250,   434,   113,   413,   364,   662,   667,
     423,   247,   633,   460,   704,   672,   369,   253,   494,   463,
     464,   495,   548,   409,   496,   337,   497,   753,   112,   646,
     647,   648,   350,   750,   649,   153,   748,   332,   353,   181,
      99,   100,   435,   443,   538,   182,   678,   241,   611,   612,
     613,   448,   432,   283,   494,   751,   718,   505,   436,   661,
     666,   532,   499,   708,   661,   495,    73,    74,   496,   701,
     497,   703,   241,   568,   713,   599,   623,   674,   684,   685,
     674,    22,   668,   601,   730,   105,   733,   333,   334,   603,
     707,   604,   744,    72,   614,   615,   682,    99,   100,   335,
     591,   545,   624,   161,   336,   616,   624,   617,   684,   685,
     642,   623,   105,   721,   774,   434,   626,   716,   425,   645,
     626,   764,   780,   781,   663,   267,   753,   655,   782,   582,
     690,   171,   172,   173,   583,   750,   722,   174,   175,   283,
     283,   624,  -172,   283,   710,   663,   283,   734,   426,   703,
     705,    99,   100,   435,    69,   626,   693,    32,   427,   696,
     709,   746,   714,   720,   788,    42,  -340,   239,   803,   804,
     264,   337,   337,   717,   805,   337,   247,   733,   597,   724,
     247,   785,   765,   704,   770,   793,   545,   548,   545,   797,
     783,   545,   504,   798,   545,  -202,   357,   250,   544,  -203,
     552,   809,  -204,   630,   675,   738,   721,   675,   727,   176,
     279,   253,   181,   543,   547,   551,   518,    86,   182,   221,
     747,    88,   549,   553,    90,   784,   631,    70,    71,   722,
      69,   486,   808,    75,   598,   428,   332,   241,   791,   358,
     703,   241,    94,    95,   247,   728,   597,   364,   662,   667,
     712,   261,   801,   802,    99,   100,   155,    22,   308,   548,
     452,   738,    22,    70,    71,   672,   369,   103,   104,    75,
     740,   309,   548,   794,   337,    99,   100,   160,   591,   181,
     512,   551,   220,   745,   181,   182,   333,   298,   414,   810,
     182,   723,   609,    22,   608,   729,    99,   100,   335,   749,
      90,     0,   598,   498,   752,   241,     0,   582,     0,   455,
     456,   457,   583,   458,   587,     0,    97,     0,    94,    95,
      34,    99,   100,   715,     0,   558,   299,   332,     0,   202,
     555,   263,    99,   100,   300,     0,   301,   302,    99,   100,
     160,   739,   303,   304,   305,     0,     0,   306,   543,   547,
     551,     0,    97,    99,   100,   187,   543,   547,   -40,    68,
       0,   681,     7,   543,   547,   202,   555,     0,    69,     0,
      70,    71,    72,    73,    74,     0,    75,   349,   334,   332,
       8,     9,    76,    10,    11,     0,    77,    99,   100,     0,
      13,    14,    15,    16,   336,    78,    18,    19,    20,    21,
      22,    23,    24,     0,    25,    79,    26,     0,     0,    80,
      27,    28,    81,    29,    82,     0,    83,    84,    30,    34,
      99,   100,    37,     0,    85,     0,    31,     0,   706,   333,
     334,    86,     0,    87,     0,    88,   551,    89,    90,    99,
     100,   335,    99,   100,   187,     0,   336,   650,   379,   380,
     447,   188,    91,     0,    92,    93,    94,    95,    96,    97,
       0,   275,     0,   276,    32,    33,     0,    98,   285,    34,
      99,   100,   101,     0,   102,   349,   334,    38,   514,   515,
     516,   103,   104,     0,     0,    99,   100,   171,   172,   277,
       0,     0,   336,   278,   175,   171,   172,   173,     0,     0,
     294,   362,   175,   171,   172,   277,     0,     0,   296,   367,
     175,     0,   314,     0,     0,   317,    72,    73,    74,   522,
     523,   516,   778,   779,     7,     0,   779,     0,     0,   779,
      69,     0,    70,    71,    72,    73,    74,     0,    75,   529,
     530,   516,     8,     9,    76,    10,    11,     0,    77,   379,
     380,   602,    13,    14,    15,    16,     0,     0,    18,    19,
      20,    21,    22,    23,    24,     0,    25,    79,    26,     0,
       0,    80,    27,    28,    81,    29,    82,     0,    83,    84,
      30,   687,   688,   689,     0,     0,    85,     0,    31,   778,
     779,     0,     0,    86,   778,    87,     0,    88,     0,    89,
      90,   687,   688,   692,   687,   688,   695,   778,     0,     0,
     778,   263,    99,   100,    91,     0,    92,    93,    94,    95,
      96,   754,   755,   756,     0,     0,    32,    33,     0,    98,
       0,    34,    99,   100,   386,   359,   102,     0,     7,    38,
     171,   172,   372,   103,   104,     0,   373,   175,    72,    73,
      74,   759,   760,   756,   772,   773,   756,     0,    76,    10,
      11,     0,    12,   775,   776,   756,    13,    14,    15,    16,
       0,     0,     0,    19,    20,    21,    22,   171,   172,   372,
      25,    79,     0,   416,   175,    80,     0,    28,    81,    29,
      82,     0,    83,     0,    30,     0,     0,   171,   172,   173,
      85,     0,    31,   542,   175,   171,   172,   372,     0,    87,
       0,   546,   175,    89,   171,   172,   372,   171,   172,   173,
     550,   175,     0,   657,   175,     0,     0,     0,    91,     0,
       0,    93,   171,   172,   372,    97,     0,     0,   657,   175,
      32,    33,     0,    98,     0,    34,    99,   100,   202,     0,
       0,   -42,   359,    38,   384,     7,   171,   172,   372,     0,
       0,     0,   664,   175,     0,    72,    73,    74,     0,     0,
       0,     0,     0,     0,     0,    76,    10,    11,     0,    12,
       0,     0,     0,    13,    14,    15,    16,     0,     0,     0,
      19,    20,    21,    22,   171,   172,   372,    25,    79,     0,
     670,   175,    80,     0,    28,    81,    29,    82,     0,    83,
       0,    30,     0,     0,   171,   172,   372,    85,     0,    31,
     680,   175,   171,   172,   173,     0,    87,     0,   664,   175,
      89,     0,     0,     0,  -264,  -264,  -264,  -264,     0,     0,
       0,     0,  -264,     0,     0,    91,     0,     0,    93,     0,
       0,     0,    97,   195,     0,     0,  -122,    32,    33,     0,
      98,     0,    34,    99,   100,   202,  -122,  -122,  -122,     0,
      38,     0,     0,     0,     0,     0,  -122,  -122,  -122,     0,
    -122,     0,     0,     0,  -122,  -122,  -122,  -122,     0,     0,
       0,  -122,  -122,  -122,     0,     0,     0,  -264,  -122,  -122,
       0,  -264,     0,  -122,  -264,  -122,  -122,  -122,  -122,     0,
    -122,     0,  -122,     0,     0,     0,     0,     0,  -122,     0,
    -122,     0,  -264,  -264,     0,     0,     0,  -122,     0,     0,
       0,  -122,     0,     0,     0,     0,     0,     0,     0,     0,
    -264,     0,     0,     0,     0,     0,  -122,  -264,  -264,  -122,
       0,    -2,     6,     0,     0,     7,     0,     0,  -122,  -122,
       0,  -122,     0,    34,    99,   100,    37,     0,     0,     0,
       0,  -122,   196,     8,     9,     0,    10,    11,     0,    12,
       0,     0,     0,    13,    14,    15,    16,   -10,    17,    18,
      19,    20,    21,    22,    23,    24,     0,    25,     0,    26,
       0,     0,   468,    27,    28,     7,    29,     0,     0,     0,
       0,    30,     0,     0,     0,     0,     0,     0,     0,    31,
       0,     0,     0,     0,     9,     0,    10,    11,     0,    12,
       0,     0,     0,    13,    14,    15,    16,   -86,     0,    18,
      19,    20,    21,    22,    23,    24,     0,    25,     0,    26,
       0,     0,   480,    27,    28,     7,    29,    32,    33,     0,
       0,    30,    34,    35,    36,    37,     0,     0,     0,    31,
      38,     0,     0,     0,     0,     0,    10,    11,     0,    12,
       0,     0,     0,    13,    14,    15,    16,   -99,     0,    18,
      19,    20,    21,    22,    23,    24,     0,    25,     0,    26,
       0,     0,     0,    27,    28,     0,    29,    32,    33,     0,
       0,    30,    34,    35,   469,     0,     0,     0,     0,    31,
      38,   470,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -164,  -164,  -164,  -164,     0,     0,     0,
       0,  -164,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   359,     0,     0,     7,     0,    32,    33,     0,
       0,     0,    34,    35,   481,    72,    73,    74,     0,     0,
      38,   482,     0,     0,     0,    76,    10,    11,     0,    12,
       0,     0,     0,    13,    14,    15,    16,     0,     0,     0,
      19,    20,    21,    22,     0,     0,  -164,    25,    79,     0,
    -164,     0,    80,  -164,    28,    81,    29,    82,     0,    83,
       0,    30,     0,     0,     0,     0,     0,    85,     0,    31,
     360,  -164,  -164,     0,     0,     0,    87,     0,     0,     0,
      89,     0,     0,     0,     0,     0,     0,     0,     0,  -164,
       0,     0,     0,     0,     0,    91,  -164,  -164,    93,     0,
       0,     0,    97,     0,     0,     0,     0,    32,    33,     0,
      98,     0,    34,    99,   100,   202,     7,     0,     0,     0,
      38,     0,     0,   229,    70,   230,    72,    73,    74,     0,
      75,     0,     0,     0,     8,     9,    76,    10,    11,     0,
      77,     0,     0,     0,    13,    14,    15,    16,     0,     0,
      18,    19,    20,    21,    22,    23,    24,     0,    25,    79,
      26,     0,     0,    80,    27,    28,    81,    29,    82,     0,
      83,    84,    30,     0,     0,     0,     0,     0,    85,     0,
      31,     0,     0,     0,     0,     0,     0,    87,     0,     0,
       0,    89,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    91,     0,    92,    93,
       0,     0,   231,     0,     0,     0,     0,     0,   232,    33,
       0,    98,   233,   234,   235,   236,   237,     7,   238,     0,
       0,    38,     0,     0,     0,    70,    71,    72,    73,    74,
       0,    75,     0,     0,     0,     8,     9,    76,    10,    11,
       0,    77,     0,     0,     0,    13,    14,    15,    16,     0,
       0,    18,    19,    20,    21,    22,    23,    24,     0,    25,
      79,    26,     0,     0,    80,    27,    28,    81,    29,    82,
       0,    83,    84,    30,     0,     0,     0,     0,     0,    85,
       0,    31,     0,     0,     0,     0,     0,     0,    87,     0,
       0,     0,    89,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    91,     0,    92,
      93,     0,     0,   592,     0,     0,     0,     0,     0,    32,
      33,     0,    98,   233,    34,   593,   236,   594,     7,   595,
       0,     0,    38,     0,     0,     0,     0,     0,    72,    73,
      74,     0,     0,     0,     0,     0,     8,     9,    76,    10,
      11,     0,    77,     0,     0,     0,    13,    14,    15,    16,
       0,     0,    18,    19,    20,    21,    22,    23,    24,     0,
      25,    79,    26,     0,     0,    80,    27,    28,    81,    29,
      82,     0,    83,    84,    30,     0,     0,     0,     0,     0,
      85,     0,    31,     0,     0,     0,     0,     0,     0,    87,
       0,     0,     0,    89,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    91,     0,
      92,    93,     0,     0,   533,     0,     0,     0,     0,     7,
      32,    33,     0,    98,   233,    34,   534,   236,   535,    72,
      73,    74,     0,    38,     0,     0,     0,     8,     9,    76,
      10,    11,     0,    77,     0,     0,     0,    13,    14,    15,
      16,     0,     0,    18,    19,    20,    21,    22,    23,    24,
       0,    25,    79,    26,     0,     0,    80,    27,    28,    81,
      29,    82,     0,    83,    84,    30,     0,     0,     0,     0,
       0,    85,     0,    31,     0,     0,     0,     0,     0,     0,
      87,     0,     0,     0,    89,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    91,
       0,    92,    93,     0,     0,   676,     0,     0,     0,     0,
       7,   232,    33,     0,    98,   233,   234,   534,   236,   535,
      72,    73,    74,     0,    38,     0,     0,     0,     8,     9,
      76,    10,    11,     0,    77,     0,     0,     0,    13,    14,
      15,    16,     0,     0,    18,    19,    20,    21,    22,    23,
      24,     0,    25,    79,    26,     0,     0,    80,    27,    28,
      81,    29,    82,     0,    83,    84,    30,     0,     0,     0,
       0,     0,    85,     0,    31,     0,     0,     0,     0,     0,
       0,    87,     0,     0,     0,    89,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      91,     0,    92,    93,     0,     0,   697,     0,     0,     0,
       0,     7,    32,    33,     0,    98,   233,    34,   698,   236,
     699,    72,    73,    74,     0,    38,     0,     0,     0,     8,
       9,    76,    10,    11,     0,    77,     0,     0,     0,    13,
      14,    15,    16,     0,     0,    18,    19,    20,    21,    22,
      23,    24,     0,    25,    79,    26,     0,     0,    80,    27,
      28,    81,    29,    82,     0,    83,    84,    30,     0,     0,
       0,     0,     0,    85,     0,    31,     0,     0,     0,     0,
       0,     0,    87,     0,     0,     0,    89,     0,     0,     0,
    -245,  -245,  -245,  -245,     0,     0,     0,     0,  -245,     0,
       0,    91,     0,    92,    93,     0,     0,   697,     0,     0,
       0,     0,     7,   232,    33,     0,    98,   233,   234,   789,
     236,   790,    72,    73,    74,     0,    38,     0,     0,     0,
       0,     0,    76,    10,    11,     0,    12,     0,     0,     0,
      13,    14,    15,    16,     0,     0,     0,    19,    20,    21,
      22,     0,     0,  -245,    25,    79,     0,  -245,     0,    80,
    -245,    28,    81,    29,    82,     0,    83,     0,    30,     0,
       0,     0,     0,     0,    85,     0,    31,     0,  -245,  -245,
       0,     0,     0,    87,     0,     0,     0,    89,     0,     0,
       0,  -183,  -183,  -183,  -183,     0,  -245,     0,     0,  -183,
       0,     0,    91,  -245,  -245,    93,     0,     0,     0,    97,
       0,     0,     0,     7,    32,    33,     0,    98,     0,    34,
      99,   100,   202,    72,    73,    74,     0,    38,     0,     0,
       0,     0,     0,    76,    10,    11,     0,    12,     0,     0,
       0,    13,    14,    15,    16,     0,     0,     0,    19,    20,
      21,    22,     0,     0,  -183,    25,    79,     0,  -183,     0,
      80,  -183,    28,    81,    29,    82,     0,    83,     0,    30,
       0,     0,     0,     0,     0,    85,     0,    31,     0,  -183,
    -183,     0,     0,     0,    87,     0,     0,     0,    89,     0,
       0,     0,  -250,  -250,  -250,  -250,     0,  -183,     0,     0,
    -250,     0,     0,    91,  -183,  -183,    93,     0,     0,     0,
      97,     0,     0,     0,     7,    32,    33,     0,    98,     0,
      34,    35,     0,   202,    72,    73,    74,     0,    38,     0,
       0,     0,     0,     0,    76,    10,    11,     0,    12,     0,
       0,     0,    13,    14,    15,    16,     0,     0,     0,    19,
      20,    21,    22,     0,     0,  -250,    25,    79,     0,  -250,
       0,    80,  -250,    28,    81,    29,    82,     0,    83,     0,
      30,     0,     0,     0,     0,     0,    85,     0,    31,     0,
    -250,  -250,     0,     0,     0,    87,     0,     0,    69,    89,
      70,    71,     0,     0,     0,     0,    75,     0,  -250,     0,
       0,     0,     0,     0,    91,  -250,  -250,    93,     0,     0,
       7,    97,     0,     0,     0,     0,    32,    33,     0,    98,
      72,    73,    74,     0,   202,     0,     0,     0,     0,    38,
      76,    10,    11,     0,    12,     0,     0,     0,    13,    14,
      15,    16,     0,     0,     0,    19,    20,    21,    22,     0,
       0,    86,    25,    79,     0,    88,     0,    80,    90,    28,
      81,    29,    82,     0,    83,     0,    30,     0,     0,     0,
       0,     0,    85,     0,    31,     0,    94,    95,     0,     0,
       0,    87,     0,     0,     0,    89,     0,     0,     0,     0,
       0,     0,     0,     0,   539,     0,     0,     0,     0,     0,
      91,   103,   104,    93,     0,     0,     7,    97,     0,     0,
       0,     0,   232,    33,     0,    98,    72,    73,    74,     0,
     202,     0,     0,     0,     0,    38,    76,    10,    11,     0,
     396,     0,     0,     0,    13,    14,    15,    16,     0,     0,
       0,    19,    20,    21,     0,     0,     0,     0,    25,    79,
       0,     0,     0,    80,     0,    28,    81,    29,    82,     0,
      83,     0,    30,     0,     0,     0,     0,     0,    85,     0,
      31,  -208,  -208,  -208,  -208,     0,     0,    87,     0,  -208,
       0,    89,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     7,     0,    91,     0,  -208,    93,
    -208,  -208,     0,     0,     0,     0,  -208,     0,    32,    33,
       0,    98,     0,     0,     0,    10,    11,     0,    12,     0,
       0,    38,    13,    14,    15,    16,     0,     0,     0,    19,
      20,    21,     0,     0,  -208,     0,    25,     0,  -208,     0,
       0,  -208,     0,    28,     0,    29,   531,   518,     0,     0,
      30,     0,     0,     0,  -249,  -249,  -249,  -249,    31,  -208,
    -208,  -208,  -249,     0,     0,  -208,     0,     0,  -208,     0,
       0,     0,     0,   771,   518,     0,     0,  -208,     0,     0,
       0,     0,     0,     0,  -208,  -208,  -208,  -208,     0,     0,
       0,  -247,  -247,  -247,  -247,     0,    32,    33,     0,  -247,
       0,     0,     0,     0,  -208,     0,     0,     0,     0,    38,
       0,  -208,  -208,     0,     0,     0,     0,  -249,     0,     0,
       0,  -249,     0,     0,  -249,  -251,  -251,  -251,  -251,     0,
       0,     0,     0,  -251,     0,     0,  -253,  -253,  -253,  -253,
       0,     0,  -249,  -249,  -253,  -252,  -252,  -252,  -252,     0,
       0,     0,     0,  -252,  -247,     0,     0,     0,  -247,     0,
    -249,  -247,     0,     0,     0,     0,     0,  -249,  -249,     0,
       0,     0,     0,  -248,  -248,  -248,  -248,     0,     0,  -247,
    -247,  -248,     0,     0,     0,     0,     0,     0,  -251,     0,
       0,     0,  -251,     0,     0,  -251,     0,  -247,     0,  -253,
       0,     0,     0,  -253,  -247,  -247,  -253,     0,  -252,     0,
       0,     0,  -252,  -251,  -251,  -252,     0,     0,  -185,  -185,
    -185,  -185,     0,     0,  -253,  -253,  -185,    69,     0,    70,
      71,  -251,     0,  -252,  -252,    75,  -248,     0,  -251,  -251,
    -248,     0,  -253,  -248,     0,     0,     0,     0,     0,  -253,
    -253,  -252,     0,     0,     0,     0,     0,     0,  -252,  -252,
       0,  -248,  -248,     0,     0,     0,     0,    69,     0,    70,
      71,     0,     0,     0,     0,    75,     0,     0,     0,  -248,
       0,  -185,     0,     0,     0,  -185,  -248,  -248,  -185,     0,
      86,     0,     0,     0,    88,     0,  -259,    90,  -259,  -259,
       0,     0,     0,     0,  -259,     0,  -185,  -185,     0,    69,
       0,    70,    71,     0,     0,    94,    95,    75,     0,    69,
       0,   735,   736,     0,  -185,     0,     0,    75,     0,     0,
      86,  -185,  -185,   627,    88,     0,     0,    90,     0,     0,
     103,   104,     0,     0,     0,     0,     0,     0,     0,    69,
       0,   766,   767,     0,     0,    94,    95,   768,     0,  -259,
       0,     0,     0,  -259,     0,     0,  -259,     0,     0,     0,
       0,     0,    86,   677,     0,     0,    88,     0,     0,    90,
     103,   104,    86,     0,  -259,  -259,    88,     0,     0,    90,
       0,     0,     0,     0,     0,     0,     0,    94,    95,     0,
       0,     0,  -259,     0,     0,     0,     0,    94,    95,  -259,
    -259,     0,    86,     0,     0,   702,    88,     0,     0,    90,
     569,   570,   103,   104,     0,   702,     0,   571,     0,   572,
     573,   574,   103,   104,     0,     0,     0,    94,    95,     0,
       0,     0,     0,   569,   570,   575,     0,   576,     0,   577,
     571,   578,   572,   573,   574,   769,     0,   579,   580,    84,
       0,     0,   103,   104,     0,     0,   569,   570,   575,     0,
     576,     0,   577,   571,   578,   572,   573,   574,     0,     0,
     579,   580,    84,     0,     0,     0,     0,     0,     0,     0,
       0,   575,     0,   576,     0,   577,    92,   578,     0,     0,
       0,     0,     0,   579,   580,     0,     0,     0,     0,     0,
       0,    34,    99,   100,   160,     0,     0,     0,     0,    92,
     581,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    34,    99,   100,   160,     0,     0,
       0,     0,   725,   806,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    34,    99,   100,
     160,     8,     9,     0,    10,    11,   726,    77,     0,     0,
       0,    13,    14,    15,    16,     0,     0,    18,    19,    20,
       0,    22,    23,    24,     0,    25,     0,    26,     0,     0,
       0,    27,    28,     0,    29,     0,     0,     0,    84,    30,
       0,     0,     0,     0,     0,     0,     0,    31,     0,     0,
       8,     9,     0,    10,    11,     0,    77,     0,     0,     0,
      13,    14,    15,    16,     0,     0,    18,    19,    20,     0,
      22,    23,    24,     0,    25,    92,    26,     0,     0,   622,
      27,    28,     0,    29,     0,   299,    33,    84,    30,   233,
     263,   534,   236,   535,     0,     0,    31,     0,    38,     8,
       9,     0,    10,    11,     0,    77,     0,     0,     0,    13,
      14,    15,    16,     0,     0,    18,    19,    20,     0,    22,
      23,    24,     0,    25,    92,    26,     0,     0,   697,    27,
      28,     0,    29,     0,   299,    33,    84,    30,   233,   263,
     731,   236,   732,     0,     0,    31,     0,    38,     0,     0,
      10,    11,     0,    12,     0,     0,     0,    13,    14,    15,
      16,     0,     0,     0,    19,    20,     0,     0,     0,     0,
       0,    25,     0,    92,     0,     0,     0,   761,    28,     0,
      29,     0,     0,   299,    33,    30,     0,   233,   263,   762,
     236,   763,     0,    31,     0,     0,    38,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   299,    33,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    38
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-513)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       3,     4,     4,     3,    30,    80,    73,     4,    82,   140,
       7,    32,     4,    34,     4,    12,     3,     4,    82,   164,
     171,    82,   173,    82,    21,    34,    95,    28,    29,   165,
     143,   144,    51,    30,    32,   165,    34,    32,    82,    34,
       4,   366,    84,    32,    79,    34,    81,     4,    83,   253,
     164,   347,    82,    21,    51,   268,   188,   190,   354,    51,
       3,     4,   164,   371,   104,    38,     3,     4,   102,   366,
      82,   371,    90,     3,    64,    78,    78,    13,   376,    82,
      77,    78,    82,   172,   173,   330,    78,    84,    78,    17,
     223,    78,    61,    63,     3,     4,     0,    95,   140,    59,
      95,   347,   408,    18,     4,   121,    95,   413,   354,    95,
      12,    13,   119,   358,    78,   131,    18,     3,     4,   631,
     117,    78,    64,    13,     3,     4,   277,    53,    18,    55,
     455,   119,     0,   458,     7,    78,    96,   140,   199,     7,
     119,    78,    68,   140,   171,   172,    13,   293,    12,    13,
     171,   226,   173,   366,    18,    12,    13,   119,    11,   272,
      13,    18,   275,   232,   100,   234,   166,   164,   165,    78,
      61,    62,    63,   170,    65,   117,   171,   172,    78,   238,
      36,   294,   171,   172,   119,   188,   188,   184,   277,    12,
      13,   188,    78,   119,   263,    18,   188,   166,   188,    78,
     128,   188,   347,     1,   317,    18,   121,   122,    42,   253,
     722,   232,    18,   234,   116,   114,    42,   117,   354,   544,
     514,   372,   516,   253,   188,   234,     1,     0,   522,   527,
     299,   188,    85,    86,    13,   529,   382,   383,    36,   209,
      38,   549,    11,   255,    13,   188,    44,   544,   234,   549,
      48,   188,   286,   110,   552,    11,   277,    13,   115,   110,
       0,    36,   394,    38,   115,   263,   269,   101,   263,    44,
     125,   126,   269,    48,   263,   101,   110,   263,    85,   188,
     114,   115,   472,   372,   253,     0,   320,   321,   114,    82,
      83,    84,   115,     0,   484,   112,   113,   114,   119,   515,
     516,   299,   188,    91,   299,   122,    11,   523,    13,   188,
     299,   380,   381,   426,   530,   376,   121,   392,   377,   292,
      96,   511,   120,   326,   383,   328,   326,    91,   328,    85,
      86,   544,   329,   658,    86,   111,   112,   113,    86,   326,
     330,   328,    12,    13,   121,   120,   671,   408,    18,   408,
     347,   372,   413,   661,   413,   324,   652,   354,   379,   380,
     381,   329,   331,    11,   515,    13,   674,   108,   358,   356,
     379,   445,   381,   376,     7,   377,   376,   126,   447,   530,
     406,   379,   380,   326,   379,   328,   532,   446,   502,   448,
     379,   394,   394,   125,   380,   381,   326,   394,   328,   396,
     502,   445,   394,   121,   394,   408,   652,   394,   408,   406,
     413,   717,   452,   413,   406,   445,   406,   326,    11,   328,
      13,    13,   626,   721,   116,   117,   447,   383,    95,    11,
     394,    13,   122,   436,   523,   104,   105,   394,   447,   436,
     326,   530,   445,   576,   446,   658,    11,   326,    13,   328,
      42,   394,   449,   527,   119,   751,   399,   394,   671,   518,
     754,   447,   756,    85,    86,   759,   527,    85,    86,   528,
     112,   113,   114,   532,    11,    17,    13,   121,   772,   785,
     122,   775,    74,   527,    76,   394,   121,   514,   515,   516,
     121,   552,   448,   127,   553,   522,   523,   527,    81,   318,
     319,    84,   523,   578,    87,   502,    89,   652,   394,   494,
     495,   496,   648,   649,   499,   394,   647,    52,   648,   514,
     112,   113,   114,   128,   527,   514,   528,   527,    70,    71,
      72,    86,    13,   602,    81,   649,   595,   105,   130,   755,
     756,    86,    81,   562,   760,    84,    15,    16,    87,   552,
      89,   553,   552,   114,   580,    85,   630,   773,    12,    13,
     776,    42,   518,   122,    18,   562,   630,   102,   103,   121,
     562,    13,   639,    14,   116,   117,   532,   112,   113,   114,
     606,   602,   626,   580,   119,   127,   630,   129,    12,    13,
       5,   665,   589,   602,    18,    76,   626,   589,    67,   119,
     630,   665,    12,    13,   755,   647,   751,    85,    18,   606,
       8,    82,    83,    84,   606,   751,   602,    88,    89,   688,
     689,   665,     8,   692,   567,   776,   695,   630,    97,   631,
     122,   112,   113,   114,    10,   665,     8,   106,   107,     8,
     119,   642,   585,   599,   719,   645,   121,   721,    12,    13,
     647,   648,   649,   121,    18,   652,   717,   721,   717,   116,
     721,   121,   665,   722,   666,    13,   687,   688,   689,   122,
     705,   692,   104,    50,   695,    86,   645,   721,   687,    86,
     689,   794,    86,   692,   773,    13,   695,   776,   606,   687,
     688,   721,   687,   379,   380,   381,    86,    73,   687,    78,
     645,    77,   688,   689,    80,   709,   692,    12,    13,   695,
      10,   328,   787,    18,   717,   268,    52,   717,   721,   169,
     722,   721,    98,    99,   785,   606,   785,   754,   755,   756,
     578,    83,   759,   760,   112,   113,   114,    42,   140,   760,
     116,    13,    42,    12,    13,   772,   773,   123,   124,    18,
     638,   140,   773,   729,   751,   112,   113,   114,   784,   754,
     747,   447,   119,   641,   759,   754,   102,    67,   229,   797,
     759,   603,   436,    42,   431,   608,   112,   113,   114,   648,
      80,    -1,   785,   333,   649,   785,    -1,   784,    -1,    61,
      62,    63,   784,    65,   784,    -1,   101,    -1,    98,    99,
     111,   112,   113,   114,    -1,   110,   106,    52,    -1,   114,
     115,   111,   112,   113,   114,    -1,   116,   117,   112,   113,
     114,    93,   122,   123,   124,    -1,    -1,   127,   514,   515,
     516,    -1,   101,   112,   113,   114,   522,   523,     0,     1,
      -1,   110,     4,   529,   530,   114,   115,    -1,    10,    -1,
      12,    13,    14,    15,    16,    -1,    18,   102,   103,    52,
      22,    23,    24,    25,    26,    -1,    28,   112,   113,    -1,
      32,    33,    34,    35,   119,    37,    38,    39,    40,    41,
      42,    43,    44,    -1,    46,    47,    48,    -1,    -1,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,   111,
     112,   113,   114,    -1,    66,    -1,    68,    -1,   120,   102,
     103,    73,    -1,    75,    -1,    77,   602,    79,    80,   112,
     113,   114,   112,   113,   114,    -1,   119,   120,    82,    83,
      84,   121,    94,    -1,    96,    97,    98,    99,   100,   101,
      -1,    91,    -1,    93,   106,   107,    -1,   109,    98,   111,
     112,   113,   114,    -1,   116,   102,   103,   119,    82,    83,
      84,   123,   124,    -1,    -1,   112,   113,    82,    83,    84,
      -1,    -1,   119,    88,    89,    82,    83,    84,    -1,    -1,
     130,    88,    89,    82,    83,    84,    -1,    -1,   138,    88,
      89,    -1,   142,    -1,    -1,   145,    14,    15,    16,    82,
      83,    84,   688,   689,     4,    -1,   692,    -1,    -1,   695,
      10,    -1,    12,    13,    14,    15,    16,    -1,    18,    82,
      83,    84,    22,    23,    24,    25,    26,    -1,    28,    82,
      83,    84,    32,    33,    34,    35,    -1,    -1,    38,    39,
      40,    41,    42,    43,    44,    -1,    46,    47,    48,    -1,
      -1,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    82,    83,    84,    -1,    -1,    66,    -1,    68,   755,
     756,    -1,    -1,    73,   760,    75,    -1,    77,    -1,    79,
      80,    82,    83,    84,    82,    83,    84,   773,    -1,    -1,
     776,   111,   112,   113,    94,    -1,    96,    97,    98,    99,
     100,    82,    83,    84,    -1,    -1,   106,   107,    -1,   109,
      -1,   111,   112,   113,   114,     1,   116,    -1,     4,   119,
      82,    83,    84,   123,   124,    -1,    88,    89,    14,    15,
      16,    82,    83,    84,    82,    83,    84,    -1,    24,    25,
      26,    -1,    28,    82,    83,    84,    32,    33,    34,    35,
      -1,    -1,    -1,    39,    40,    41,    42,    82,    83,    84,
      46,    47,    -1,    88,    89,    51,    -1,    53,    54,    55,
      56,    -1,    58,    -1,    60,    -1,    -1,    82,    83,    84,
      66,    -1,    68,    88,    89,    82,    83,    84,    -1,    75,
      -1,    88,    89,    79,    82,    83,    84,    82,    83,    84,
      88,    89,    -1,    88,    89,    -1,    -1,    -1,    94,    -1,
      -1,    97,    82,    83,    84,   101,    -1,    -1,    88,    89,
     106,   107,    -1,   109,    -1,   111,   112,   113,   114,    -1,
      -1,     0,     1,   119,   120,     4,    82,    83,    84,    -1,
      -1,    -1,    88,    89,    -1,    14,    15,    16,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,    25,    26,    -1,    28,
      -1,    -1,    -1,    32,    33,    34,    35,    -1,    -1,    -1,
      39,    40,    41,    42,    82,    83,    84,    46,    47,    -1,
      88,    89,    51,    -1,    53,    54,    55,    56,    -1,    58,
      -1,    60,    -1,    -1,    82,    83,    84,    66,    -1,    68,
      88,    89,    82,    83,    84,    -1,    75,    -1,    88,    89,
      79,    -1,    -1,    -1,    10,    11,    12,    13,    -1,    -1,
      -1,    -1,    18,    -1,    -1,    94,    -1,    -1,    97,    -1,
      -1,    -1,   101,     1,    -1,    -1,     4,   106,   107,    -1,
     109,    -1,   111,   112,   113,   114,    14,    15,    16,    -1,
     119,    -1,    -1,    -1,    -1,    -1,    24,    25,    26,    -1,
      28,    -1,    -1,    -1,    32,    33,    34,    35,    -1,    -1,
      -1,    39,    40,    41,    -1,    -1,    -1,    73,    46,    47,
      -1,    77,    -1,    51,    80,    53,    54,    55,    56,    -1,
      58,    -1,    60,    -1,    -1,    -1,    -1,    -1,    66,    -1,
      68,    -1,    98,    99,    -1,    -1,    -1,    75,    -1,    -1,
      -1,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     116,    -1,    -1,    -1,    -1,    -1,    94,   123,   124,    97,
      -1,     0,     1,    -1,    -1,     4,    -1,    -1,   106,   107,
      -1,   109,    -1,   111,   112,   113,   114,    -1,    -1,    -1,
      -1,   119,   120,    22,    23,    -1,    25,    26,    -1,    28,
      -1,    -1,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    -1,    46,    -1,    48,
      -1,    -1,     1,    52,    53,     4,    55,    -1,    -1,    -1,
      -1,    60,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    23,    -1,    25,    26,    -1,    28,
      -1,    -1,    -1,    32,    33,    34,    35,    36,    -1,    38,
      39,    40,    41,    42,    43,    44,    -1,    46,    -1,    48,
      -1,    -1,     1,    52,    53,     4,    55,   106,   107,    -1,
      -1,    60,   111,   112,   113,   114,    -1,    -1,    -1,    68,
     119,    -1,    -1,    -1,    -1,    -1,    25,    26,    -1,    28,
      -1,    -1,    -1,    32,    33,    34,    35,    36,    -1,    38,
      39,    40,    41,    42,    43,    44,    -1,    46,    -1,    48,
      -1,    -1,    -1,    52,    53,    -1,    55,   106,   107,    -1,
      -1,    60,   111,   112,   113,    -1,    -1,    -1,    -1,    68,
     119,   120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    11,    12,    13,    -1,    -1,    -1,
      -1,    18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,     4,    -1,   106,   107,    -1,
      -1,    -1,   111,   112,   113,    14,    15,    16,    -1,    -1,
     119,   120,    -1,    -1,    -1,    24,    25,    26,    -1,    28,
      -1,    -1,    -1,    32,    33,    34,    35,    -1,    -1,    -1,
      39,    40,    41,    42,    -1,    -1,    73,    46,    47,    -1,
      77,    -1,    51,    80,    53,    54,    55,    56,    -1,    58,
      -1,    60,    -1,    -1,    -1,    -1,    -1,    66,    -1,    68,
      69,    98,    99,    -1,    -1,    -1,    75,    -1,    -1,    -1,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,
      -1,    -1,    -1,    -1,    -1,    94,   123,   124,    97,    -1,
      -1,    -1,   101,    -1,    -1,    -1,    -1,   106,   107,    -1,
     109,    -1,   111,   112,   113,   114,     4,    -1,    -1,    -1,
     119,    -1,    -1,    11,    12,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      28,    -1,    -1,    -1,    32,    33,    34,    35,    -1,    -1,
      38,    39,    40,    41,    42,    43,    44,    -1,    46,    47,
      48,    -1,    -1,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    -1,    -1,    -1,    -1,    -1,    66,    -1,
      68,    -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,    -1,
      -1,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    -1,    96,    97,
      -1,    -1,   100,    -1,    -1,    -1,    -1,    -1,   106,   107,
      -1,   109,   110,   111,   112,   113,   114,     4,   116,    -1,
      -1,   119,    -1,    -1,    -1,    12,    13,    14,    15,    16,
      -1,    18,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      -1,    28,    -1,    -1,    -1,    32,    33,    34,    35,    -1,
      -1,    38,    39,    40,    41,    42,    43,    44,    -1,    46,
      47,    48,    -1,    -1,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    -1,    -1,    -1,    -1,    -1,    66,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,
      -1,    -1,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    -1,    96,
      97,    -1,    -1,   100,    -1,    -1,    -1,    -1,    -1,   106,
     107,    -1,   109,   110,   111,   112,   113,   114,     4,   116,
      -1,    -1,   119,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    -1,    28,    -1,    -1,    -1,    32,    33,    34,    35,
      -1,    -1,    38,    39,    40,    41,    42,    43,    44,    -1,
      46,    47,    48,    -1,    -1,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    -1,    -1,    -1,    -1,    -1,
      66,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,    75,
      -1,    -1,    -1,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    -1,
      96,    97,    -1,    -1,   100,    -1,    -1,    -1,    -1,     4,
     106,   107,    -1,   109,   110,   111,   112,   113,   114,    14,
      15,    16,    -1,   119,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    -1,    28,    -1,    -1,    -1,    32,    33,    34,
      35,    -1,    -1,    38,    39,    40,    41,    42,    43,    44,
      -1,    46,    47,    48,    -1,    -1,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    -1,    -1,    -1,    -1,
      -1,    66,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      75,    -1,    -1,    -1,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      -1,    96,    97,    -1,    -1,   100,    -1,    -1,    -1,    -1,
       4,   106,   107,    -1,   109,   110,   111,   112,   113,   114,
      14,    15,    16,    -1,   119,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    -1,    28,    -1,    -1,    -1,    32,    33,
      34,    35,    -1,    -1,    38,    39,    40,    41,    42,    43,
      44,    -1,    46,    47,    48,    -1,    -1,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    -1,    -1,    -1,
      -1,    -1,    66,    -1,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    75,    -1,    -1,    -1,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    -1,    96,    97,    -1,    -1,   100,    -1,    -1,    -1,
      -1,     4,   106,   107,    -1,   109,   110,   111,   112,   113,
     114,    14,    15,    16,    -1,   119,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    -1,    28,    -1,    -1,    -1,    32,
      33,    34,    35,    -1,    -1,    38,    39,    40,    41,    42,
      43,    44,    -1,    46,    47,    48,    -1,    -1,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    -1,    -1,
      -1,    -1,    -1,    66,    -1,    68,    -1,    -1,    -1,    -1,
      -1,    -1,    75,    -1,    -1,    -1,    79,    -1,    -1,    -1,
      10,    11,    12,    13,    -1,    -1,    -1,    -1,    18,    -1,
      -1,    94,    -1,    96,    97,    -1,    -1,   100,    -1,    -1,
      -1,    -1,     4,   106,   107,    -1,   109,   110,   111,   112,
     113,   114,    14,    15,    16,    -1,   119,    -1,    -1,    -1,
      -1,    -1,    24,    25,    26,    -1,    28,    -1,    -1,    -1,
      32,    33,    34,    35,    -1,    -1,    -1,    39,    40,    41,
      42,    -1,    -1,    73,    46,    47,    -1,    77,    -1,    51,
      80,    53,    54,    55,    56,    -1,    58,    -1,    60,    -1,
      -1,    -1,    -1,    -1,    66,    -1,    68,    -1,    98,    99,
      -1,    -1,    -1,    75,    -1,    -1,    -1,    79,    -1,    -1,
      -1,    10,    11,    12,    13,    -1,   116,    -1,    -1,    18,
      -1,    -1,    94,   123,   124,    97,    -1,    -1,    -1,   101,
      -1,    -1,    -1,     4,   106,   107,    -1,   109,    -1,   111,
     112,   113,   114,    14,    15,    16,    -1,   119,    -1,    -1,
      -1,    -1,    -1,    24,    25,    26,    -1,    28,    -1,    -1,
      -1,    32,    33,    34,    35,    -1,    -1,    -1,    39,    40,
      41,    42,    -1,    -1,    73,    46,    47,    -1,    77,    -1,
      51,    80,    53,    54,    55,    56,    -1,    58,    -1,    60,
      -1,    -1,    -1,    -1,    -1,    66,    -1,    68,    -1,    98,
      99,    -1,    -1,    -1,    75,    -1,    -1,    -1,    79,    -1,
      -1,    -1,    10,    11,    12,    13,    -1,   116,    -1,    -1,
      18,    -1,    -1,    94,   123,   124,    97,    -1,    -1,    -1,
     101,    -1,    -1,    -1,     4,   106,   107,    -1,   109,    -1,
     111,   112,    -1,   114,    14,    15,    16,    -1,   119,    -1,
      -1,    -1,    -1,    -1,    24,    25,    26,    -1,    28,    -1,
      -1,    -1,    32,    33,    34,    35,    -1,    -1,    -1,    39,
      40,    41,    42,    -1,    -1,    73,    46,    47,    -1,    77,
      -1,    51,    80,    53,    54,    55,    56,    -1,    58,    -1,
      60,    -1,    -1,    -1,    -1,    -1,    66,    -1,    68,    -1,
      98,    99,    -1,    -1,    -1,    75,    -1,    -1,    10,    79,
      12,    13,    -1,    -1,    -1,    -1,    18,    -1,   116,    -1,
      -1,    -1,    -1,    -1,    94,   123,   124,    97,    -1,    -1,
       4,   101,    -1,    -1,    -1,    -1,   106,   107,    -1,   109,
      14,    15,    16,    -1,   114,    -1,    -1,    -1,    -1,   119,
      24,    25,    26,    -1,    28,    -1,    -1,    -1,    32,    33,
      34,    35,    -1,    -1,    -1,    39,    40,    41,    42,    -1,
      -1,    73,    46,    47,    -1,    77,    -1,    51,    80,    53,
      54,    55,    56,    -1,    58,    -1,    60,    -1,    -1,    -1,
      -1,    -1,    66,    -1,    68,    -1,    98,    99,    -1,    -1,
      -1,    75,    -1,    -1,    -1,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,
      94,   123,   124,    97,    -1,    -1,     4,   101,    -1,    -1,
      -1,    -1,   106,   107,    -1,   109,    14,    15,    16,    -1,
     114,    -1,    -1,    -1,    -1,   119,    24,    25,    26,    -1,
      28,    -1,    -1,    -1,    32,    33,    34,    35,    -1,    -1,
      -1,    39,    40,    41,    -1,    -1,    -1,    -1,    46,    47,
      -1,    -1,    -1,    51,    -1,    53,    54,    55,    56,    -1,
      58,    -1,    60,    -1,    -1,    -1,    -1,    -1,    66,    -1,
      68,    10,    11,    12,    13,    -1,    -1,    75,    -1,    18,
      -1,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     4,    -1,    94,    -1,    10,    97,
      12,    13,    -1,    -1,    -1,    -1,    18,    -1,   106,   107,
      -1,   109,    -1,    -1,    -1,    25,    26,    -1,    28,    -1,
      -1,   119,    32,    33,    34,    35,    -1,    -1,    -1,    39,
      40,    41,    -1,    -1,    73,    -1,    46,    -1,    77,    -1,
      -1,    80,    -1,    53,    -1,    55,    85,    86,    -1,    -1,
      60,    -1,    -1,    -1,    10,    11,    12,    13,    68,    98,
      99,    73,    18,    -1,    -1,    77,    -1,    -1,    80,    -1,
      -1,    -1,    -1,    85,    86,    -1,    -1,   116,    -1,    -1,
      -1,    -1,    -1,    -1,   123,   124,    98,    99,    -1,    -1,
      -1,    10,    11,    12,    13,    -1,   106,   107,    -1,    18,
      -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,   119,
      -1,   123,   124,    -1,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    77,    -1,    -1,    80,    10,    11,    12,    13,    -1,
      -1,    -1,    -1,    18,    -1,    -1,    10,    11,    12,    13,
      -1,    -1,    98,    99,    18,    10,    11,    12,    13,    -1,
      -1,    -1,    -1,    18,    73,    -1,    -1,    -1,    77,    -1,
     116,    80,    -1,    -1,    -1,    -1,    -1,   123,   124,    -1,
      -1,    -1,    -1,    10,    11,    12,    13,    -1,    -1,    98,
      99,    18,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,
      -1,    -1,    77,    -1,    -1,    80,    -1,   116,    -1,    73,
      -1,    -1,    -1,    77,   123,   124,    80,    -1,    73,    -1,
      -1,    -1,    77,    98,    99,    80,    -1,    -1,    10,    11,
      12,    13,    -1,    -1,    98,    99,    18,    10,    -1,    12,
      13,   116,    -1,    98,    99,    18,    73,    -1,   123,   124,
      77,    -1,   116,    80,    -1,    -1,    -1,    -1,    -1,   123,
     124,   116,    -1,    -1,    -1,    -1,    -1,    -1,   123,   124,
      -1,    98,    99,    -1,    -1,    -1,    -1,    10,    -1,    12,
      13,    -1,    -1,    -1,    -1,    18,    -1,    -1,    -1,   116,
      -1,    73,    -1,    -1,    -1,    77,   123,   124,    80,    -1,
      73,    -1,    -1,    -1,    77,    -1,    10,    80,    12,    13,
      -1,    -1,    -1,    -1,    18,    -1,    98,    99,    -1,    10,
      -1,    12,    13,    -1,    -1,    98,    99,    18,    -1,    10,
      -1,    12,    13,    -1,   116,    -1,    -1,    18,    -1,    -1,
      73,   123,   124,   116,    77,    -1,    -1,    80,    -1,    -1,
     123,   124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    12,    13,    -1,    -1,    98,    99,    18,    -1,    73,
      -1,    -1,    -1,    77,    -1,    -1,    80,    -1,    -1,    -1,
      -1,    -1,    73,   116,    -1,    -1,    77,    -1,    -1,    80,
     123,   124,    73,    -1,    98,    99,    77,    -1,    -1,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    99,    -1,
      -1,    -1,   116,    -1,    -1,    -1,    -1,    98,    99,   123,
     124,    -1,    73,    -1,    -1,   116,    77,    -1,    -1,    80,
      20,    21,   123,   124,    -1,   116,    -1,    27,    -1,    29,
      30,    31,   123,   124,    -1,    -1,    -1,    98,    99,    -1,
      -1,    -1,    -1,    20,    21,    45,    -1,    47,    -1,    49,
      27,    51,    29,    30,    31,   116,    -1,    57,    58,    59,
      -1,    -1,   123,   124,    -1,    -1,    20,    21,    45,    -1,
      47,    -1,    49,    27,    51,    29,    30,    31,    -1,    -1,
      57,    58,    59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    47,    -1,    49,    96,    51,    -1,    -1,
      -1,    -1,    -1,    57,    58,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,    -1,    -1,    -1,    -1,    96,
     120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,    -1,    -1,
      -1,    -1,    96,   120,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,    22,    23,    -1,    25,    26,   120,    28,    -1,    -1,
      -1,    32,    33,    34,    35,    -1,    -1,    38,    39,    40,
      -1,    42,    43,    44,    -1,    46,    -1,    48,    -1,    -1,
      -1,    52,    53,    -1,    55,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,
      22,    23,    -1,    25,    26,    -1,    28,    -1,    -1,    -1,
      32,    33,    34,    35,    -1,    -1,    38,    39,    40,    -1,
      42,    43,    44,    -1,    46,    96,    48,    -1,    -1,   100,
      52,    53,    -1,    55,    -1,   106,   107,    59,    60,   110,
     111,   112,   113,   114,    -1,    -1,    68,    -1,   119,    22,
      23,    -1,    25,    26,    -1,    28,    -1,    -1,    -1,    32,
      33,    34,    35,    -1,    -1,    38,    39,    40,    -1,    42,
      43,    44,    -1,    46,    96,    48,    -1,    -1,   100,    52,
      53,    -1,    55,    -1,   106,   107,    59,    60,   110,   111,
     112,   113,   114,    -1,    -1,    68,    -1,   119,    -1,    -1,
      25,    26,    -1,    28,    -1,    -1,    -1,    32,    33,    34,
      35,    -1,    -1,    -1,    39,    40,    -1,    -1,    -1,    -1,
      -1,    46,    -1,    96,    -1,    -1,    -1,   100,    53,    -1,
      55,    -1,    -1,   106,   107,    60,    -1,   110,   111,   112,
     113,   114,    -1,    68,    -1,    -1,   119,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   106,   107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   119
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    90,   133,   135,   134,     0,     1,     4,    22,    23,
      25,    26,    28,    32,    33,    34,    35,    37,    38,    39,
      40,    41,    42,    43,    44,    46,    48,    52,    53,    55,
      60,    68,   106,   107,   111,   112,   113,   114,   119,   136,
     137,   139,   143,   147,   148,   155,   158,   161,   165,   166,
     167,   170,   174,   180,   181,   182,   188,   190,   191,   215,
     217,   218,   219,   220,   221,   225,   308,   310,     1,    10,
      12,    13,    14,    15,    16,    18,    24,    28,    37,    47,
      51,    54,    56,    58,    59,    66,    73,    75,    77,    79,
      80,    94,    96,    97,    98,    99,   100,   101,   109,   112,
     113,   114,   116,   123,   124,   138,   141,   143,   144,   149,
     150,   155,   158,   161,   165,   172,   175,   176,   177,   178,
     179,   183,   184,   188,   227,   238,   240,   241,   246,   247,
     248,   253,   254,   255,   257,   259,   260,   266,   267,   268,
     273,   280,   287,   289,   290,   291,   292,   293,   300,   301,
     302,   303,   304,   308,   310,   114,   138,   242,   119,   119,
     114,   138,   243,   242,   311,   309,   119,   174,   174,   243,
     173,    82,    83,    84,    88,    89,   193,   199,   200,   204,
     205,   206,   214,   204,   173,    36,   146,   114,   121,   138,
     196,   197,   198,   228,   119,     1,   120,   141,   148,   171,
       7,   222,   114,   175,   183,   188,   310,   191,   184,   186,
      13,    18,    18,   125,   126,   263,   264,   265,   263,   114,
     119,   144,   196,   235,   236,   197,   239,   196,   237,    11,
      13,   100,   106,   110,   111,   112,   113,   114,   116,   140,
     142,   143,   150,   155,   158,   161,   165,   178,   184,   189,
     190,   212,   213,   218,   244,   245,   252,   277,   303,   308,
     310,   237,    96,   111,   138,   185,   211,   213,   249,   286,
      13,   275,   276,   277,   278,   276,   276,    84,    88,   193,
     194,   206,   207,   208,   214,   276,   116,   302,    13,   271,
     271,   141,   176,    85,   276,   256,   276,   306,    67,   106,
     114,   116,   117,   122,   123,   124,   127,   211,   252,   260,
     261,   270,   272,   310,   276,   256,   256,   276,   116,   117,
      17,   128,    13,    18,   305,    91,   156,    91,   159,   121,
     216,   226,    52,   102,   103,   114,   119,   138,   312,   313,
     315,   316,   318,   320,   321,   323,   326,   327,   328,   102,
     313,   315,   317,   318,   327,   139,   162,   175,   216,     1,
      69,   176,    88,   201,   203,   205,   209,    88,   202,   203,
     208,   210,    84,    88,   203,   206,   209,   210,   214,    82,
      83,    84,    86,    86,   120,   119,   114,   141,   149,   183,
     188,   310,   122,   228,   121,   108,    28,   168,   178,   223,
       7,   191,   125,   126,   121,    95,   154,   228,   121,   197,
     230,   231,   232,   121,   279,   279,    88,   193,   207,   207,
     303,   189,   277,   121,   119,    67,    97,   107,   215,   250,
     251,   268,    13,    74,    76,   114,   130,   138,   281,   283,
     285,   310,   256,   128,   256,   209,   210,    84,    86,   173,
     292,   256,   116,   257,   258,    61,    62,    63,    65,   295,
     127,   307,   256,   301,   301,   302,   302,   175,     1,   113,
     120,   139,   157,   158,   161,   164,   165,   188,   308,   310,
       1,   113,   120,   139,   160,   161,   164,   188,   308,   310,
     242,   186,   175,   319,    81,    84,    87,    89,   324,    81,
     324,   325,   322,   314,   104,   105,   316,   326,   328,     1,
     120,   163,   165,   186,    82,    83,    84,    85,    86,   267,
     268,   269,    82,    83,    85,   274,   278,   209,   210,    82,
      83,    85,    86,   100,   112,   114,   140,   142,   310,   116,
     257,   303,    88,   192,   204,   205,    88,   192,   205,   207,
      88,   192,   204,   207,   110,   115,   195,   292,   110,   195,
     292,   303,   145,   197,   149,   169,   188,   224,   114,    20,
      21,    27,    29,    30,    31,    45,    47,    49,    51,    57,
      58,   120,   138,   141,   151,   152,   153,   184,   229,   233,
     234,   243,   100,   112,   114,   116,   244,   303,   310,    85,
     244,   122,    84,   121,    13,   299,   187,   256,   306,   283,
      17,    70,    71,    72,   116,   117,   127,   129,   282,   284,
      13,   100,   100,   140,   190,   212,   218,   116,   257,   303,
     204,   207,   110,   195,   303,   271,   267,   267,   294,   121,
     131,   262,     5,   146,   146,   119,   325,   325,   325,   325,
     120,   315,   327,   328,   329,    85,   146,    88,   201,   205,
     209,   202,   203,   209,    88,   201,   202,   203,   195,   303,
      88,   201,   203,   210,   202,   210,   100,   116,   257,   303,
      88,   110,   195,   303,    12,    13,    18,    82,    83,    84,
       8,   269,    84,     8,   274,    84,     8,   100,   112,   114,
     142,   310,   116,   257,   303,   122,   120,   141,   148,   119,
     188,   228,   230,   243,   188,   114,   141,   121,   303,   110,
     195,   204,   207,   299,   116,    96,   120,   153,   234,   307,
      18,   112,   114,   212,   310,    12,    13,   304,    13,    93,
     295,   296,   297,   298,   263,   275,   174,   162,   211,   317,
     313,   327,   329,   328,    82,    83,    84,   269,   274,    82,
      83,   100,   112,   114,   212,   310,    12,    13,    18,   116,
     257,    85,    82,    83,    18,    82,    83,   192,   192,   192,
      12,    13,    18,   196,   154,   121,   244,   122,   197,   112,
     114,   310,   304,    13,   262,    64,   117,   122,    50,   288,
     120,   203,   203,    12,    13,    18,   120,   244,   197,   256,
     298
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, parser, retval, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (YYID (N))                                                     \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (YYID (0))
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

__attribute__((__unused__))
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
#else
static unsigned
yy_location_print_ (yyo, yylocp)
    FILE *yyo;
    YYLTYPE const * const yylocp;
#endif
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += fprintf (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += fprintf (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += fprintf (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += fprintf (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += fprintf (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc, parser)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, parser, retval); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Lily_parser *parser, SCM *retval)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, parser, retval)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    Lily_parser *parser;
    SCM *retval;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (parser);
  YYUSE (retval);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Lily_parser *parser, SCM *retval)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, parser, retval)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    Lily_parser *parser;
    SCM *retval;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, parser, retval);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, Lily_parser *parser, SCM *retval)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, parser, retval)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    Lily_parser *parser;
    SCM *retval;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , parser, retval);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, parser, retval); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, Lily_parser *parser, SCM *retval)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, parser, retval)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    Lily_parser *parser;
    SCM *retval;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (parser);
  YYUSE (retval);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (Lily_parser *parser, SCM *retval)
#else
int
yyparse (parser, retval)
    Lily_parser *parser;
    SCM *retval;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;


#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
static YYSTYPE yyval_default;
# define YY_INITIAL_VALUE(Value) = Value
#endif
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc = yyloc_default;


    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
/* Line 1792 of yacc.c  */
#line 389 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("pitchnames");
		parser->lexer_->push_note_state (nn);
	}
    break;

  case 4:
/* Line 1792 of yacc.c  */
#line 392 "parser.yy"
    {
		parser->lexer_->pop_state ();
                *retval = (yyvsp[(3) - (3)]);
 	}
    break;

  case 5:
/* Line 1792 of yacc.c  */
#line 398 "parser.yy"
    { (yyval) = SCM_UNSPECIFIED; }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 399 "parser.yy"
    {
	}
    break;

  case 7:
/* Line 1792 of yacc.c  */
#line 401 "parser.yy"
    {
	}
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 403 "parser.yy"
    {
		parser->error_level_ = 1;
	}
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 406 "parser.yy"
    {
		parser->error_level_ = 1;
	}
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 413 "parser.yy"
    {
		parser->lexer_->add_scope (get_header (parser));
	}
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 415 "parser.yy"
    {
		parser->lexer_->set_identifier (ly_symbol2scm ("$defaultheader"), (yyvsp[(2) - (2)]));
	}
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 418 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-book-handler");
		scm_call_2 (proc, parser->self_scm (), (yyvsp[(1) - (1)]));
	}
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 422 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-bookpart-handler");
		scm_call_2 (proc, parser->self_scm (), (yyvsp[(1) - (1)]));
	}
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 426 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-score-handler");
		scm_call_2 (proc, parser->self_scm (), (yyvsp[(1) - (1)]));
	}
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 430 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-music-handler");
		scm_call_2 (proc, parser->self_scm (), (yyvsp[(1) - (1)]));
	}
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 434 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
		scm_call_2 (proc, parser->self_scm (), scm_list_1 ((yyvsp[(1) - (1)])));
	}
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 438 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
		scm_call_2 (proc, parser->self_scm (), (yyvsp[(1) - (1)]));
	}
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 442 "parser.yy"
    {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token ((yyvsp[(1) - (1)]));
	}
    break;

  case 19:
/* Line 1792 of yacc.c  */
#line 447 "parser.yy"
    {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup ((yyvsp[(1) - (1)])))
			out = scm_list_1 ((yyvsp[(1) - (1)]));
		else if (Text_interface::is_markup_list ((yyvsp[(1) - (1)])))
			out = (yyvsp[(1) - (1)]);
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
			scm_call_2 (proc, parser->self_scm (), out);
		} else if (!scm_is_eq ((yyvsp[(1) - (1)]), SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[(1) - (1)]), _("bad expression type"));
	}
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 460 "parser.yy"
    {
		SCM id = SCM_EOL;
		Output_def * od = unsmob_output_def ((yyvsp[(1) - (1)]));

		if (od->c_variable ("is-paper") == SCM_BOOL_T)
			id = ly_symbol2scm ("$defaultpaper");
		else if (od->c_variable ("is-midi") == SCM_BOOL_T)
			id = ly_symbol2scm ("$defaultmidi");
		else if (od->c_variable ("is-layout") == SCM_BOOL_T)
			id = ly_symbol2scm ("$defaultlayout");

		parser->lexer_->set_identifier (id, (yyvsp[(1) - (1)]));
	}
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 477 "parser.yy"
    {
		(yyval) = parser->lexer_->eval_scm_token ((yyvsp[(1) - (1)]));
	}
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 491 "parser.yy"
    {
		(yyval) = parser->lexer_->eval_scm_token ((yyvsp[(1) - (1)]));
	}
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 517 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("music-function", (yyloc),
					 (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 525 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("void-music", (yyloc));
	}
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 529 "parser.yy"
    {
		(yyvsp[(3) - (3)]) = scm_reverse_x ((yyvsp[(3) - (3)]), SCM_EOL);
		if (unsmob_music ((yyvsp[(2) - (3)])))
			(yyvsp[(3) - (3)]) = scm_cons ((yyvsp[(2) - (3)]), (yyvsp[(3) - (3)]));
		if (unsmob_music ((yyvsp[(1) - (3)])))
			(yyvsp[(3) - (3)]) = scm_cons ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
		(yyval) = MAKE_SYNTAX ("sequential-music", (yyloc), (yyvsp[(3) - (3)]));
	}
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 537 "parser.yy"
    {
		parser->error_level_ = 1;
                (yyval) = SCM_UNSPECIFIED;
	}
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 541 "parser.yy"
    {
		parser->error_level_ = 1;
                (yyval) = (yyvsp[(2) - (2)]);
	}
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 549 "parser.yy"
    { (yyval) = SCM_UNSPECIFIED; }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 550 "parser.yy"
    {

	}
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 553 "parser.yy"
    {

	}
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 559 "parser.yy"
    {
		(yyval) = parser->lexer_->remove_scope ();
	}
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 568 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 572 "parser.yy"
    {
	        parser->lexer_->set_identifier ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
                (yyval) = SCM_UNSPECIFIED;
	}
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 576 "parser.yy"
    {
		SCM path = scm_cons (scm_string_to_symbol ((yyvsp[(1) - (4)])), (yyvsp[(2) - (4)]));
		parser->lexer_->set_identifier (path, (yyvsp[(4) - (4)]));
                (yyval) = SCM_UNSPECIFIED;
	}
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 592 "parser.yy"
    {
		(yyval) = scm_reverse_x ((yyvsp[(2) - (2)]), SCM_EOL);
		if (Music *m = unsmob_music ((yyvsp[(1) - (2)])))
		{
			if (m->is_mus_type ("post-event-wrapper"))
				(yyval) = scm_append
					(scm_list_2 (m->get_property ("elements"),
						     (yyval)));
			else
				(yyval) = scm_cons ((yyvsp[(1) - (2)]), (yyval));
		}
		if (scm_is_pair ((yyval))
		    && scm_is_null (scm_cdr ((yyval))))
			(yyval) = scm_car ((yyval));
		else
		{
			Music * m = MY_MAKE_MUSIC ("PostEvents", (yyloc));
			m->set_property ("elements", (yyval));
			(yyval) = m->unprotect ();
		}
	}
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 623 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (4)]);
	}
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 631 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("pitchnames");
		parser->lexer_->push_note_state (nn);
	}
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 636 "parser.yy"
    {
		parser->lexer_->pop_state ();
		(yyval) = (yyvsp[(2) - (2)]);
	}
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 644 "parser.yy"
    {
		if (unsmob_music ((yyvsp[(1) - (1)]))) {
			SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
			(yyvsp[(1) - (1)]) = scm_call_2 (proc, parser->self_scm (), (yyvsp[(1) - (1)]));
		}
		if (unsmob_context_mod ((yyvsp[(1) - (1)])))
			(yyval) = (yyvsp[(1) - (1)]);
		else {
			parser->parser_error ((yylsp[(1) - (1)]), _ ("not a context mod"));
		}
	}
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 659 "parser.yy"
    {
		(yyval) = Context_def::make_scm ();
		unsmob_context_def ((yyval))->origin ()->set_spot ((yyloc));
	}
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 663 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
		unsmob_context_def ((yyval))->origin ()->set_spot ((yyloc));
	}
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 667 "parser.yy"
    {
		if (!SCM_UNBNDP ((yyvsp[(2) - (2)])))
			unsmob_context_def ((yyval))->add_context_mod ((yyvsp[(2) - (2)]));
	}
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 671 "parser.yy"
    {
                Context_def *td = unsmob_context_def ((yyval));
                SCM new_mods = unsmob_context_mod ((yyvsp[(2) - (2)]))->get_mods ();
                for (SCM m = new_mods; scm_is_pair (m); m = scm_cdr (m)) {
                    td->add_context_mod (scm_car (m));
                }
	}
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 678 "parser.yy"
    {
                Context_def *td = unsmob_context_def ((yyval));
                SCM new_mods = unsmob_context_mod ((yyvsp[(2) - (2)]))->get_mods ();
                for (SCM m = new_mods; scm_is_pair (m); m = scm_cdr (m)) {
                    td->add_context_mod (scm_car (m));
                }
	}
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 690 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (4)]);
		pop_paper (parser);
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), SCM_BOOL_F);
	}
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 701 "parser.yy"
    {
		Book *book = new Book;
		init_papers (parser);
		book->origin ()->set_spot ((yyloc));
		book->paper_ = dynamic_cast<Output_def*> (unsmob_output_def (parser->lexer_->lookup_identifier ("$defaultpaper"))->clone ());
		book->paper_->unprotect ();
		push_paper (parser, book->paper_);
		book->header_ = get_header (parser);
                (yyval) = book->unprotect ();
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), (yyval));
	}
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 712 "parser.yy"
    {
		unsmob_book ((yyvsp[(1) - (1)]))->origin ()->set_spot ((yyloc));
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), (yyvsp[(1) - (1)]));
	}
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 716 "parser.yy"
    {
		unsmob_book ((yyvsp[(1) - (2)]))->paper_ = unsmob_output_def ((yyvsp[(2) - (2)]));
		set_paper (parser, unsmob_output_def ((yyvsp[(2) - (2)])));
	}
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 720 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("book-bookpart-handler");
		scm_call_2 (proc, (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 724 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("book-score-handler");
		scm_call_2 (proc, (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 728 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("book-music-handler");
		scm_call_3 (proc, parser->self_scm (), (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 732 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
		scm_call_2 (proc, (yyvsp[(1) - (2)]), scm_list_1 ((yyvsp[(2) - (2)])));
	}
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 736 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
		scm_call_2 (proc, (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 740 "parser.yy"
    {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token ((yyvsp[(2) - (2)]));
	}
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 745 "parser.yy"
    {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup ((yyvsp[(2) - (2)])))
			out = scm_list_1 ((yyvsp[(2) - (2)]));
		else if (Text_interface::is_markup_list ((yyvsp[(2) - (2)])))
			out = (yyvsp[(2) - (2)]);
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
			scm_call_2 (proc, (yyvsp[(1) - (2)]), out);
		} else if (!scm_is_eq ((yyvsp[(2) - (2)]), SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[(2) - (2)]), _("bad expression type"));
	}
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 759 "parser.yy"
    {
		parser->lexer_->add_scope (unsmob_book ((yyvsp[(1) - (1)]))->header_);
	}
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 762 "parser.yy"
    {
                Book *book = unsmob_book ((yyvsp[(1) - (2)]));
		book->paper_ = 0;
		book->scores_ = SCM_EOL;
		book->bookparts_ = SCM_EOL;
	}
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 771 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (4)]);
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), SCM_BOOL_F);
	}
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 778 "parser.yy"
    {
		Book *book = new Book;
		book->origin ()->set_spot ((yyloc));
                (yyval) = book->unprotect ();
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), (yyval));
	}
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 784 "parser.yy"
    {
		unsmob_book ((yyvsp[(1) - (1)]))->origin ()->set_spot ((yyloc));
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), (yyvsp[(1) - (1)]));
	}
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 788 "parser.yy"
    {
		unsmob_book ((yyval))->paper_ = unsmob_output_def ((yyvsp[(2) - (2)]));
	}
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 791 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-score-handler");
		scm_call_2 (proc, (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 94:
/* Line 1792 of yacc.c  */
#line 795 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-music-handler");
		scm_call_3 (proc, parser->self_scm (), (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 799 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
		scm_call_2 (proc, (yyvsp[(1) - (2)]), scm_list_1 ((yyvsp[(2) - (2)])));
	}
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 803 "parser.yy"
    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
		scm_call_2 (proc, (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 807 "parser.yy"
    {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token ((yyvsp[(2) - (2)]));
	}
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 812 "parser.yy"
    {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup ((yyvsp[(2) - (2)])))
			out = scm_list_1 ((yyvsp[(2) - (2)]));
		else if (Text_interface::is_markup_list ((yyvsp[(2) - (2)])))
			out = (yyvsp[(2) - (2)]);
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
			scm_call_2 (proc, (yyvsp[(1) - (2)]), out);
		} else if (!scm_is_eq ((yyvsp[(2) - (2)]), SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[(2) - (2)]), _("bad expression type"));
	}
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 826 "parser.yy"
    {
                Book *book = unsmob_book ((yyvsp[(1) - (1)]));
		if (!ly_is_module (book->header_))
			book->header_ = ly_make_module (false);
		parser->lexer_->add_scope (book->header_);
	}
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 832 "parser.yy"
    {
                Book *book = unsmob_book ((yyvsp[(1) - (2)]));
		book->paper_ = 0;
		book->scores_ = SCM_EOL;
	}
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 840 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (4)]);
	}
    break;

  case 103:
/* Line 1792 of yacc.c  */
#line 846 "parser.yy"
    {
		SCM scorify = ly_lily_module_constant ("scorify-music");
		(yyval) = scm_call_2 (scorify, (yyvsp[(1) - (1)]), parser->self_scm ());

		unsmob_score ((yyval))->origin ()->set_spot ((yyloc));
	}
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 852 "parser.yy"
    {
		Score *score;
		if (unsmob_score ((yyvsp[(1) - (1)])))
			score = new Score (*unsmob_score ((yyvsp[(1) - (1)])));
		else {
			score = new Score;
			parser->parser_error ((yylsp[(1) - (1)]), _("score expected"));
		}
		unsmob_score ((yyval))->origin ()->set_spot ((yyloc));
		(yyval) = score->unprotect ();
	}
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 864 "parser.yy"
    {
                Score *score = unsmob_score ((yyvsp[(1) - (1)]));
		if (!ly_is_module (score->get_header ()))
			score->set_header (ly_make_module (false));
		parser->lexer_->add_scope (score->get_header ());
	}
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 870 "parser.yy"
    {
                Output_def *od = unsmob_output_def ((yyvsp[(2) - (2)]));
		if (od->lookup_variable (ly_symbol2scm ("is-paper")) == SCM_BOOL_T)
		{
			parser->parser_error ((yylsp[(2) - (2)]), _("\\paper cannot be used in \\score, use \\layout instead"));

		}
		else
		{
			unsmob_score ((yyvsp[(1) - (2)]))->add_output_def (od);
		}
	}
    break;

  case 108:
/* Line 1792 of yacc.c  */
#line 882 "parser.yy"
    {
		unsmob_score ((yyval))->error_found_ = true;
	}
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 893 "parser.yy"
    {
                Output_def *od = unsmob_output_def ((yyvsp[(1) - (1)]));

		if (od->lookup_variable (ly_symbol2scm ("is-paper")) != SCM_BOOL_T)
		{
			parser->parser_error ((yylsp[(1) - (1)]), _ ("need \\paper for paper block"));
			(yyval) = get_paper (parser)->unprotect ();
		}
	}
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 906 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (2)]);

		parser->lexer_->remove_scope ();
		parser->lexer_->pop_state ();
	}
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 915 "parser.yy"
    {
                Output_def *p = get_paper (parser);
		p->input_origin_ = (yyloc);
		parser->lexer_->add_scope (p->scope_);
                (yyval) = p->unprotect ();
	}
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 921 "parser.yy"
    {
		Output_def *p = get_midi (parser);
		(yyval) = p->unprotect ();
		parser->lexer_->add_scope (p->scope_);
	}
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 926 "parser.yy"
    {
		Output_def *p = get_layout (parser);

		parser->lexer_->add_scope (p->scope_);
		(yyval) = p->unprotect ();
	}
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 935 "parser.yy"
    {
		parser->lexer_->push_initial_state ();
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 115:
/* Line 1792 of yacc.c  */
#line 948 "parser.yy"
    {
		parser->lexer_->pop_state ();
	}
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 952 "parser.yy"
    {
		parser->lexer_->pop_state ();
	}
    break;

  case 117:
/* Line 1792 of yacc.c  */
#line 955 "parser.yy"
    {
		(yyval) = (yyvsp[(4) - (5)]);
	}
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 961 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (2)]);
		unsmob_output_def ((yyval))->input_origin_.set_spot ((yyloc));
	}
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 965 "parser.yy"
    {
		Output_def *o = unsmob_output_def ((yyvsp[(3) - (3)]));
		o->input_origin_.set_spot ((yyloc));
		(yyval) = o->self_scm ();
		parser->lexer_->remove_scope ();
		parser->lexer_->add_scope (o->scope_);
	}
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 972 "parser.yy"
    {

	}
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 975 "parser.yy"
    {

	}
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 979 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("pitchnames");
		parser->lexer_->push_note_state (nn);
	}
    break;

  case 123:
/* Line 1792 of yacc.c  */
#line 983 "parser.yy"
    {
		if (unsmob_context_def ((yyvsp[(3) - (3)])))
			assign_context_def (unsmob_output_def ((yyvsp[(1) - (3)])), (yyvsp[(3) - (3)]));
		else {

			SCM proc = parser->lexer_->lookup_identifier
				     ("output-def-music-handler");
			scm_call_3 (proc, parser->self_scm (),
				    (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
		}
	}
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 994 "parser.yy"
    {

	}
    break;

  case 125:
/* Line 1792 of yacc.c  */
#line 1000 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("tempo", (yyloc), SCM_EOL, (yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]));
	}
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 1003 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("tempo", (yyloc), (yyvsp[(2) - (5)]), (yyvsp[(3) - (5)]), (yyvsp[(5) - (5)]));
	}
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 1006 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("tempo", (yyloc), (yyvsp[(2) - (2)]));
	}
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 1015 "parser.yy"
    {
		(yyval) = SCM_EOL;
	}
    break;

  case 129:
/* Line 1792 of yacc.c  */
#line 1018 "parser.yy"
    {
		if (unsmob_music ((yyvsp[(2) - (2)])))
			(yyval) = scm_cons ((yyvsp[(2) - (2)]), (yyvsp[(1) - (2)]));
	}
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 1022 "parser.yy"
    {
		Music *m = MY_MAKE_MUSIC("Music", (yyloc));
		// ugh. code dup
		m->set_property ("error-found", SCM_BOOL_T);
		(yyval) = scm_cons (m->self_scm (), (yyvsp[(1) - (2)]));
		m->unprotect (); /* UGH */
	}
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 1033 "parser.yy"
    {
		(yyval) = scm_reverse_x ((yyvsp[(2) - (3)]), SCM_EOL);
	}
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 1044 "parser.yy"
    {
		if (unsmob_music ((yyvsp[(1) - (1)]))->is_mus_type ("post-event")) {
			parser->parser_error ((yylsp[(1) - (1)]), _ ("unexpected post-event"));
			(yyval) = SCM_UNSPECIFIED;
		}
	}
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 1051 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 1055 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (3)]);
	}
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 1062 "parser.yy"
    {
		if (scm_is_eq ((yyvsp[(1) - (1)]), SCM_UNSPECIFIED))
			(yyval) = (yyvsp[(1) - (1)]);
		else if (Music *m = unsmob_music ((yyvsp[(1) - (1)]))) {
			if (m->is_mus_type ("post-event")) {
				parser->parser_error
					((yylsp[(1) - (1)]), _ ("unexpected post-event"));
				(yyval) = SCM_UNSPECIFIED;
			} else
				(yyval) = (yyvsp[(1) - (1)]);
		} else if (parser->lexer_->is_lyric_state ()
			   && Text_interface::is_markup ((yyvsp[(1) - (1)])))
			MYBACKUP (LYRIC_ELEMENT, (yyvsp[(1) - (1)]), (yylsp[(1) - (1)]));
		else {
			(yyloc).warning (_ ("Ignoring non-music expression"));
			(yyval) = (yyvsp[(1) - (1)]);
		}
	}
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 1084 "parser.yy"
    {
	        (yyval) = make_music_from_simple (parser, (yylsp[(1) - (1)]), (yyvsp[(1) - (1)]));
                if (!unsmob_music ((yyval)))
                        parser->parser_error ((yylsp[(1) - (1)]), _ ("music expected"));
	}
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 1099 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("repeat", (yyloc), (yyvsp[(2) - (4)]), (yyvsp[(3) - (4)]), (yyvsp[(4) - (4)]), SCM_EOL);
	}
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 1103 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("repeat", (yyloc), (yyvsp[(2) - (6)]), (yyvsp[(3) - (6)]), (yyvsp[(4) - (6)]), (yyvsp[(6) - (6)]));
	}
    break;

  case 144:
/* Line 1792 of yacc.c  */
#line 1109 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("sequential-music", (yyloc), (yyvsp[(2) - (2)]));
	}
    break;

  case 145:
/* Line 1792 of yacc.c  */
#line 1112 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("sequential-music", (yyloc), (yyvsp[(1) - (1)]));
	}
    break;

  case 146:
/* Line 1792 of yacc.c  */
#line 1118 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("simultaneous-music", (yyloc), (yyvsp[(2) - (2)]));
	}
    break;

  case 147:
/* Line 1792 of yacc.c  */
#line 1121 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("simultaneous-music", (yyloc), scm_reverse_x ((yyvsp[(2) - (3)]), SCM_EOL));
	}
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 1133 "parser.yy"
    { parser->lexer_->push_initial_state (); }
    break;

  case 152:
/* Line 1792 of yacc.c  */
#line 1134 "parser.yy"
    {
                parser->lexer_->pop_state ();
                (yyval) = (yyvsp[(4) - (5)]);
        }
    break;

  case 153:
/* Line 1792 of yacc.c  */
#line 1139 "parser.yy"
    {
                (yyval) = (yyvsp[(2) - (2)]);
        }
    break;

  case 154:
/* Line 1792 of yacc.c  */
#line 1143 "parser.yy"
    {
                (yyval) = (yyvsp[(1) - (1)]);
        }
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 1147 "parser.yy"
    {
		if (unsmob_context_mod ((yyvsp[(2) - (2)])))
			(yyval) = (yyvsp[(2) - (2)]);
		else {
			parser->parser_error ((yylsp[(2) - (2)]), _ ("not a context mod"));
			(yyval) = Context_mod ().smobbed_copy ();
		}
	}
    break;

  case 156:
/* Line 1792 of yacc.c  */
#line 1158 "parser.yy"
    {
            (yyval) = SCM_EOL;
        }
    break;

  case 157:
/* Line 1792 of yacc.c  */
#line 1162 "parser.yy"
    {
              (yyval) = (yyvsp[(1) - (1)]);
        }
    break;

  case 158:
/* Line 1792 of yacc.c  */
#line 1168 "parser.yy"
    {
            (yyval) = Context_mod ().smobbed_copy ();
        }
    break;

  case 159:
/* Line 1792 of yacc.c  */
#line 1171 "parser.yy"
    {
		if (!SCM_UNBNDP ((yyvsp[(2) - (2)])))
			unsmob_context_mod ((yyvsp[(1) - (2)]))->add_context_mod ((yyvsp[(2) - (2)]));
        }
    break;

  case 160:
/* Line 1792 of yacc.c  */
#line 1175 "parser.yy"
    {
                 Context_mod *md = unsmob_context_mod ((yyvsp[(2) - (2)]));
                 if (md)
                     unsmob_context_mod ((yyvsp[(1) - (2)]))->add_context_mods (md->get_mods ());
        }
    break;

  case 161:
/* Line 1792 of yacc.c  */
#line 1180 "parser.yy"
    {
		unsmob_context_mod ((yyvsp[(1) - (2)]))->add_context_mods
			(unsmob_context_mod ((yyvsp[(2) - (2)]))->get_mods ());
        }
    break;

  case 165:
/* Line 1792 of yacc.c  */
#line 1195 "parser.yy"
    {
		(yyval) = FINISH_MAKE_SYNTAX ((yyvsp[(1) - (2)]), (yyloc), (yyvsp[(2) - (2)]));
	}
    break;

  case 170:
/* Line 1792 of yacc.c  */
#line 1208 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 171:
/* Line 1792 of yacc.c  */
#line 1209 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 173:
/* Line 1792 of yacc.c  */
#line 1247 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 174:
/* Line 1792 of yacc.c  */
#line 1251 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 175:
/* Line 1792 of yacc.c  */
#line 1255 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 176:
/* Line 1792 of yacc.c  */
#line 1262 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]));
	}
    break;

  case 177:
/* Line 1792 of yacc.c  */
#line 1265 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]));
	}
    break;

  case 178:
/* Line 1792 of yacc.c  */
#line 1269 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]), (yyvsp[(2) - (4)]));
	}
    break;

  case 179:
/* Line 1792 of yacc.c  */
#line 1273 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]), (yyvsp[(2) - (4)]));
	}
    break;

  case 180:
/* Line 1792 of yacc.c  */
#line 1277 "parser.yy"
    {
		SCM n = scm_difference ((yyvsp[(5) - (5)]), SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (5)]), n)))
			(yyval) = scm_cons (n, (yyvsp[(3) - (5)]));
		else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[(5) - (5)]));
			t->set_property ("digit", (yyvsp[(5) - (5)]));
			(yyval) = check_scheme_arg (parser, (yylsp[(4) - (5)]), t->unprotect (),
					       (yyvsp[(3) - (5)]), (yyvsp[(2) - (5)]), n);
		}
		
	}
    break;

  case 181:
/* Line 1792 of yacc.c  */
#line 1290 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (5)]),
				       scm_difference ((yyvsp[(5) - (5)]), SCM_UNDEFINED),
				       (yyvsp[(3) - (5)]), (yyvsp[(2) - (5)]));
	}
    break;

  case 182:
/* Line 1792 of yacc.c  */
#line 1296 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (5)]),
				       scm_difference ((yyvsp[(5) - (5)]), SCM_UNDEFINED),
				       (yyvsp[(3) - (5)]), (yyvsp[(2) - (5)]));
	}
    break;

  case 184:
/* Line 1792 of yacc.c  */
#line 1306 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]), (yyvsp[(2) - (4)]));
	}
    break;

  case 185:
/* Line 1792 of yacc.c  */
#line 1310 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]), (yyvsp[(2) - (4)]));
	}
    break;

  case 186:
/* Line 1792 of yacc.c  */
#line 1314 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]),
				       try_string_variants ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)])),
				       (yyvsp[(3) - (4)]), (yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]));
	}
    break;

  case 187:
/* Line 1792 of yacc.c  */
#line 1320 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]),
				       try_string_variants ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)])),
				       (yyvsp[(3) - (4)]), (yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]));
	}
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 1326 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]), (yyvsp[(2) - (4)]));
	}
    break;

  case 190:
/* Line 1792 of yacc.c  */
#line 1334 "parser.yy"
    {
		(yyval) = scm_append (scm_list_2 ((yyvsp[(1) - (3)]), scm_reverse_x ((yyvsp[(3) - (3)]), SCM_EOL)));
	}
    break;

  case 192:
/* Line 1792 of yacc.c  */
#line 1342 "parser.yy"
    {
		(yyval) = scm_append_x (scm_list_2 ((yyvsp[(3) - (3)]), (yyvsp[(1) - (3)])));
	}
    break;

  case 193:
/* Line 1792 of yacc.c  */
#line 1351 "parser.yy"
    {
		SCM sym_l_p = ly_lily_module_constant ("symbol-list?");
		(yyval) = try_string_variants (sym_l_p, (yyvsp[(1) - (1)]));
		if (SCM_UNBNDP ((yyval))) {
			parser->parser_error ((yylsp[(1) - (1)]), _("not a symbol"));
			(yyval) = SCM_EOL;
		} else
			(yyval) = scm_reverse ((yyval));
	}
    break;

  case 197:
/* Line 1792 of yacc.c  */
#line 1372 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]), (yyvsp[(2) - (4)]));
	}
    break;

  case 198:
/* Line 1792 of yacc.c  */
#line 1376 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]), (yyvsp[(2) - (4)]));
	}
    break;

  case 199:
/* Line 1792 of yacc.c  */
#line 1380 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 1384 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 201:
/* Line 1792 of yacc.c  */
#line 1388 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 1395 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (4)]);
		SCM res = try_string_variants ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]));
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  ((yyvsp[(2) - (4)]), make_music_from_simple
			   (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)])))))
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), STRING, (yyvsp[(4) - (4)]));
		else
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SCM_ARG, (yyvsp[(4) - (4)]));
	}
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 1412 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (4)]);
		SCM res = try_string_variants ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]));
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  ((yyvsp[(2) - (4)]), make_music_from_simple
			   (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)])))))
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), STRING, (yyvsp[(4) - (4)]));
		else
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SCM_ARG, (yyvsp[(4) - (4)]));
	}
    break;

  case 204:
/* Line 1792 of yacc.c  */
#line 1429 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (4)]);
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SCM_ARG, (yyvsp[(4) - (4)]));
		else if (scm_is_true
			 (scm_call_1
			  ((yyvsp[(2) - (4)]), make_music_from_simple
			   (parser, (yylsp[(4) - (4)]), (yyvsp[(4) - (4)])))))
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), STRING, (yyvsp[(4) - (4)]));
		else
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SCM_ARG, (yyvsp[(4) - (4)]));
	}
    break;

  case 209:
/* Line 1792 of yacc.c  */
#line 1455 "parser.yy"
    {
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
		{
			(yyval) = scm_cons ((yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]));
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (SCM_ARG, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 210:
/* Line 1792 of yacc.c  */
#line 1465 "parser.yy"
    {
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
		{
			(yyval) = scm_cons ((yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]));
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (EVENT_IDENTIFIER, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 1475 "parser.yy"
    {
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
			(yyval) = scm_cons ((yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]));
		else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (LYRIC_ELEMENT, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 1484 "parser.yy"
    {
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
		{
			(yyval) = (yyvsp[(3) - (4)]);
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), UNSIGNED, (yyvsp[(4) - (4)]));
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (UNSIGNED, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 213:
/* Line 1792 of yacc.c  */
#line 1495 "parser.yy"
    {
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
		{
			(yyval) = (yyvsp[(3) - (4)]);
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), REAL, (yyvsp[(4) - (4)]));
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (REAL, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 214:
/* Line 1792 of yacc.c  */
#line 1506 "parser.yy"
    {
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
		{
			(yyval) = scm_cons ((yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]));
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (NUMBER_IDENTIFIER, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 1516 "parser.yy"
    {
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]))))
		{
			(yyval) = scm_cons ((yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]));
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (FRACTION, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 1526 "parser.yy"
    {
		SCM n = scm_difference ((yyvsp[(5) - (5)]), SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (5)]), n))) {
			(yyval) = (yyvsp[(3) - (5)]);
			MYREPARSE ((yylsp[(5) - (5)]), (yyvsp[(2) - (5)]), REAL, n);
		} else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[(5) - (5)]));
			t->set_property ("digit", (yyvsp[(5) - (5)]));
			(yyval) = t->unprotect ();
			if (scm_is_true (scm_call_1 ((yyvsp[(2) - (5)]), (yyval))))
				(yyval) = scm_cons ((yyval), (yyvsp[(3) - (5)]));
			else {
				(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (5)]), (yyvsp[(1) - (5)])), (yyvsp[(3) - (5)]));
				MYBACKUP (UNSIGNED, (yyvsp[(5) - (5)]), (yylsp[(5) - (5)]));
				parser->lexer_->push_extra_token ('-');
			}
		}
		
	}
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 1546 "parser.yy"
    {
		SCM n = scm_difference ((yyvsp[(5) - (5)]), SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (5)]), n))) {
			MYREPARSE ((yylsp[(5) - (5)]), (yyvsp[(2) - (5)]), REAL, n);
			(yyval) = (yyvsp[(3) - (5)]);
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (5)]), (yyvsp[(1) - (5)])), (yyvsp[(3) - (5)]));
			MYBACKUP (REAL, n, (yylsp[(5) - (5)]));
		}
	}
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 1557 "parser.yy"
    {
		SCM n = scm_difference ((yyvsp[(5) - (5)]), SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 ((yyvsp[(2) - (5)]), n))) {
			(yyval) = scm_cons (n, (yyvsp[(3) - (5)]));
		} else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (5)]), (yyvsp[(1) - (5)])), (yyvsp[(3) - (5)]));
			MYBACKUP (NUMBER_IDENTIFIER, n, (yylsp[(5) - (5)]));
		}
	}
    break;

  case 219:
/* Line 1792 of yacc.c  */
#line 1567 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]));
	}
    break;

  case 220:
/* Line 1792 of yacc.c  */
#line 1571 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(4) - (4)]), (yyvsp[(3) - (4)]));
	}
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 1575 "parser.yy"
    {
		SCM res = try_string_variants ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]));
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				(yyval) = (yyvsp[(3) - (4)]);
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SYMBOL_LIST, res);
			}
			else
				(yyval) = scm_cons (res, (yyvsp[(3) - (4)]));
		else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (SCM_IDENTIFIER, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 1590 "parser.yy"
    {
		SCM res = try_string_variants ((yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]));
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				(yyval) = (yyvsp[(3) - (4)]);
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(2) - (4)]), SYMBOL_LIST, res);
			}
			else
				(yyval) = scm_cons (res, (yyvsp[(3) - (4)]));
		else {
			(yyval) = scm_cons (loc_on_music ((yylsp[(3) - (4)]), (yyvsp[(1) - (4)])), (yyvsp[(3) - (4)]));
			MYBACKUP (STRING, (yyvsp[(4) - (4)]), (yylsp[(4) - (4)]));
		}
	}
    break;

  case 223:
/* Line 1792 of yacc.c  */
#line 1605 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(1) - (4)]), (yyvsp[(3) - (4)]));
		MYBACKUP(0, SCM_UNDEFINED, (yylsp[(3) - (4)]));
	}
    break;

  case 224:
/* Line 1792 of yacc.c  */
#line 1610 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 225:
/* Line 1792 of yacc.c  */
#line 1615 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 229:
/* Line 1792 of yacc.c  */
#line 1628 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]));
	}
    break;

  case 230:
/* Line 1792 of yacc.c  */
#line 1633 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]));
	}
    break;

  case 231:
/* Line 1792 of yacc.c  */
#line 1638 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]));
	}
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 1643 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]));
	}
    break;

  case 233:
/* Line 1792 of yacc.c  */
#line 1648 "parser.yy"
    {
		SCM n = scm_difference ((yyvsp[(4) - (4)]), SCM_UNDEFINED);
		(yyval) = check_scheme_arg (parser, (yylsp[(4) - (4)]), n, (yyvsp[(2) - (4)]), (yyvsp[(1) - (4)]));
	}
    break;

  case 234:
/* Line 1792 of yacc.c  */
#line 1653 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 235:
/* Line 1792 of yacc.c  */
#line 1658 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 236:
/* Line 1792 of yacc.c  */
#line 1663 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 237:
/* Line 1792 of yacc.c  */
#line 1668 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 238:
/* Line 1792 of yacc.c  */
#line 1675 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (3)]);
		SCM res = try_string_variants ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  ((yyvsp[(1) - (3)]), make_music_from_simple (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)])))))
			MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), LYRIC_ELEMENT, (yyvsp[(3) - (3)]));
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), SCM_ARG, (yyvsp[(3) - (3)]));
	}
    break;

  case 239:
/* Line 1792 of yacc.c  */
#line 1693 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (3)]);
		SCM res = try_string_variants ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  ((yyvsp[(1) - (3)]), make_music_from_simple (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)])))))
			MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), LYRIC_ELEMENT, (yyvsp[(3) - (3)]));
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), SCM_ARG, (yyvsp[(3) - (3)]));
	}
    break;

  case 240:
/* Line 1792 of yacc.c  */
#line 1711 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (3)]);
		if (scm_is_true (scm_call_1 ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]))))
			MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), SCM_ARG, (yyvsp[(3) - (3)]));
		else if (scm_is_true
			 (scm_call_1
			  ((yyvsp[(1) - (3)]), make_music_from_simple (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)])))))
			MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), LYRIC_ELEMENT, (yyvsp[(3) - (3)]));
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[(3) - (3)]), (yyvsp[(1) - (3)]), SCM_ARG, (yyvsp[(3) - (3)]));
	}
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 1725 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (4)]);
		SCM n = scm_difference ((yyvsp[(4) - (4)]), SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 ((yyvsp[(1) - (4)]), n)))
			MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(1) - (4)]), REAL, n);
		else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[(4) - (4)]));
			t->set_property ("digit", (yyvsp[(4) - (4)]));
			SCM m = t->unprotect ();
			if (scm_is_true (scm_call_1 ((yyvsp[(1) - (4)]), m)))
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(1) - (4)]), SCM_ARG, m);
			else
				MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(1) - (4)]), SCM_ARG, (yyvsp[(4) - (4)]));
		}
		
	}
    break;

  case 242:
/* Line 1792 of yacc.c  */
#line 1742 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (4)]);
		SCM n = scm_difference ((yyvsp[(4) - (4)]), SCM_UNDEFINED);
		MYREPARSE ((yylsp[(4) - (4)]), (yyvsp[(1) - (4)]), REAL, n);
	}
    break;

  case 246:
/* Line 1792 of yacc.c  */
#line 1757 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]));
	}
    break;

  case 247:
/* Line 1792 of yacc.c  */
#line 1762 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]));
	}
    break;

  case 248:
/* Line 1792 of yacc.c  */
#line 1767 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (4)]),
				       scm_difference ((yyvsp[(4) - (4)]), SCM_UNDEFINED),
				       (yyvsp[(2) - (4)]), (yyvsp[(1) - (4)]));
	}
    break;

  case 249:
/* Line 1792 of yacc.c  */
#line 1773 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]));
	}
    break;

  case 250:
/* Line 1792 of yacc.c  */
#line 1778 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]));
	}
    break;

  case 251:
/* Line 1792 of yacc.c  */
#line 1783 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 252:
/* Line 1792 of yacc.c  */
#line 1788 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]),
				       (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 253:
/* Line 1792 of yacc.c  */
#line 1793 "parser.yy"
    {
		(yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)]), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 256:
/* Line 1792 of yacc.c  */
#line 1802 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 257:
/* Line 1792 of yacc.c  */
#line 1806 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 260:
/* Line 1792 of yacc.c  */
#line 1815 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 261:
/* Line 1792 of yacc.c  */
#line 1819 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 267:
/* Line 1792 of yacc.c  */
#line 1836 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("music-function", (yyloc),
					 (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 268:
/* Line 1792 of yacc.c  */
#line 1843 "parser.yy"
    {
		(yyval) = SCM_EOL;
	}
    break;

  case 269:
/* Line 1792 of yacc.c  */
#line 1846 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 270:
/* Line 1792 of yacc.c  */
#line 1849 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 271:
/* Line 1792 of yacc.c  */
#line 1852 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(1) - (4)]), (yyvsp[(3) - (4)]));
	}
    break;

  case 272:
/* Line 1792 of yacc.c  */
#line 1855 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(1) - (4)]), (yyvsp[(3) - (4)]));
	}
    break;

  case 273:
/* Line 1792 of yacc.c  */
#line 1858 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(1) - (4)]), (yyvsp[(3) - (4)]));
	}
    break;

  case 274:
/* Line 1792 of yacc.c  */
#line 1864 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("music-function", (yyloc),
					 (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 275:
/* Line 1792 of yacc.c  */
#line 1872 "parser.yy"
    { (yyval) = SCM_EOL; }
    break;

  case 276:
/* Line 1792 of yacc.c  */
#line 1873 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (2)]);
	}
    break;

  case 278:
/* Line 1792 of yacc.c  */
#line 1880 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 279:
/* Line 1792 of yacc.c  */
#line 1881 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 280:
/* Line 1792 of yacc.c  */
#line 1883 "parser.yy"
    {
		(yyval) = FINISH_MAKE_SYNTAX ((yyvsp[(1) - (2)]), (yyloc), (yyvsp[(2) - (2)]));
	}
    break;

  case 281:
/* Line 1792 of yacc.c  */
#line 1889 "parser.yy"
    {
                Context_mod *ctxmod = unsmob_context_mod ((yyvsp[(4) - (4)]));
                SCM mods = SCM_EOL;
                if (ctxmod)
                        mods = ctxmod->get_mods ();
		(yyval) = START_MAKE_SYNTAX ("context-specification", (yyvsp[(2) - (4)]), (yyvsp[(3) - (4)]), mods, SCM_BOOL_F);
	}
    break;

  case 282:
/* Line 1792 of yacc.c  */
#line 1896 "parser.yy"
    {
                Context_mod *ctxmod = unsmob_context_mod ((yyvsp[(4) - (4)]));
                SCM mods = SCM_EOL;
                if (ctxmod)
                        mods = ctxmod->get_mods ();
		(yyval) = START_MAKE_SYNTAX ("context-specification", (yyvsp[(2) - (4)]), (yyvsp[(3) - (4)]), mods, SCM_BOOL_T);
	}
    break;

  case 283:
/* Line 1792 of yacc.c  */
#line 1906 "parser.yy"
    {
		if ((yyvsp[(1) - (2)]) == ly_symbol2scm ("chords"))
		{
		  (yyval) = MAKE_SYNTAX ("unrelativable-music", (yyloc), (yyvsp[(2) - (2)]));
		}
		else
		{
		  (yyval) = (yyvsp[(2) - (2)]);
		}
		parser->lexer_->pop_state ();
	}
    break;

  case 284:
/* Line 1792 of yacc.c  */
#line 1917 "parser.yy"
    {
                Context_mod *ctxmod = unsmob_context_mod ((yyvsp[(2) - (3)]));
                SCM mods = SCM_EOL;
                if (ctxmod)
                        mods = ctxmod->get_mods ();
		(yyval) = MAKE_SYNTAX ("context-specification", (yyloc), (yyvsp[(1) - (3)]), SCM_EOL, mods, SCM_BOOL_T, (yyvsp[(3) - (3)]));
		if ((yyvsp[(1) - (3)]) == ly_symbol2scm ("ChordNames"))
		{
		  (yyval) = MAKE_SYNTAX ("unrelativable-music", (yyloc), (yyval));
		}
		parser->lexer_->pop_state ();
	}
    break;

  case 285:
/* Line 1792 of yacc.c  */
#line 1932 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("pitchnames");
		parser->lexer_->push_note_state (nn);

		(yyval) = ly_symbol2scm ("notes");
	}
    break;

  case 286:
/* Line 1792 of yacc.c  */
#line 1939 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("drumPitchNames");
		parser->lexer_->push_note_state (nn);

		(yyval) = ly_symbol2scm ("drums");
	}
    break;

  case 287:
/* Line 1792 of yacc.c  */
#line 1945 "parser.yy"
    {
		parser->lexer_->push_figuredbass_state ();

		(yyval) = ly_symbol2scm ("figures");
	}
    break;

  case 288:
/* Line 1792 of yacc.c  */
#line 1950 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("chordmodifiers");
		parser->lexer_->chordmodifier_tab_ = alist_to_hashq (nn);
		nn = parser->lexer_->lookup_identifier ("pitchnames");
		parser->lexer_->push_chord_state (nn);
		(yyval) = ly_symbol2scm ("chords");

	}
    break;

  case 289:
/* Line 1792 of yacc.c  */
#line 1959 "parser.yy"
    { parser->lexer_->push_lyric_state ();
		(yyval) = ly_symbol2scm ("lyrics");
	}
    break;

  case 290:
/* Line 1792 of yacc.c  */
#line 1965 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("drumPitchNames");
		parser->lexer_->push_note_state (nn);

		(yyval) = ly_symbol2scm ("DrumStaff");
	}
    break;

  case 291:
/* Line 1792 of yacc.c  */
#line 1971 "parser.yy"
    {
		parser->lexer_->push_figuredbass_state ();

		(yyval) = ly_symbol2scm ("FiguredBass");
	}
    break;

  case 292:
/* Line 1792 of yacc.c  */
#line 1976 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("chordmodifiers");
		parser->lexer_->chordmodifier_tab_ = alist_to_hashq (nn);
		nn = parser->lexer_->lookup_identifier ("pitchnames");
		parser->lexer_->push_chord_state (nn);
		(yyval) = ly_symbol2scm ("ChordNames");
	}
    break;

  case 293:
/* Line 1792 of yacc.c  */
#line 1984 "parser.yy"
    { parser->lexer_->push_lyric_state ();
		(yyval) = ly_symbol2scm ("Lyrics");
	}
    break;

  case 294:
/* Line 1792 of yacc.c  */
#line 1990 "parser.yy"
    { parser->lexer_->push_lyric_state (); }
    break;

  case 295:
/* Line 1792 of yacc.c  */
#line 1992 "parser.yy"
    {
	/* Can also use music at the expensive of two S/Rs similar to
           \repeat \alternative */
		parser->lexer_->pop_state ();

		(yyval) = scm_cons ((yyvsp[(3) - (3)]), SCM_EOL);
	}
    break;

  case 296:
/* Line 1792 of yacc.c  */
#line 1999 "parser.yy"
    {
		parser->lexer_->push_lyric_state ();
	}
    break;

  case 297:
/* Line 1792 of yacc.c  */
#line 2001 "parser.yy"
    {
		parser->lexer_->pop_state ();
		(yyval) = scm_cons ((yyvsp[(4) - (4)]), (yyvsp[(1) - (4)]));
	}
    break;

  case 298:
/* Line 1792 of yacc.c  */
#line 2008 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("add-lyrics", (yyloc), (yyvsp[(1) - (2)]), scm_reverse_x ((yyvsp[(2) - (2)]), SCM_EOL));
	}
    break;

  case 299:
/* Line 1792 of yacc.c  */
#line 2011 "parser.yy"
    {
		parser->lexer_->push_lyric_state ();
	}
    break;

  case 300:
/* Line 1792 of yacc.c  */
#line 2013 "parser.yy"
    {
		parser->lexer_->pop_state ();
		(yyval) = MAKE_SYNTAX ("lyric-combine", (yyloc), (yyvsp[(2) - (4)]), (yyvsp[(4) - (4)]));
	}
    break;

  case 301:
/* Line 1792 of yacc.c  */
#line 2020 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("context-change", (yyloc), scm_string_to_symbol ((yyvsp[(2) - (4)])), (yyvsp[(4) - (4)]));
	}
    break;

  case 302:
/* Line 1792 of yacc.c  */
#line 2027 "parser.yy"
    {
		(yyval) = scm_reverse_x ((yyvsp[(1) - (1)]), SCM_EOL);
	}
    break;

  case 303:
/* Line 1792 of yacc.c  */
#line 2030 "parser.yy"
    {
		(yyval) = scm_reverse_x ((yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 304:
/* Line 1792 of yacc.c  */
#line 2036 "parser.yy"
    {
		(yyval) = scm_list_3 (ly_symbol2scm ("assign"), (yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 305:
/* Line 1792 of yacc.c  */
#line 2039 "parser.yy"
    {
		(yyval) = scm_list_2 (ly_symbol2scm ("unset"), (yyvsp[(2) - (2)]));
	}
    break;

  case 306:
/* Line 1792 of yacc.c  */
#line 2042 "parser.yy"
    {
		if (scm_ilength ((yyvsp[(2) - (4)])) < 2) {
			parser->parser_error ((yylsp[(2) - (4)]), _("bad grob property path"));
			(yyval) = SCM_UNDEFINED;
		} else {
			(yyval) = scm_cons (ly_symbol2scm ("push"),
				       scm_cons2 (scm_car ((yyvsp[(2) - (4)])),
						  (yyvsp[(4) - (4)]),
						  scm_cdr ((yyvsp[(2) - (4)]))));
		}
	}
    break;

  case 307:
/* Line 1792 of yacc.c  */
#line 2053 "parser.yy"
    {
		(yyval) = scm_cons (ly_symbol2scm ("pop"), (yyvsp[(2) - (2)]));
	}
    break;

  case 308:
/* Line 1792 of yacc.c  */
#line 2083 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (3)]);
	}
    break;

  case 309:
/* Line 1792 of yacc.c  */
#line 2090 "parser.yy"
    {
		if (scm_is_null ((yyvsp[(1) - (1)]))
		    || scm_is_null (scm_cdr ((yyvsp[(1) - (1)]))))
			MYBACKUP (SCM_ARG, (yyvsp[(1) - (1)]), (yylsp[(1) - (1)]));
		else
			MYBACKUP (SYMBOL_LIST, scm_reverse_x ((yyvsp[(1) - (1)]), SCM_EOL), (yylsp[(1) - (1)]));
	}
    break;

  case 311:
/* Line 1792 of yacc.c  */
#line 2103 "parser.yy"
    {
		(yyval) = scm_append_x (scm_list_2 ((yyvsp[(5) - (5)]), (yyvsp[(3) - (5)])));
	}
    break;

  case 312:
/* Line 1792 of yacc.c  */
#line 2107 "parser.yy"
    {
		(yyval) = scm_append_x (scm_list_2 ((yyvsp[(4) - (4)]), (yyvsp[(3) - (4)])));
	}
    break;

  case 313:
/* Line 1792 of yacc.c  */
#line 2113 "parser.yy"
    { (yyval) = ly_symbol2scm ("consists"); }
    break;

  case 314:
/* Line 1792 of yacc.c  */
#line 2114 "parser.yy"
    { (yyval) = ly_symbol2scm ("remove"); }
    break;

  case 315:
/* Line 1792 of yacc.c  */
#line 2116 "parser.yy"
    { (yyval) = ly_symbol2scm ("accepts"); }
    break;

  case 316:
/* Line 1792 of yacc.c  */
#line 2117 "parser.yy"
    { (yyval) = ly_symbol2scm ("default-child"); }
    break;

  case 317:
/* Line 1792 of yacc.c  */
#line 2118 "parser.yy"
    { (yyval) = ly_symbol2scm ("denies"); }
    break;

  case 318:
/* Line 1792 of yacc.c  */
#line 2120 "parser.yy"
    { (yyval) = ly_symbol2scm ("alias"); }
    break;

  case 319:
/* Line 1792 of yacc.c  */
#line 2121 "parser.yy"
    { (yyval) = ly_symbol2scm ("translator-type"); }
    break;

  case 320:
/* Line 1792 of yacc.c  */
#line 2122 "parser.yy"
    { (yyval) = ly_symbol2scm ("description"); }
    break;

  case 321:
/* Line 1792 of yacc.c  */
#line 2123 "parser.yy"
    { (yyval) = ly_symbol2scm ("context-name"); }
    break;

  case 322:
/* Line 1792 of yacc.c  */
#line 2127 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 323:
/* Line 1792 of yacc.c  */
#line 2128 "parser.yy"
    {
		(yyval) = scm_list_2 ((yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 324:
/* Line 1792 of yacc.c  */
#line 2132 "parser.yy"
    {
		if (!scm_is_string ((yyvsp[(2) - (2)]))
		    && ly_symbol2scm ("consists") != (yyvsp[(1) - (2)])
		    && ly_symbol2scm ("remove") != (yyvsp[(1) - (2)]))
		{
			(yyval) = SCM_EOL;
			parser->parser_error ((yylsp[(1) - (2)]), _ ("only \\consists and \\remove take non-string argument."));
		}
		else
		{
			(yyval) = scm_list_2 ((yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
		}
	}
    break;

  case 325:
/* Line 1792 of yacc.c  */
#line 2150 "parser.yy"
    {
		SCM l = scm_reverse_x ((yyvsp[(1) - (1)]), SCM_EOL);
		if (scm_is_pair (l)
		    && to_boolean
		    (scm_object_property (scm_car (l),
					  ly_symbol2scm ("is-grob?"))))
			l = scm_cons (ly_symbol2scm ("Bottom"), l);
		if (scm_is_null (l) || scm_is_null (scm_cdr (l))) {
			parser->parser_error ((yylsp[(1) - (1)]), _ ("bad grob property path"));
			l = SCM_UNDEFINED;
		}
		(yyval) = l;
	}
    break;

  case 326:
/* Line 1792 of yacc.c  */
#line 2168 "parser.yy"
    {
		if (!SCM_UNBNDP ((yyvsp[(1) - (1)])) && scm_is_null (scm_cddr ((yyvsp[(1) - (1)]))))
		{
			parser->parser_error ((yylsp[(1) - (1)]), _ ("bad grob property path"));
			(yyval) = SCM_UNDEFINED;
		}
	}
    break;

  case 327:
/* Line 1792 of yacc.c  */
#line 2176 "parser.yy"
    {
		if (!SCM_UNBNDP ((yyvsp[(1) - (2)]))) {
			(yyval) = scm_append_x (scm_list_2 ((yyvsp[(1) - (2)]), (yyvsp[(2) - (2)])));
			if (scm_is_null (scm_cddr ((yyval)))) {
				parser->parser_error ((yyloc), _ ("bad grob property path"));
				(yyval) = SCM_UNDEFINED;
			}
		}

	}
    break;

  case 328:
/* Line 1792 of yacc.c  */
#line 2191 "parser.yy"
    {
		SCM l = scm_reverse_x ((yyvsp[(1) - (1)]), SCM_EOL);
		switch (scm_ilength (l)) {
		case 1:
			l = scm_cons (ly_symbol2scm ("Bottom"), l);
		case 2:
			break;
		default:
			parser->parser_error ((yylsp[(1) - (1)]), _ ("bad context property path"));
			l = SCM_UNDEFINED;
		}
		(yyval) = l;
	}
    break;

  case 329:
/* Line 1792 of yacc.c  */
#line 2207 "parser.yy"
    {
		if (SCM_UNBNDP ((yyvsp[(2) - (4)])))
			(yyval) = SCM_UNDEFINED;
		else {
			(yyval) = scm_list_5 (scm_car ((yyvsp[(2) - (4)])),
					 ly_symbol2scm ("OverrideProperty"),
					 scm_cadr ((yyvsp[(2) - (4)])),
					 (yyvsp[(4) - (4)]),
					 scm_cddr ((yyvsp[(2) - (4)])));
		}
	}
    break;

  case 330:
/* Line 1792 of yacc.c  */
#line 2218 "parser.yy"
    {
		(yyval) = scm_list_4 ((yyvsp[(2) - (3)]),
				 ly_symbol2scm ("RevertProperty"),
				 scm_car ((yyvsp[(3) - (3)])),
				 scm_cdr ((yyvsp[(3) - (3)])));
	}
    break;

  case 331:
/* Line 1792 of yacc.c  */
#line 2224 "parser.yy"
    {
		if (SCM_UNBNDP ((yyvsp[(2) - (4)])))
			(yyval) = SCM_UNDEFINED;
		else
			(yyval) = scm_list_4 (scm_car ((yyvsp[(2) - (4)])),
					 ly_symbol2scm ("PropertySet"),
					 scm_cadr ((yyvsp[(2) - (4)])),
					 (yyvsp[(4) - (4)]));
	}
    break;

  case 332:
/* Line 1792 of yacc.c  */
#line 2233 "parser.yy"
    {
		if (SCM_UNBNDP ((yyvsp[(2) - (2)])))
			(yyval) = SCM_UNDEFINED;
		else
			(yyval) = scm_list_3 (scm_car ((yyvsp[(2) - (2)])),
					 ly_symbol2scm ("PropertyUnset"),
					 scm_cadr ((yyvsp[(2) - (2)])));
	}
    break;

  case 333:
/* Line 1792 of yacc.c  */
#line 2260 "parser.yy"
    {
		(yyvsp[(1) - (1)]) = scm_reverse_x ((yyvsp[(1) - (1)]), SCM_EOL);
		if (scm_is_null ((yyvsp[(1) - (1)]))
		    || to_boolean
		    (scm_object_property (scm_car ((yyvsp[(1) - (1)])),
					  ly_symbol2scm ("is-grob?")))) {
			(yyval) = ly_symbol2scm ("Bottom");
			parser->lexer_->push_extra_token (SCM_IDENTIFIER, (yyvsp[(1) - (1)]));
		} else {
			(yyval) = scm_car ((yyvsp[(1) - (1)]));
			parser->lexer_->push_extra_token (SCM_IDENTIFIER,
							  scm_cdr ((yyvsp[(1) - (1)])));
		}
	}
    break;

  case 334:
/* Line 1792 of yacc.c  */
#line 2277 "parser.yy"
    {
		if (SCM_UNBNDP ((yyvsp[(1) - (1)])))
			(yyval) = MAKE_SYNTAX ("void-music", (yylsp[(1) - (1)]));
		else
			(yyval) = LOWLEVEL_MAKE_SYNTAX (ly_lily_module_constant ("property-operation"), scm_cons2 (parser->self_scm (), make_input ((yyloc)), (yyvsp[(1) - (1)])));
	}
    break;

  case 335:
/* Line 1792 of yacc.c  */
#line 2286 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 337:
/* Line 1792 of yacc.c  */
#line 2292 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 338:
/* Line 1792 of yacc.c  */
#line 2296 "parser.yy"
    {
		if (scm_is_string ((yyvsp[(1) - (1)]))) {
			(yyval) = (yyvsp[(1) - (1)]);
		} else {
			parser->parser_error ((yylsp[(1) - (1)]), (_ ("simple string expected")));
			(yyval) = scm_string (SCM_EOL);
		}
	}
    break;

  case 339:
/* Line 1792 of yacc.c  */
#line 2307 "parser.yy"
    {
		(yyval) = scm_string_to_symbol ((yyvsp[(1) - (1)]));
	}
    break;

  case 340:
/* Line 1792 of yacc.c  */
#line 2311 "parser.yy"
    {
		// This is a bit of overkill but makes the same
		// routine responsible for all symbol interpretations.
		(yyval) = try_string_variants (ly_lily_module_constant ("symbol?"),
					  (yyvsp[(1) - (1)]));
		if (SCM_UNBNDP ((yyval)))
		{
			parser->parser_error ((yylsp[(1) - (1)]), (_ ("symbol expected")));
			// Generate a unique symbol in case it is used
			// for an assignment or similar
			(yyval) = scm_make_symbol (ly_string2scm ("undefined"));
		}
	}
    break;

  case 344:
/* Line 1792 of yacc.c  */
#line 2338 "parser.yy"
    {
		(yyval) = scm_difference ((yyvsp[(2) - (2)]), SCM_UNDEFINED);
	}
    break;

  case 351:
/* Line 1792 of yacc.c  */
#line 2355 "parser.yy"
    {
		(yyval) = scm_difference ((yyvsp[(2) - (2)]), SCM_UNDEFINED);
	}
    break;

  case 355:
/* Line 1792 of yacc.c  */
#line 2365 "parser.yy"
    {
		// Let the rhythmic music iterator sort this mess out.
		if (scm_is_pair ((yyvsp[(2) - (2)]))) {
		        (yyval) = make_music_from_simple (parser, (yylsp[(1) - (2)]), (yyvsp[(1) - (2)]));
			if (unsmob_music ((yyval)))
                                unsmob_music ((yyval))->set_property ("articulations",
                                                                 scm_reverse_x ((yyvsp[(2) - (2)]), SCM_EOL));
                        else
                                parser->parser_error ((yylsp[(1) - (2)]), _("music expected"));
		}
	}
    break;

  case 356:
/* Line 1792 of yacc.c  */
#line 2376 "parser.yy"
    {
		SCM elts = ly_append2 ((yyvsp[(1) - (2)]), scm_reverse_x ((yyvsp[(2) - (2)]), SCM_EOL));

		Input i;
		/* why is this giving wrong start location? -ns
		 * i = @$; */
		i.set_location ((yylsp[(1) - (2)]), (yylsp[(2) - (2)]));
		(yyval) = MAKE_SYNTAX ("event-chord", i, elts);
	}
    break;

  case 357:
/* Line 1792 of yacc.c  */
#line 2385 "parser.yy"
    {
		Input i;
		i.set_location ((yylsp[(1) - (3)]), (yylsp[(3) - (3)]));
		(yyval) = MAKE_SYNTAX ("repetition-chord", i,
				  (yyvsp[(2) - (3)]), scm_reverse_x ((yyvsp[(3) - (3)]), SCM_EOL));
	}
    break;

  case 358:
/* Line 1792 of yacc.c  */
#line 2391 "parser.yy"
    {
		Input i;
		i.set_location ((yylsp[(1) - (3)]), (yylsp[(3) - (3)]));
		(yyval) = MAKE_SYNTAX ("multi-measure-rest", i, (yyvsp[(2) - (3)]),
				  scm_reverse_x ((yyvsp[(3) - (3)]), SCM_EOL));
	}
    break;

  case 361:
/* Line 1792 of yacc.c  */
#line 2404 "parser.yy"
    {
		Music *m = unsmob_music ((yyvsp[(1) - (3)]));
		SCM dur = unsmob_duration ((yyvsp[(2) - (3)]))->smobbed_copy ();
		SCM es = m->get_property ("elements");
		SCM postevs = scm_reverse_x ((yyvsp[(3) - (3)]), SCM_EOL);

		for (SCM s = es; scm_is_pair (s); s = scm_cdr (s))
		  unsmob_music (scm_car (s))->set_property ("duration", dur);
		es = ly_append2 (es, postevs);

		m-> set_property ("elements", es);
		m->set_spot ((yyloc));
		(yyval) = m->self_scm ();
	}
    break;

  case 362:
/* Line 1792 of yacc.c  */
#line 2422 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("event-chord", (yyloc), scm_reverse_x ((yyvsp[(2) - (3)]), SCM_EOL));
	}
    break;

  case 363:
/* Line 1792 of yacc.c  */
#line 2428 "parser.yy"
    { (yyval) = SCM_EOL; }
    break;

  case 364:
/* Line 1792 of yacc.c  */
#line 2429 "parser.yy"
    {
		if (!SCM_UNBNDP ((yyvsp[(2) - (2)])))
			(yyval) = scm_cons ((yyvsp[(2) - (2)]), (yyvsp[(1) - (2)]));
	}
    break;

  case 365:
/* Line 1792 of yacc.c  */
#line 2437 "parser.yy"
    {
		bool q = to_boolean ((yyvsp[(3) - (5)]));
		bool ex = to_boolean ((yyvsp[(2) - (5)]));
		SCM check = (yyvsp[(4) - (5)]);
		SCM post = (yyvsp[(5) - (5)]);

		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		n->set_property ("pitch", (yyvsp[(1) - (5)]));
		if (q)
			n->set_property ("cautionary", SCM_BOOL_T);
                if (ex || q)
			n->set_property ("force-accidental", SCM_BOOL_T);

		if (scm_is_pair (post)) {
			SCM arts = scm_reverse_x (post, SCM_EOL);
			n->set_property ("articulations", arts);
		}
		if (scm_is_number (check))
		{
			int q = scm_to_int (check);
			n->set_property ("absolute-octave", scm_from_int (q-1));
		}

		(yyval) = n->unprotect ();
	}
    break;

  case 366:
/* Line 1792 of yacc.c  */
#line 2462 "parser.yy"
    {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		n->set_property ("drum-type", (yyvsp[(1) - (2)]));

		if (scm_is_pair ((yyvsp[(2) - (2)]))) {
			SCM arts = scm_reverse_x ((yyvsp[(2) - (2)]), SCM_EOL);
			n->set_property ("articulations", arts);
		}
		(yyval) = n->unprotect ();
	}
    break;

  case 367:
/* Line 1792 of yacc.c  */
#line 2473 "parser.yy"
    {
		Music *m = unsmob_music ((yyvsp[(1) - (1)]));

		while (m && m->is_mus_type ("music-wrapper-music")) {
			(yyval) = m->get_property ("element");
			m = unsmob_music ((yyval));
		}

		if (!(m && m->is_mus_type ("rhythmic-event"))) {
			parser->parser_error ((yyloc), _ ("not a rhythmic event"));
			(yyval) = SCM_UNDEFINED;
		}
	}
    break;

  case 370:
/* Line 1792 of yacc.c  */
#line 2499 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("music-function", (yyloc),
					 (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 371:
/* Line 1792 of yacc.c  */
#line 2506 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("music-function", (yyloc),
					 (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 372:
/* Line 1792 of yacc.c  */
#line 2513 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 373:
/* Line 1792 of yacc.c  */
#line 2519 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 374:
/* Line 1792 of yacc.c  */
#line 2526 "parser.yy"
    {
		(yyval) = SCM_EOL;
	}
    break;

  case 375:
/* Line 1792 of yacc.c  */
#line 2529 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (2)]);
		if (Music *m = unsmob_music ((yyvsp[(2) - (2)])))
		{
			if (m->is_mus_type ("post-event-wrapper"))
			{
				for (SCM p = m->get_property ("elements");
				     scm_is_pair (p);
				     p = scm_cdr (p))
				{
					(yyval) = scm_cons (scm_car (p), (yyval));
				}
			} else {
				m->set_spot ((yylsp[(2) - (2)]));
				(yyval) = scm_cons ((yyvsp[(2) - (2)]), (yyval));
			}
		}
	}
    break;

  case 376:
/* Line 1792 of yacc.c  */
#line 2550 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 377:
/* Line 1792 of yacc.c  */
#line 2553 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (2)]);
		if (!unsmob_music ((yyvsp[(2) - (2)]))->is_mus_type ("post-event")) {
			parser->parser_error ((yylsp[(2) - (2)]), _ ("post-event expected"));
			(yyval) = SCM_UNSPECIFIED;
		} else if (!SCM_UNBNDP ((yyvsp[(1) - (2)])))
		{
			unsmob_music ((yyval))->set_property ("direction", (yyvsp[(1) - (2)]));
		}
	}
    break;

  case 378:
/* Line 1792 of yacc.c  */
#line 2563 "parser.yy"
    {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[(1) - (1)]), _ ("have to be in Lyric mode for lyrics"));
		(yyval) = MY_MAKE_MUSIC ("HyphenEvent", (yyloc))->unprotect ();
	}
    break;

  case 379:
/* Line 1792 of yacc.c  */
#line 2568 "parser.yy"
    {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[(1) - (1)]), _ ("have to be in Lyric mode for lyrics"));
		(yyval) = MY_MAKE_MUSIC ("ExtenderEvent", (yyloc))->unprotect ();
	}
    break;

  case 380:
/* Line 1792 of yacc.c  */
#line 2573 "parser.yy"
    {
		if (!SCM_UNBNDP ((yyvsp[(1) - (2)])))
		{
			Music *m = unsmob_music ((yyvsp[(2) - (2)]));
			m->set_property ("direction", (yyvsp[(1) - (2)]));
		}
		(yyval) = (yyvsp[(2) - (2)]);
	}
    break;

  case 381:
/* Line 1792 of yacc.c  */
#line 2581 "parser.yy"
    {
		if (!SCM_UNBNDP ((yyvsp[(1) - (2)])))
		{
			Music *m = unsmob_music ((yyvsp[(2) - (2)]));
			m->set_property ("direction", (yyvsp[(1) - (2)]));
		}
		(yyval) = (yyvsp[(2) - (2)]);
	}
    break;

  case 382:
/* Line 1792 of yacc.c  */
#line 2590 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (2)]);
		unsmob_music ((yyval))->set_property ("direction", scm_from_int (UP));
	}
    break;

  case 383:
/* Line 1792 of yacc.c  */
#line 2595 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (2)]);
		unsmob_music ((yyval))->set_property ("direction", scm_from_int (DOWN));
	}
    break;

  case 385:
/* Line 1792 of yacc.c  */
#line 2603 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (2)]);
	}
    break;

  case 386:
/* Line 1792 of yacc.c  */
#line 2609 "parser.yy"
    {
		Music *s = MY_MAKE_MUSIC ("StringNumberEvent", (yyloc));
		s->set_property ("string-number", (yyvsp[(1) - (1)]));
		(yyval) = s->unprotect ();
	}
    break;

  case 388:
/* Line 1792 of yacc.c  */
#line 2618 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 389:
/* Line 1792 of yacc.c  */
#line 2621 "parser.yy"
    {
               Music *a = MY_MAKE_MUSIC ("TremoloEvent", (yyloc));
               a->set_property ("tremolo-type", (yyvsp[(1) - (1)]));
               (yyval) = a->unprotect ();
        }
    break;

  case 391:
/* Line 1792 of yacc.c  */
#line 2630 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 392:
/* Line 1792 of yacc.c  */
#line 2633 "parser.yy"
    {
		SCM s = parser->lexer_->lookup_identifier ("dash" + ly_scm2string ((yyvsp[(1) - (1)])));
		Music *a = MY_MAKE_MUSIC ("ArticulationEvent", (yyloc));
		if (scm_is_string (s))
			a->set_property ("articulation-type", s);
		else parser->parser_error ((yylsp[(1) - (1)]), _ ("expecting string as script definition"));
		(yyval) = a->unprotect ();
	}
    break;

  case 393:
/* Line 1792 of yacc.c  */
#line 2644 "parser.yy"
    { (yyval) = SCM_EOL; }
    break;

  case 394:
/* Line 1792 of yacc.c  */
#line 2645 "parser.yy"
    { (yyval) = (yyvsp[(2) - (2)]); }
    break;

  case 395:
/* Line 1792 of yacc.c  */
#line 2650 "parser.yy"
    {
                (yyval) = SCM_INUM0;
        }
    break;

  case 398:
/* Line 1792 of yacc.c  */
#line 2658 "parser.yy"
    {
		(yyval) = scm_from_int (1);
	}
    break;

  case 399:
/* Line 1792 of yacc.c  */
#line 2661 "parser.yy"
    {
		(yyval) = scm_oneplus ((yyvsp[(1) - (2)]));
	}
    break;

  case 400:
/* Line 1792 of yacc.c  */
#line 2667 "parser.yy"
    {
		(yyval) = scm_from_int (-1);
	}
    break;

  case 401:
/* Line 1792 of yacc.c  */
#line 2670 "parser.yy"
    {
		(yyval) = scm_oneminus ((yyvsp[(1) - (2)]));
	}
    break;

  case 402:
/* Line 1792 of yacc.c  */
#line 2676 "parser.yy"
    {
                if (!scm_is_eq (SCM_INUM0, (yyvsp[(2) - (2)])))
                {
                        Pitch p = *unsmob_pitch ((yyvsp[(1) - (2)]));
                        p = p.transposed (Pitch (scm_to_int ((yyvsp[(2) - (2)])),0,0));
                        (yyval) = p.smobbed_copy ();
                }
	}
    break;

  case 403:
/* Line 1792 of yacc.c  */
#line 2691 "parser.yy"
    {
                if (!scm_is_eq (SCM_INUM0, (yyvsp[(2) - (2)])))
                {
                        Pitch p = *unsmob_pitch ((yyvsp[(1) - (2)]));
                        p = p.transposed (Pitch (scm_to_int ((yyvsp[(2) - (2)])),0,0));
                        (yyval) = p.smobbed_copy ();
                }
	}
    break;

  case 408:
/* Line 1792 of yacc.c  */
#line 2712 "parser.yy"
    {
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		t->set_property ("text", (yyvsp[(1) - (1)]));
		(yyval) = t->unprotect ();
	}
    break;

  case 409:
/* Line 1792 of yacc.c  */
#line 2717 "parser.yy"
    {
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		t->set_property ("text",
			make_simple_markup ((yyvsp[(1) - (1)])));
		(yyval) = t->unprotect ();
	}
    break;

  case 410:
/* Line 1792 of yacc.c  */
#line 2724 "parser.yy"
    {
		Music *m = unsmob_music ((yyvsp[(1) - (1)]));
		if (m && m->is_mus_type ("post-event"))
			(yyval) = (yyvsp[(1) - (1)]);
		else if (Text_interface::is_markup ((yyvsp[(1) - (1)]))) {
			Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
			t->set_property ("text", (yyvsp[(1) - (1)]));
			(yyval) = t->unprotect ();
		} else
			parser->parser_error ((yylsp[(1) - (1)]), _ ("not an articulation"));
	}
    break;

  case 411:
/* Line 1792 of yacc.c  */
#line 2738 "parser.yy"
    {
		Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yyloc));
		t->set_property ("digit", (yyvsp[(1) - (1)]));
		(yyval) = t->unprotect ();
	}
    break;

  case 412:
/* Line 1792 of yacc.c  */
#line 2746 "parser.yy"
    {
		(yyval) = scm_from_locale_string ("Hat");
	}
    break;

  case 413:
/* Line 1792 of yacc.c  */
#line 2749 "parser.yy"
    {
		(yyval) = scm_from_locale_string ("Plus");
	}
    break;

  case 414:
/* Line 1792 of yacc.c  */
#line 2752 "parser.yy"
    {
		(yyval) = scm_from_locale_string ("Dash");
	}
    break;

  case 415:
/* Line 1792 of yacc.c  */
#line 2755 "parser.yy"
    {
		(yyval) = scm_from_locale_string ("Bang");
	}
    break;

  case 416:
/* Line 1792 of yacc.c  */
#line 2758 "parser.yy"
    {
		(yyval) = scm_from_locale_string ("Larger");
	}
    break;

  case 417:
/* Line 1792 of yacc.c  */
#line 2761 "parser.yy"
    {
		(yyval) = scm_from_locale_string ("Dot");
	}
    break;

  case 418:
/* Line 1792 of yacc.c  */
#line 2764 "parser.yy"
    {
		(yyval) = scm_from_locale_string ("Underscore");
	}
    break;

  case 419:
/* Line 1792 of yacc.c  */
#line 2770 "parser.yy"
    { (yyval) = scm_from_int (DOWN); }
    break;

  case 420:
/* Line 1792 of yacc.c  */
#line 2771 "parser.yy"
    { (yyval) = scm_from_int (UP); }
    break;

  case 421:
/* Line 1792 of yacc.c  */
#line 2772 "parser.yy"
    { (yyval) = SCM_UNDEFINED; }
    break;

  case 422:
/* Line 1792 of yacc.c  */
#line 2776 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 423:
/* Line 1792 of yacc.c  */
#line 2782 "parser.yy"
    {
		(yyval) = SCM_UNDEFINED;
	}
    break;

  case 424:
/* Line 1792 of yacc.c  */
#line 2785 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
		parser->default_duration_ = *unsmob_duration ((yyval));
	}
    break;

  case 425:
/* Line 1792 of yacc.c  */
#line 2794 "parser.yy"
    {
		if (SCM_UNBNDP ((yyval)))
			(yyval) = parser->default_duration_.smobbed_copy ();
	}
    break;

  case 426:
/* Line 1792 of yacc.c  */
#line 2801 "parser.yy"
    {
		int len = 0;
                int n = scm_to_int ((yyvsp[(1) - (2)]));
		if (!is_duration (n))
			parser->parser_error ((yylsp[(1) - (2)]), _f ("not a duration: %d", n));
		else
			len = intlog2 (n);

		(yyval) = Duration (len, scm_to_int ((yyvsp[(2) - (2)]))).smobbed_copy ();
	}
    break;

  case 427:
/* Line 1792 of yacc.c  */
#line 2811 "parser.yy"
    {
		Duration *d = unsmob_duration ((yyvsp[(1) - (2)]));
		Duration k (d->duration_log (),
                            d->dot_count () + scm_to_int ((yyvsp[(2) - (2)])));
		k = k.compressed (d->factor ());
                scm_remember_upto_here_1 ((yyvsp[(1) - (2)]));
		(yyval) = k.smobbed_copy ();
	}
    break;

  case 428:
/* Line 1792 of yacc.c  */
#line 2822 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 429:
/* Line 1792 of yacc.c  */
#line 2825 "parser.yy"
    {
		(yyval) = unsmob_duration ((yyval))->compressed (scm_to_int ((yyvsp[(3) - (3)]))).smobbed_copy ();
	}
    break;

  case 430:
/* Line 1792 of yacc.c  */
#line 2828 "parser.yy"
    {
		Rational  m (scm_to_int (scm_car ((yyvsp[(3) - (3)]))), scm_to_int (scm_cdr ((yyvsp[(3) - (3)]))));

		(yyval) = unsmob_duration ((yyval))->compressed (m).smobbed_copy ();
	}
    break;

  case 431:
/* Line 1792 of yacc.c  */
#line 2836 "parser.yy"
    {
		(yyval) = SCM_INUM0;
	}
    break;

  case 432:
/* Line 1792 of yacc.c  */
#line 2839 "parser.yy"
    {
		(yyval) = scm_oneplus ((yyvsp[(1) - (2)]));
	}
    break;

  case 433:
/* Line 1792 of yacc.c  */
#line 2845 "parser.yy"
    {
		(yyval) = SCM_INUM0;
	}
    break;

  case 434:
/* Line 1792 of yacc.c  */
#line 2848 "parser.yy"
    {
                int n = scm_to_int ((yyvsp[(2) - (2)]));
		if (!is_duration (n))
			parser->parser_error ((yylsp[(2) - (2)]), _f ("not a duration: %d", n));
		(yyval) = (yyvsp[(2) - (2)]);
	}
    break;

  case 435:
/* Line 1792 of yacc.c  */
#line 2857 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 436:
/* Line 1792 of yacc.c  */
#line 2858 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 437:
/* Line 1792 of yacc.c  */
#line 2859 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 438:
/* Line 1792 of yacc.c  */
#line 2861 "parser.yy"
    {
		// as an integer, it needs to be non-negative, and otherwise
		// it needs to be suitable as a markup.
		if (scm_is_integer ((yyvsp[(1) - (1)]))
		    ? scm_is_true (scm_negative_p ((yyvsp[(1) - (1)])))
		    : !Text_interface::is_markup ((yyvsp[(1) - (1)])))
		{
			parser->parser_error ((yylsp[(1) - (1)]), _ ("bass number expected"));
			(yyval) = SCM_INUM0;
		}
	}
    break;

  case 439:
/* Line 1792 of yacc.c  */
#line 2875 "parser.yy"
    { (yyval) = ly_rational2scm (FLAT_ALTERATION); }
    break;

  case 440:
/* Line 1792 of yacc.c  */
#line 2876 "parser.yy"
    { (yyval) = ly_rational2scm (SHARP_ALTERATION); }
    break;

  case 441:
/* Line 1792 of yacc.c  */
#line 2877 "parser.yy"
    { (yyval) = scm_from_int (0); }
    break;

  case 442:
/* Line 1792 of yacc.c  */
#line 2881 "parser.yy"
    {
		Music *bfr = MY_MAKE_MUSIC ("BassFigureEvent", (yyloc));
		(yyval) = bfr->unprotect ();
	}
    break;

  case 443:
/* Line 1792 of yacc.c  */
#line 2885 "parser.yy"
    {
		Music *bfr = MY_MAKE_MUSIC ("BassFigureEvent", (yyloc));
		(yyval) = bfr->self_scm ();

		if (scm_is_number ((yyvsp[(1) - (1)])))
			bfr->set_property ("figure", (yyvsp[(1) - (1)]));
		else if (Text_interface::is_markup ((yyvsp[(1) - (1)])))
			bfr->set_property ("text", (yyvsp[(1) - (1)]));

		bfr->unprotect ();
	}
    break;

  case 444:
/* Line 1792 of yacc.c  */
#line 2896 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (2)]);
		unsmob_music ((yyvsp[(1) - (2)]))->set_property ("bracket-stop", SCM_BOOL_T);
	}
    break;

  case 445:
/* Line 1792 of yacc.c  */
#line 2900 "parser.yy"
    {
		Music *m = unsmob_music ((yyvsp[(1) - (2)]));
		if (scm_to_double ((yyvsp[(2) - (2)]))) {
			SCM salter = m->get_property ("alteration");
			SCM alter = scm_is_number (salter) ? salter : scm_from_int (0);
			m->set_property ("alteration",
					 scm_sum (alter, (yyvsp[(2) - (2)])));
		} else {
			m->set_property ("alteration", scm_from_int (0));
		}
	}
    break;

  case 446:
/* Line 1792 of yacc.c  */
#line 2911 "parser.yy"
    {
		Music *m = unsmob_music ((yyvsp[(1) - (2)]));
		m->set_property ((yyvsp[(2) - (2)]), SCM_BOOL_T);
	}
    break;

  case 447:
/* Line 1792 of yacc.c  */
#line 2919 "parser.yy"
    {
		(yyval) = ly_symbol2scm ("augmented");
	}
    break;

  case 448:
/* Line 1792 of yacc.c  */
#line 2922 "parser.yy"
    {
		(yyval) = ly_symbol2scm ("no-continuation");
	}
    break;

  case 449:
/* Line 1792 of yacc.c  */
#line 2925 "parser.yy"
    {
		(yyval) = ly_symbol2scm ("diminished");
	}
    break;

  case 450:
/* Line 1792 of yacc.c  */
#line 2928 "parser.yy"
    {
		(yyval) = ly_symbol2scm ("augmented-slash");
	}
    break;

  case 451:
/* Line 1792 of yacc.c  */
#line 2934 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 452:
/* Line 1792 of yacc.c  */
#line 2937 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (2)]);
		unsmob_music ((yyval))->set_property ("bracket-start", SCM_BOOL_T);
	}
    break;

  case 453:
/* Line 1792 of yacc.c  */
#line 2944 "parser.yy"
    {
		(yyval) = SCM_EOL;
	}
    break;

  case 454:
/* Line 1792 of yacc.c  */
#line 2947 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(2) - (2)]), (yyvsp[(1) - (2)]));
	}
    break;

  case 455:
/* Line 1792 of yacc.c  */
#line 2953 "parser.yy"
    {
		(yyval) = scm_reverse_x ((yyvsp[(2) - (3)]), SCM_EOL);
	}
    break;

  case 456:
/* Line 1792 of yacc.c  */
#line 2960 "parser.yy"
    { (yyval) = SCM_BOOL_F; }
    break;

  case 457:
/* Line 1792 of yacc.c  */
#line 2961 "parser.yy"
    { (yyval) = SCM_BOOL_T; }
    break;

  case 458:
/* Line 1792 of yacc.c  */
#line 2965 "parser.yy"
    {
		if (!parser->lexer_->is_note_state ())
			parser->parser_error ((yylsp[(1) - (6)]), _ ("have to be in Note mode for notes"));
		if (!SCM_UNBNDP ((yyvsp[(2) - (6)]))
                    || !SCM_UNBNDP ((yyvsp[(3) - (6)]))
                    || scm_is_number ((yyvsp[(4) - (6)]))
                    || !SCM_UNBNDP ((yyvsp[(5) - (6)]))
                    || scm_is_true ((yyvsp[(6) - (6)])))
		{
			Music *n = 0;
			if (scm_is_true ((yyvsp[(6) - (6)])))
				n = MY_MAKE_MUSIC ("RestEvent", (yyloc));
			else
				n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
			
			n->set_property ("pitch", (yyvsp[(1) - (6)]));
			if (SCM_UNBNDP ((yyvsp[(5) - (6)])))
				n->set_property ("duration",
						 parser->default_duration_.smobbed_copy ());
			else
				n->set_property ("duration", (yyvsp[(5) - (6)]));
			
			if (scm_is_number ((yyvsp[(4) - (6)])))
			{
				int q = scm_to_int ((yyvsp[(4) - (6)]));
				n->set_property ("absolute-octave", scm_from_int (q-1));
			}
			
			if (to_boolean ((yyvsp[(3) - (6)])))
				n->set_property ("cautionary", SCM_BOOL_T);
			if (to_boolean ((yyvsp[(2) - (6)])) || to_boolean ((yyvsp[(3) - (6)])))
				n->set_property ("force-accidental", SCM_BOOL_T);
			
			(yyval) = n->unprotect ();
		}
	}
    break;

  case 459:
/* Line 1792 of yacc.c  */
#line 3001 "parser.yy"
    {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		n->set_property ("duration", (yyvsp[(2) - (2)]));
		n->set_property ("drum-type", (yyvsp[(1) - (2)]));

		(yyval) = n->unprotect ();
	}
    break;

  case 460:
/* Line 1792 of yacc.c  */
#line 3008 "parser.yy"
    {
		Music *ev = 0;
 		if (ly_scm2string ((yyvsp[(1) - (2)])) == "s") {
			/* Space */
			ev = MY_MAKE_MUSIC ("SkipEvent", (yyloc));
		  }
		else {
			ev = MY_MAKE_MUSIC ("RestEvent", (yyloc));

		    }
		ev->set_property ("duration", (yyvsp[(2) - (2)]));
 		(yyval) = ev->unprotect ();
	}
    break;

  case 461:
/* Line 1792 of yacc.c  */
#line 3024 "parser.yy"
    {
                if (!parser->lexer_->is_chord_state ())
                        parser->parser_error ((yylsp[(1) - (1)]), _ ("have to be in Chord mode for chords"));
                (yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 462:
/* Line 1792 of yacc.c  */
#line 3029 "parser.yy"
    {
		for (SCM s = (yyvsp[(1) - (2)]); scm_is_pair (s); s = scm_cdr (s))
		{
			unsmob_music (scm_car (s))->set_property ("duration", (yyvsp[(2) - (2)]));
		}
		(yyval) = (yyvsp[(1) - (2)]);
	}
    break;

  case 463:
/* Line 1792 of yacc.c  */
#line 3039 "parser.yy"
    {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[(1) - (1)]), _ ("markup outside of text script or \\lyricmode"));
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 464:
/* Line 1792 of yacc.c  */
#line 3044 "parser.yy"
    {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[(1) - (1)]), _ ("unrecognized string, not in text script or \\lyricmode"));
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 466:
/* Line 1792 of yacc.c  */
#line 3053 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("lyric-event", (yyloc), (yyvsp[(1) - (3)]), (yyvsp[(2) - (3)]));
		if (scm_is_pair ((yyvsp[(3) - (3)])))
			unsmob_music ((yyval))->set_property
				("articulations", scm_reverse_x ((yyvsp[(3) - (3)]), SCM_EOL));
	}
    break;

  case 467:
/* Line 1792 of yacc.c  */
#line 3062 "parser.yy"
    {
		(yyval) = make_chord_elements ((yyloc), (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]), SCM_EOL);
	}
    break;

  case 468:
/* Line 1792 of yacc.c  */
#line 3065 "parser.yy"
    {
		SCM its = scm_reverse_x ((yyvsp[(4) - (4)]), SCM_EOL);
		(yyval) = make_chord_elements ((yyloc), (yyvsp[(1) - (4)]), (yyvsp[(2) - (4)]), scm_cons ((yyvsp[(3) - (4)]), its));
	}
    break;

  case 469:
/* Line 1792 of yacc.c  */
#line 3072 "parser.yy"
    {
		(yyval) = SCM_EOL;
	}
    break;

  case 470:
/* Line 1792 of yacc.c  */
#line 3075 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(2) - (2)]), (yyval));
	}
    break;

  case 471:
/* Line 1792 of yacc.c  */
#line 3081 "parser.yy"
    {
		(yyval) = ly_symbol2scm ("chord-colon");
	}
    break;

  case 472:
/* Line 1792 of yacc.c  */
#line 3084 "parser.yy"
    {
		(yyval) = ly_symbol2scm ("chord-caret");
	}
    break;

  case 473:
/* Line 1792 of yacc.c  */
#line 3087 "parser.yy"
    {
 		(yyval) = scm_list_2 (ly_symbol2scm ("chord-slash"), (yyvsp[(2) - (2)]));
	}
    break;

  case 474:
/* Line 1792 of yacc.c  */
#line 3090 "parser.yy"
    {
		(yyval) = scm_list_2 (ly_symbol2scm ("chord-bass"), (yyvsp[(2) - (2)]));
	}
    break;

  case 475:
/* Line 1792 of yacc.c  */
#line 3096 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 476:
/* Line 1792 of yacc.c  */
#line 3099 "parser.yy"
    {
		(yyval) = scm_reverse_x ((yyvsp[(1) - (1)]), SCM_EOL);
	}
    break;

  case 477:
/* Line 1792 of yacc.c  */
#line 3102 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 478:
/* Line 1792 of yacc.c  */
#line 3108 "parser.yy"
    { (yyval) = scm_cons ((yyvsp[(1) - (1)]), SCM_EOL); }
    break;

  case 479:
/* Line 1792 of yacc.c  */
#line 3109 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(3) - (3)]), (yyval));
	}
    break;

  case 480:
/* Line 1792 of yacc.c  */
#line 3115 "parser.yy"
    {
		(yyval) = make_chord_step ((yyvsp[(1) - (1)]), 0);
        }
    break;

  case 481:
/* Line 1792 of yacc.c  */
#line 3118 "parser.yy"
    {
		(yyval) = make_chord_step ((yyvsp[(1) - (2)]), SHARP_ALTERATION);
	}
    break;

  case 482:
/* Line 1792 of yacc.c  */
#line 3121 "parser.yy"
    {
		(yyval) = make_chord_step ((yyvsp[(1) - (2)]), FLAT_ALTERATION);
	}
    break;

  case 483:
/* Line 1792 of yacc.c  */
#line 3127 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 484:
/* Line 1792 of yacc.c  */
#line 3130 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 485:
/* Line 1792 of yacc.c  */
#line 3142 "parser.yy"
    {
		(yyval) = scm_sum ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 486:
/* Line 1792 of yacc.c  */
#line 3145 "parser.yy"
    {
		(yyval) = scm_difference ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 488:
/* Line 1792 of yacc.c  */
#line 3152 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 489:
/* Line 1792 of yacc.c  */
#line 3155 "parser.yy"
    {
		(yyval) = scm_product ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 490:
/* Line 1792 of yacc.c  */
#line 3158 "parser.yy"
    {
		(yyval) = scm_divide ((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)]));
	}
    break;

  case 491:
/* Line 1792 of yacc.c  */
#line 3164 "parser.yy"
    { /* %prec UNARY_MINUS */
		(yyval) = scm_difference ((yyvsp[(2) - (2)]), SCM_UNDEFINED);
	}
    break;

  case 494:
/* Line 1792 of yacc.c  */
#line 3173 "parser.yy"
    {
		(yyval) = scm_product ((yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 495:
/* Line 1792 of yacc.c  */
#line 3176 "parser.yy"
    {
		(yyval) = scm_product ((yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 501:
/* Line 1792 of yacc.c  */
#line 3193 "parser.yy"
    { (yyval) = SCM_UNDEFINED; }
    break;

  case 502:
/* Line 1792 of yacc.c  */
#line 3195 "parser.yy"
    {
                if (SCM_UNBNDP ((yyvsp[(1) - (2)])))
                        (yyval) = SCM_BOOL_T;
                else
                        (yyval) = scm_not ((yyvsp[(1) - (2)]));
        }
    break;

  case 503:
/* Line 1792 of yacc.c  */
#line 3204 "parser.yy"
    { (yyval) = SCM_UNDEFINED; }
    break;

  case 504:
/* Line 1792 of yacc.c  */
#line 3206 "parser.yy"
    {
                if (SCM_UNBNDP ((yyvsp[(1) - (2)])))
                        (yyval) = SCM_BOOL_T;
                else
                        (yyval) = scm_not ((yyvsp[(1) - (2)]));
        }
    break;

  case 505:
/* Line 1792 of yacc.c  */
#line 3216 "parser.yy"
    { parser->lexer_->push_markup_state (); }
    break;

  case 506:
/* Line 1792 of yacc.c  */
#line 3217 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (3)]);
		parser->lexer_->pop_state ();
	}
    break;

  case 507:
/* Line 1792 of yacc.c  */
#line 3225 "parser.yy"
    { parser->lexer_->push_markup_state (); }
    break;

  case 508:
/* Line 1792 of yacc.c  */
#line 3226 "parser.yy"
    {
		(yyval) = (yyvsp[(3) - (3)]);
		parser->lexer_->pop_state ();
	}
    break;

  case 509:
/* Line 1792 of yacc.c  */
#line 3233 "parser.yy"
    {
		(yyval) = scm_list_2 (ly_lily_module_constant ("line-markup"),  (yyvsp[(1) - (1)]));
	}
    break;

  case 510:
/* Line 1792 of yacc.c  */
#line 3237 "parser.yy"
    {
		(yyval) = scm_car (MAKE_SYNTAX ("composed-markup-list",
					   (yylsp[(2) - (2)]), (yyvsp[(1) - (2)]), scm_list_1 ((yyvsp[(2) - (2)]))));
	}
    break;

  case 511:
/* Line 1792 of yacc.c  */
#line 3241 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 512:
/* Line 1792 of yacc.c  */
#line 3248 "parser.yy"
    {
		if (Text_interface::is_markup ((yyvsp[(1) - (1)])))
			MYBACKUP (MARKUP_IDENTIFIER, (yyvsp[(1) - (1)]), (yylsp[(1) - (1)]));
		else if (Text_interface::is_markup_list ((yyvsp[(1) - (1)])))
			MYBACKUP (MARKUPLIST_IDENTIFIER, (yyvsp[(1) - (1)]), (yylsp[(1) - (1)]));
		else {
			parser->parser_error ((yylsp[(1) - (1)]), _ ("not a markup"));
			MYBACKUP (MARKUP_IDENTIFIER, scm_string (SCM_EOL), (yylsp[(1) - (1)]));
		}
	}
    break;

  case 514:
/* Line 1792 of yacc.c  */
#line 3262 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 516:
/* Line 1792 of yacc.c  */
#line 3269 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;

  case 517:
/* Line 1792 of yacc.c  */
#line 3272 "parser.yy"
    {
		(yyval) = scm_list_1 ((yyvsp[(1) - (1)]));
	}
    break;

  case 518:
/* Line 1792 of yacc.c  */
#line 3276 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (2)]);
	}
    break;

  case 520:
/* Line 1792 of yacc.c  */
#line 3284 "parser.yy"
    {
		(yyval) = scm_list_1 (scm_list_2 (ly_lily_module_constant ("score-lines-markup-list"), (yyvsp[(1) - (1)])));
	}
    break;

  case 521:
/* Line 1792 of yacc.c  */
#line 3290 "parser.yy"
    {
		SCM nn = parser->lexer_->lookup_identifier ("pitchnames");
		parser->lexer_->push_note_state (nn);
	}
    break;

  case 522:
/* Line 1792 of yacc.c  */
#line 3293 "parser.yy"
    {
		(yyval) = (yyvsp[(4) - (5)]);
		parser->lexer_->pop_state ();
	}
    break;

  case 523:
/* Line 1792 of yacc.c  */
#line 3300 "parser.yy"
    {
		(yyval) = MAKE_SYNTAX ("composed-markup-list",
				  (yylsp[(2) - (2)]), (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]));
	}
    break;

  case 524:
/* Line 1792 of yacc.c  */
#line 3307 "parser.yy"
    {
		(yyval) = scm_reverse_x ((yyvsp[(2) - (3)]), SCM_EOL);
	}
    break;

  case 525:
/* Line 1792 of yacc.c  */
#line 3313 "parser.yy"
    {  (yyval) = SCM_EOL; }
    break;

  case 526:
/* Line 1792 of yacc.c  */
#line 3314 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(2) - (2)]), (yyvsp[(1) - (2)]));
	}
    break;

  case 527:
/* Line 1792 of yacc.c  */
#line 3317 "parser.yy"
    {
		(yyval) = scm_reverse_x ((yyvsp[(2) - (2)]), (yyvsp[(1) - (2)]));
	}
    break;

  case 528:
/* Line 1792 of yacc.c  */
#line 3323 "parser.yy"
    {
	  (yyval) = scm_cons ((yyvsp[(1) - (2)]), scm_reverse_x((yyvsp[(2) - (2)]), SCM_EOL));
	}
    break;

  case 529:
/* Line 1792 of yacc.c  */
#line 3329 "parser.yy"
    {
	  (yyval) = scm_cons ((yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 530:
/* Line 1792 of yacc.c  */
#line 3332 "parser.yy"
    {
	  (yyval) = check_scheme_arg (parser, (yylsp[(3) - (3)]), (yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]), (yyvsp[(1) - (3)]));
	}
    break;

  case 531:
/* Line 1792 of yacc.c  */
#line 3335 "parser.yy"
    {
	  (yyval) = SCM_EOL;
	}
    break;

  case 532:
/* Line 1792 of yacc.c  */
#line 3341 "parser.yy"
    { (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 533:
/* Line 1792 of yacc.c  */
#line 3342 "parser.yy"
    {
	  (yyval) = scm_cons ((yyvsp[(3) - (3)]), (yyvsp[(2) - (3)]));
	}
    break;

  case 534:
/* Line 1792 of yacc.c  */
#line 3348 "parser.yy"
    {
	  (yyval) = scm_cons ((yyvsp[(1) - (3)]), scm_reverse_x ((yyvsp[(3) - (3)]), SCM_EOL));
	}
    break;

  case 535:
/* Line 1792 of yacc.c  */
#line 3354 "parser.yy"
    {
		(yyval) = scm_list_1 ((yyvsp[(1) - (1)]));
	}
    break;

  case 536:
/* Line 1792 of yacc.c  */
#line 3357 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(2) - (2)]), (yyvsp[(1) - (2)]));
	}
    break;

  case 537:
/* Line 1792 of yacc.c  */
#line 3363 "parser.yy"
    {
		(yyval) = make_simple_markup ((yyvsp[(1) - (1)]));
	}
    break;

  case 538:
/* Line 1792 of yacc.c  */
#line 3366 "parser.yy"
    {
		(yyval) = scm_cons ((yyvsp[(1) - (2)]), scm_reverse_x ((yyvsp[(2) - (2)]), SCM_EOL));
	}
    break;

  case 539:
/* Line 1792 of yacc.c  */
#line 3370 "parser.yy"
    {
		(yyval) = (yyvsp[(2) - (2)]);
	}
    break;

  case 540:
/* Line 1792 of yacc.c  */
#line 3374 "parser.yy"
    {
		(yyval) = scm_list_2 (ly_lily_module_constant ("score-markup"), (yyvsp[(1) - (1)]));
	}
    break;

  case 541:
/* Line 1792 of yacc.c  */
#line 3381 "parser.yy"
    {
		(yyval) = scm_car (MAKE_SYNTAX ("composed-markup-list",
					   (yylsp[(2) - (2)]), (yyvsp[(1) - (2)]), scm_list_1 ((yyvsp[(2) - (2)]))));
	}
    break;

  case 542:
/* Line 1792 of yacc.c  */
#line 3385 "parser.yy"
    {
		(yyval) = (yyvsp[(1) - (1)]);
	}
    break;


/* Line 1792 of yacc.c  */
#line 7411 "out/parser.cc"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, parser, retval, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, parser, retval, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, parser, retval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, parser, retval);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, parser, retval, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, parser, retval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, parser, retval);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 3390 "parser.yy"


void
Lily_parser::set_yydebug (bool x)
{
	yydebug = x;
}

SCM
Lily_parser::do_yyparse ()
{
        SCM retval = SCM_UNDEFINED;
	yyparse (this, &retval);
        return retval;
}





/*

It is a little strange to have this function in this file, but
otherwise, we have to import music classes into the lexer.

*/
int
Lily_lexer::try_special_identifiers (SCM *destination, SCM sid)
{
	if (unsmob_book (sid)) {
		Book *book =  unsmob_book (sid)->clone ();
		*destination = book->self_scm ();
		book->unprotect ();

		return BOOK_IDENTIFIER;
	} else if (scm_is_number (sid)) {
		*destination = sid;
		return NUMBER_IDENTIFIER;
        } else if (unsmob_context_def (sid)) {
                Context_def *def= unsmob_context_def (sid)->clone ();

                *destination = def->self_scm ();
                def->unprotect ();

                return CONTEXT_DEF_IDENTIFIER;
        } else if (unsmob_context_mod (sid)) {
                *destination = unsmob_context_mod (sid)->smobbed_copy ();

                return CONTEXT_MOD_IDENTIFIER;
	} else if (Music *mus = unsmob_music (sid)) {
		mus = mus->clone ();
		*destination = mus->self_scm ();
		bool is_event = mus->is_mus_type ("post-event");
		mus->unprotect ();
		return is_event ? EVENT_IDENTIFIER : MUSIC_IDENTIFIER;
	} else if (unsmob_pitch (sid)) {
		*destination = unsmob_pitch (sid)->smobbed_copy ();
		return PITCH_IDENTIFIER;
	} else if (unsmob_duration (sid)) {
		*destination = unsmob_duration (sid)->smobbed_copy ();
		return DURATION_IDENTIFIER;
	} else if (unsmob_output_def (sid)) {
		Output_def *p = unsmob_output_def (sid);
		p = p->clone ();

		*destination = p->self_scm ();
		p->unprotect ();
		return OUTPUT_DEF_IDENTIFIER;
	}

	return -1;
}

SCM
get_next_unique_context_id ()
{
	return scm_from_locale_string ("$uniqueContextId");
}


SCM
get_next_unique_lyrics_context_id ()
{
	static int new_context_count;
	char s[128];
	snprintf (s, sizeof (s)-1, "uniqueContext%d", new_context_count++);
	return scm_from_locale_string (s);
}

// check_scheme_arg checks one argument with a given predicate for use
// in an argument list and throws a syntax error if it is unusable.
// The argument is prepended to the argument list in any case.  After
// throwing a syntax error, the argument list is terminated with #f as
// its last cdr in order to mark it as uncallable while not losing
// track of its total length.
//
// There are a few special considerations: if optional argument disp
// is given (otherwise it defaults to SCM_UNDEFINED), it will be used
// instead of arg in a prospective error message.  This is useful if
// arg is not the actual argument but rather a transformation of it.
//
// If arg itself is SCM_UNDEFINED, the predicate is considered false
// and an error message using disp is produced unconditionally.

SCM check_scheme_arg (Lily_parser *parser, Input loc,
		      SCM arg, SCM args, SCM pred, SCM disp)
{
	if (SCM_UNBNDP (arg))
		args = scm_cons (disp, args);
	else {
		args = scm_cons (arg, args);
		if (scm_is_true (scm_call_1 (pred, arg)))
			return args;
	}
	scm_set_cdr_x (scm_last_pair (args), SCM_EOL);
	MAKE_SYNTAX ("argument-error", loc, scm_length (args), pred,
		     SCM_UNBNDP (disp) ? arg : disp);
	scm_set_cdr_x (scm_last_pair (args), SCM_BOOL_F);
	return args;
}

SCM loc_on_music (Input loc, SCM arg)
{
	if (Music *m = unsmob_music (arg))
	{
		m = m->clone ();
		m->set_spot (loc);
		return m->unprotect ();
	}
	return arg;
}

SCM
try_string_variants (SCM pred, SCM str)
{
	// a matching predicate is always ok
	if (scm_is_true (scm_call_1 (pred, str)))
		return str;
	// a symbol may be interpreted as a list of symbols if it helps
	if (scm_is_symbol (str)) {
		str = scm_list_1 (str);
		if (scm_is_true (scm_call_1 (pred, str)))
			return str;
		return SCM_UNDEFINED;
	}

	// If this cannot be a string representation of a symbol list,
	// we are through.

	if (!is_regular_identifier (str, true))
		return SCM_UNDEFINED;

	str = scm_string_split (str, SCM_MAKE_CHAR ('.'));
	for (SCM p = str; scm_is_pair (p); p = scm_cdr (p))
		scm_set_car_x (p, scm_string_to_symbol (scm_car (p)));

	// Let's attempt the symbol list interpretation first.

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	// If there is just one symbol in the list, we might interpret
	// it as a single symbol

	if (scm_is_null (scm_cdr (str)))
	{
		str = scm_car (str);
		if (scm_is_true (scm_call_1 (pred, str)))
			return str;
	}

	return SCM_UNDEFINED;
}

bool
is_regular_identifier (SCM id, bool multiple)
{
  if (!scm_is_string (id))
	  return false;

  string str = ly_scm2string (id);

  bool middle = false;

  for (string::iterator it=str.begin(); it != str.end (); it++)
  {
	  int c = *it & 0xff;
	  if ((c >= 'a' && c <= 'z')
	      || (c >= 'A' && c <= 'Z')
	      || c > 0x7f)
		  middle = true;
	  else if (middle && (c == '-' || c == '_' || (multiple && c == '.')))
		  middle = false;
	  else
		  return false;
  }
  return middle;
}

SCM
make_music_from_simple (Lily_parser *parser, Input loc, SCM simple)
{
	if (unsmob_music (simple))
		return simple;
	if (parser->lexer_->is_note_state ()) {
		if (scm_is_symbol (simple)) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			n->set_property ("duration", parser->default_duration_.smobbed_copy ());
			n->set_property ("drum-type", simple);
			return n->unprotect ();
		}
		if (unsmob_pitch (simple)) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			n->set_property ("duration", parser->default_duration_.smobbed_copy ());
			n->set_property ("pitch", simple);
			return n->unprotect ();
		}
		return simple;
	} else if (parser->lexer_->is_lyric_state ()) {
		if (Text_interface::is_markup (simple))
			return MAKE_SYNTAX ("lyric-event", loc, simple,
					    parser->default_duration_.smobbed_copy ());
	} else if (parser->lexer_->is_chord_state ()) {
		if (unsmob_pitch (simple))
			return make_chord_elements (loc, simple,
						    parser->default_duration_.smobbed_copy (),
						    SCM_EOL);
	}
	return simple;
}

Music *
make_music_with_input (SCM name, Input where)
{
       Music *m = make_music_by_name (name);
       m->set_spot (where);
       return m;
}

SCM
make_simple_markup (SCM a)
{
	return a;
}

bool
is_duration (int t)
{
  return t && t == 1 << intlog2 (t);
}

SCM
make_chord_step (SCM step_scm, Rational alter)
{
        int step = scm_to_int (step_scm);

	if (step == 7)
		alter += FLAT_ALTERATION;

	while (step < 0)
		step += 7;
	Pitch m ((step -1) / 7, (step - 1) % 7, alter);
	return m.smobbed_copy ();
}


SCM
make_chord_elements (Input loc, SCM pitch, SCM dur, SCM modification_list)
{
	SCM chord_ctor = ly_lily_module_constant ("construct-chord-elements");
	SCM res = scm_call_3 (chord_ctor, pitch, dur, modification_list);
	for (SCM s = res; scm_is_pair (s); s = scm_cdr (s))
	{
		unsmob_music (scm_car (s))->set_spot (loc);
	}
	return res;
}

int
yylex (YYSTYPE *s, YYLTYPE *loc, Lily_parser *parser)
{
	Lily_lexer *lex = parser->lexer_;

	lex->lexval_ = s;
	lex->lexloc_ = loc;
	lex->prepare_for_next_token ();
	return lex->yylex ();
}
